
function scJQGeneralAdd() {
  scLoadScInput('input:text.sc-js-input');
  scLoadScInput('input:password.sc-js-input');
  scLoadScInput('input:checkbox.sc-js-input');
  scLoadScInput('input:radio.sc-js-input');
  scLoadScInput('select.sc-js-input');
  scLoadScInput('textarea.sc-js-input');

} // scJQGeneralAdd

function scFocusField(sField) {
  var $oField = $('#id_sc_field_' + sField);

  if (0 == $oField.length) {
    $oField = $('input[name=' + sField + ']');
  }

  if (0 == $oField.length && document.F1.elements[sField]) {
    $oField = $(document.F1.elements[sField]);
  }

  if ($("#id_ac_" + sField).length > 0) {
    if ($oField.hasClass("select2-hidden-accessible")) {
      if (false == scSetFocusOnField($oField)) {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
    else {
      if (false == scSetFocusOnField($oField)) {
        if (false == scSetFocusOnField($("#id_ac_" + sField))) {
          setTimeout(function() { scSetFocusOnField($("#id_ac_" + sField)); }, 500);
        }
      }
      else {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
  }
  else {
    setTimeout(function() { scSetFocusOnField($oField); }, 500);
  }
} // scFocusField

function scSetFocusOnField($oField) {
  if ($oField.length > 0 && $oField[0].offsetHeight > 0 && $oField[0].offsetWidth > 0 && !$oField[0].disabled) {
    $oField[0].focus();
    return true;
  }
  return false;
} // scSetFocusOnField

function scEventControl_init(iSeqRow) {
  scEventControl_data["api_key" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["from_email" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["from_name" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["mail_to" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["to_cc" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["to_bcc" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["msg_type" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["subject" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["msg" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["template_name" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["template_editable" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["template_injection" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
}

function scEventControl_active(iSeqRow) {
  if (scEventControl_data["api_key" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["api_key" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["from_email" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["from_email" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["from_name" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["from_name" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["mail_to" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["mail_to" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["to_cc" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["to_cc" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["to_bcc" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["to_bcc" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["msg_type" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["msg_type" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["subject" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["subject" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["msg" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["msg" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["template_name" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["template_name" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["template_editable" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["template_editable" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["template_injection" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["template_injection" + iSeqRow]["change"]) {
    return true;
  }
  return false;
} // scEventControl_active

function scEventControl_onFocus(oField, iSeq) {
  var fieldId, fieldName;
  fieldId = $(oField).attr("id");
  fieldName = fieldId.substr(12);
  scEventControl_data[fieldName]["blur"] = true;
  scEventControl_data[fieldName]["change"] = false;
} // scEventControl_onFocus

function scEventControl_onBlur(sFieldName) {
  scEventControl_data[sFieldName]["blur"] = false;
  if (scEventControl_data[sFieldName]["change"]) {
        if (scEventControl_data[sFieldName]["original"] == $("#id_sc_field_" + sFieldName).val() || scEventControl_data[sFieldName]["calculated"] == $("#id_sc_field_" + sFieldName).val()) {
          scEventControl_data[sFieldName]["change"] = false;
        }
  }
} // scEventControl_onBlur

function scEventControl_onChange(sFieldName) {
  scEventControl_data[sFieldName]["change"] = false;
} // scEventControl_onChange

function scEventControl_onAutocomp(sFieldName) {
  scEventControl_data[sFieldName]["autocomp"] = false;
} // scEventControl_onChange

var scEventControl_data = {};

function scJQEventsAdd(iSeqRow) {
  $('#id_sc_field_mail_to' + iSeqRow).bind('blur', function() { sc_control_api_call_mail_to_onblur(this, iSeqRow) })
                                     .bind('change', function() { sc_control_api_call_mail_to_onchange(this, iSeqRow) })
                                     .bind('focus', function() { sc_control_api_call_mail_to_onfocus(this, iSeqRow) });
  $('#id_sc_field_msg' + iSeqRow).bind('blur', function() { sc_control_api_call_msg_onblur(this, iSeqRow) })
                                 .bind('change', function() { sc_control_api_call_msg_onchange(this, iSeqRow) })
                                 .bind('focus', function() { sc_control_api_call_msg_onfocus(this, iSeqRow) });
  $('#id_sc_field_api_key' + iSeqRow).bind('blur', function() { sc_control_api_call_api_key_onblur(this, iSeqRow) })
                                     .bind('change', function() { sc_control_api_call_api_key_onchange(this, iSeqRow) })
                                     .bind('focus', function() { sc_control_api_call_api_key_onfocus(this, iSeqRow) });
  $('#id_sc_field_from_email' + iSeqRow).bind('blur', function() { sc_control_api_call_from_email_onblur(this, iSeqRow) })
                                        .bind('change', function() { sc_control_api_call_from_email_onchange(this, iSeqRow) })
                                        .bind('focus', function() { sc_control_api_call_from_email_onfocus(this, iSeqRow) });
  $('#id_sc_field_from_name' + iSeqRow).bind('blur', function() { sc_control_api_call_from_name_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_control_api_call_from_name_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_control_api_call_from_name_onfocus(this, iSeqRow) });
  $('#id_sc_field_subject' + iSeqRow).bind('blur', function() { sc_control_api_call_subject_onblur(this, iSeqRow) })
                                     .bind('change', function() { sc_control_api_call_subject_onchange(this, iSeqRow) })
                                     .bind('focus', function() { sc_control_api_call_subject_onfocus(this, iSeqRow) });
  $('#id_sc_field_to_cc' + iSeqRow).bind('blur', function() { sc_control_api_call_to_cc_onblur(this, iSeqRow) })
                                   .bind('change', function() { sc_control_api_call_to_cc_onchange(this, iSeqRow) })
                                   .bind('focus', function() { sc_control_api_call_to_cc_onfocus(this, iSeqRow) });
  $('#id_sc_field_to_bcc' + iSeqRow).bind('blur', function() { sc_control_api_call_to_bcc_onblur(this, iSeqRow) })
                                    .bind('change', function() { sc_control_api_call_to_bcc_onchange(this, iSeqRow) })
                                    .bind('focus', function() { sc_control_api_call_to_bcc_onfocus(this, iSeqRow) });
  $('#id_sc_field_msg_type' + iSeqRow).bind('blur', function() { sc_control_api_call_msg_type_onblur(this, iSeqRow) })
                                      .bind('change', function() { sc_control_api_call_msg_type_onchange(this, iSeqRow) })
                                      .bind('click', function() { sc_control_api_call_msg_type_onclick(this, iSeqRow) })
                                      .bind('focus', function() { sc_control_api_call_msg_type_onfocus(this, iSeqRow) });
  $('#id_sc_field_template_name' + iSeqRow).bind('blur', function() { sc_control_api_call_template_name_onblur(this, iSeqRow) })
                                           .bind('change', function() { sc_control_api_call_template_name_onchange(this, iSeqRow) })
                                           .bind('focus', function() { sc_control_api_call_template_name_onfocus(this, iSeqRow) });
  $('#id_sc_field_template_editable' + iSeqRow).bind('blur', function() { sc_control_api_call_template_editable_onblur(this, iSeqRow) })
                                               .bind('change', function() { sc_control_api_call_template_editable_onchange(this, iSeqRow) })
                                               .bind('focus', function() { sc_control_api_call_template_editable_onfocus(this, iSeqRow) });
  $('#id_sc_field_template_injection' + iSeqRow).bind('blur', function() { sc_control_api_call_template_injection_onblur(this, iSeqRow) })
                                                .bind('change', function() { sc_control_api_call_template_injection_onchange(this, iSeqRow) })
                                                .bind('focus', function() { sc_control_api_call_template_injection_onfocus(this, iSeqRow) });
  $('.sc-ui-radio-msg_type' + iSeqRow).on('click', function() { scMarkFormAsChanged(); });
} // scJQEventsAdd

function sc_control_api_call_mail_to_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_mail_to();
  scCssBlur(oThis);
}

function sc_control_api_call_mail_to_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_mail_to_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_msg_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_msg();
  scCssBlur(oThis);
}

function sc_control_api_call_msg_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_msg_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_api_key_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_api_key();
  scCssBlur(oThis);
}

function sc_control_api_call_api_key_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_api_key_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_from_email_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_from_email();
  scCssBlur(oThis);
}

function sc_control_api_call_from_email_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_from_email_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_from_name_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_from_name();
  scCssBlur(oThis);
}

function sc_control_api_call_from_name_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_from_name_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_subject_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_subject();
  scCssBlur(oThis);
}

function sc_control_api_call_subject_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_subject_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_to_cc_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_to_cc();
  scCssBlur(oThis);
}

function sc_control_api_call_to_cc_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_to_cc_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_to_bcc_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_to_bcc();
  scCssBlur(oThis);
}

function sc_control_api_call_to_bcc_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_to_bcc_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_msg_type_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_msg_type();
  scCssBlur(oThis);
}

function sc_control_api_call_msg_type_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_msg_type_onclick(oThis, iSeqRow) {
  do_ajax_control_api_call_event_msg_type_onclick();
}

function sc_control_api_call_msg_type_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_template_name_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_template_name();
  scCssBlur(oThis);
}

function sc_control_api_call_template_name_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_template_name_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_template_editable_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_template_editable();
  scCssBlur(oThis);
}

function sc_control_api_call_template_editable_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_template_editable_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_api_call_template_injection_onblur(oThis, iSeqRow) {
  do_ajax_control_api_call_validate_template_injection();
  scCssBlur(oThis);
}

function sc_control_api_call_template_injection_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_api_call_template_injection_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function displayChange_block(block, status) {
	if ("0" == block) {
		displayChange_block_0(status);
	}
	if ("1" == block) {
		displayChange_block_1(status);
	}
}

function displayChange_block_0(status) {
	displayChange_field("api_key", "", status);
	displayChange_field("from_email", "", status);
	displayChange_field("from_name", "", status);
	displayChange_field("mail_to", "", status);
	displayChange_field("to_cc", "", status);
	displayChange_field("to_bcc", "", status);
}

function displayChange_block_1(status) {
	displayChange_field("msg_type", "", status);
	displayChange_field("subject", "", status);
	displayChange_field("msg", "", status);
	displayChange_field("template_name", "", status);
	displayChange_field("template_editable", "", status);
	displayChange_field("template_injection", "", status);
}

function displayChange_row(row, status) {
	displayChange_field_api_key(row, status);
	displayChange_field_from_email(row, status);
	displayChange_field_from_name(row, status);
	displayChange_field_mail_to(row, status);
	displayChange_field_to_cc(row, status);
	displayChange_field_to_bcc(row, status);
	displayChange_field_msg_type(row, status);
	displayChange_field_subject(row, status);
	displayChange_field_msg(row, status);
	displayChange_field_template_name(row, status);
	displayChange_field_template_editable(row, status);
	displayChange_field_template_injection(row, status);
}

function displayChange_field(field, row, status) {
	if ("api_key" == field) {
		displayChange_field_api_key(row, status);
	}
	if ("from_email" == field) {
		displayChange_field_from_email(row, status);
	}
	if ("from_name" == field) {
		displayChange_field_from_name(row, status);
	}
	if ("mail_to" == field) {
		displayChange_field_mail_to(row, status);
	}
	if ("to_cc" == field) {
		displayChange_field_to_cc(row, status);
	}
	if ("to_bcc" == field) {
		displayChange_field_to_bcc(row, status);
	}
	if ("msg_type" == field) {
		displayChange_field_msg_type(row, status);
	}
	if ("subject" == field) {
		displayChange_field_subject(row, status);
	}
	if ("msg" == field) {
		displayChange_field_msg(row, status);
	}
	if ("template_name" == field) {
		displayChange_field_template_name(row, status);
	}
	if ("template_editable" == field) {
		displayChange_field_template_editable(row, status);
	}
	if ("template_injection" == field) {
		displayChange_field_template_injection(row, status);
	}
}

function displayChange_field_api_key(row, status) {
}

function displayChange_field_from_email(row, status) {
}

function displayChange_field_from_name(row, status) {
}

function displayChange_field_mail_to(row, status) {
}

function displayChange_field_to_cc(row, status) {
}

function displayChange_field_to_bcc(row, status) {
}

function displayChange_field_msg_type(row, status) {
}

function displayChange_field_subject(row, status) {
}

function displayChange_field_msg(row, status) {
}

function displayChange_field_template_name(row, status) {
}

function displayChange_field_template_editable(row, status) {
}

function displayChange_field_template_injection(row, status) {
}

function scRecreateSelect2() {
}
function scResetPagesDisplay() {
	$(".sc-form-page").show();
}

function scHidePage(pageNo) {
	$("#id_control_api_call_form" + pageNo).hide();
}

function scCheckNoPageSelected() {
	if (!$(".sc-form-page").filter(".scTabActive").filter(":visible").length) {
		var inactiveTabs = $(".sc-form-page").filter(".scTabInactive").filter(":visible");
		if (inactiveTabs.length) {
			var tabNo = $(inactiveTabs[0]).attr("id").substr(24);
		}
	}
}
function scJQPopupAdd(iSeqRow) {
  $('.scFormPopupBubble' + iSeqRow).each(function() {
    var distance = 10;
    var time = 250;
    var hideDelay = 500;
    var hideDelayTimer = null;
    var beingShown = false;
    var shown = false;
    var trigger = $('.scFormPopupTrigger', this);
    var info = $('.scFormPopup', this).css('opacity', 0);
    $([trigger.get(0), info.get(0)]).mouseover(function() {
      if (hideDelayTimer) clearTimeout(hideDelayTimer);
      if (beingShown || shown) {
        // don't trigger the animation again
        return;
      } else {
        // reset position of info box
        beingShown = true;
        info.css({
          top: trigger.offset().top - (info.height() - trigger.height()),
          left: trigger.offset().left - ((info.width() - trigger.width()) / 2),
          display: 'block'
        }).animate({
          top: '-=' + distance + 'px',
          opacity: 1
        }, time, 'swing', function() {
          beingShown = false;
          shown = true;
        });
      }
      return false;
      }).mouseout(function() {
      if (hideDelayTimer) clearTimeout(hideDelayTimer);
      hideDelayTimer = setTimeout(function() {
        hideDelayTimer = null;
        info.animate({
          top: '-=' + distance + 'px',
          opacity: 0
        }, time, 'swing', function() {
          shown = false;
          info.css('display', 'none');
        });
      }, hideDelay);
      return false;
    });
  });
} // scJQPopupAdd

                var scJQHtmlEditorData = (function() {
                    var data = {};
                    function scJQHtmlEditorData(a, b) {
                        if (a) {
                            if (typeof(a) === typeof({})) {
                                for (var d in a) {
                                    if (a.hasOwnProperty(d)) {
                                        data[d] = a[d];
                                    }
                                }
                            } else if ((typeof(a) === typeof('')) || (typeof(a) === typeof(1))) {
                                if (b) {
                                    data[a] = b;
                                } else {
                                    if (typeof(a) === typeof('')) {
                                        var v = data;
                                        a = a.split('.');
                                        a.forEach(function (r) {
                                            v = v[r];
                                        });
                                        return v;
                                    }
                                    return data[a];
                                }
                            }
                        }
                        return data;
                    }
                    return scJQHtmlEditorData;
                }());
 function scJQHtmlEditorAdd(iSeqRow) {
<?php
$sLangTest = '';
if(is_file('../_lib/lang/arr_langs_tinymce.php'))
{
    include('../_lib/lang/arr_langs_tinymce.php');
    if(isset($Nm_arr_lang_tinymce[ $this->Ini->str_lang ]))
    {
        $sLangTest = $Nm_arr_lang_tinymce[ $this->Ini->str_lang ];
    }
}
if(empty($sLangTest))
{
    $sLangTest = 'en_GB';
}
?>
 var baseData = {
  mode: "textareas",
  theme: "modern",
  browser_spellcheck : true,
  paste_data_images : true,
<?php
if ('novo' != $this->nmgp_opcao && isset($this->nmgp_cmp_readonly['msg']) && $this->nmgp_cmp_readonly['msg'] == 'on')
{
    unset($this->nmgp_cmp_readonly['msg']);
?>
   readonly: "true",
<?php
}
else 
{
?>
   readonly: "",
<?php
}
?>
<?php
if ('yyyymmdd' == $_SESSION['scriptcase']['reg_conf']['date_format']) {
    $tinymceDateFormat = "%Y{$_SESSION['scriptcase']['reg_conf']['date_sep']}%m{$_SESSION['scriptcase']['reg_conf']['date_sep']}%d";
}
elseif ('mmddyyyy' == $_SESSION['scriptcase']['reg_conf']['date_format']) {
    $tinymceDateFormat = "%m{$_SESSION['scriptcase']['reg_conf']['date_sep']}%d{$_SESSION['scriptcase']['reg_conf']['date_sep']}%Y";
}
elseif ('ddmmyyyy' == $_SESSION['scriptcase']['reg_conf']['date_format']) {
    $tinymceDateFormat = "%d{$_SESSION['scriptcase']['reg_conf']['date_sep']}%m{$_SESSION['scriptcase']['reg_conf']['date_sep']}%Y";
}
else {
    $tinymceDateFormat = "%D";
}
?>
  insertdatetime_formats: ["%H:%M:%S", "%Y-%m-%d", "%I:%M:%S %p", "<?php echo $tinymceDateFormat ?>"],
  relative_urls : false,
  remove_script_host : false,
  convert_urls  : true,
  language : '<?php echo $sLangTest; ?>',
  plugins : 'advlist,autolink,link,image,lists,charmap,print,preview,hr,anchor,pagebreak,searchreplace,wordcount,visualblocks,visualchars,code,fullscreen,insertdatetime,media,nonbreaking,table,directionality,emoticons,template,textcolor,paste,textcolor,colorpicker,textpattern',
  toolbar1: "undo,redo,separator,styleselect,separator,bold,italic,separator,alignleft,aligncenter,alignright,alignjustify,separator,bullist,numlist,outdent,indent,separator,link,image",
  statusbar : false,
  menubar : 'file edit insert view format table tools',
  toolbar_items_size: 'small',
  content_style: ".mce-container-body {text-align: center !important}",
  editor_selector: "mceEditor_msg" + iSeqRow,
  setup: function(ed) {
    ed.on("init", function (e) {
      if ($('textarea[name="msg' + iSeqRow + '"]').prop('disabled') == true) {
        ed.setMode("readonly");
      }
    });
  }
 };
 var data = 'function' === typeof Object.assign ? Object.assign({}, scJQHtmlEditorData(baseData)) : baseData;
 tinyMCE.init(data);
} // scJQHtmlEditorAdd

function scJQUploadAdd(iSeqRow) {
} // scJQUploadAdd

var api_cache_requests = [];
function ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, hasRun, img_before){
    setTimeout(function(){
        if(img_name == '') return;
        iSeqRow= iSeqRow !== undefined && iSeqRow !== null ? iSeqRow : '';
        var hasVar = p.indexOf('_@NM@_') > -1 || p_cache.indexOf('_@NM@_') > -1 ? true : false;

        p = p.split('_@NM@_');
        $.each(p, function(i,v){
            try{
                p[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p[i] = v;
            }
        });
        p = p.join('');

        p_cache = p_cache.split('_@NM@_');
        $.each(p_cache, function(i,v){
            try{
                p_cache[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p_cache[i] = v;
            }
        });
        p_cache = p_cache.join('');

        img_before = img_before !== undefined ? img_before : $(t).attr('src');
        var str_key_cache = '<?php echo $this->Ini->sc_page; ?>' + img_name+field+p+p_cache;
        if(api_cache_requests[ str_key_cache ] !== undefined && api_cache_requests[ str_key_cache ] !== null){
            if(api_cache_requests[ str_key_cache ] != false){
                do_ajax_check_file(api_cache_requests[ str_key_cache ], field  ,t, iSeqRow);
            }
            return;
        }
        //scAjaxProcOn();
        $(t).attr('src', '<?php echo $this->Ini->path_icones ?>/scriptcase__NM__ajax_load.gif');
        api_cache_requests[ str_key_cache ] = false;
        var rs =$.ajax({
                    type: "POST",
                    url: 'index.php?script_case_init=<?php echo $this->Ini->sc_page; ?>',
                    async: true,
                    data:'nmgp_opcao=ajax_check_file&AjaxCheckImg=' + encodeURI(img_name) +'&rsargs='+ field + '&p=' + p + '&p_cache=' + p_cache,
                    success: function (rs) {
                        if(rs.indexOf('</span>') != -1){
                            rs = rs.substr(rs.indexOf('</span>') + 7);
                        }
                        if(rs.indexOf('/') != -1 && rs.indexOf('/') != 0){
                            rs = rs.substr(rs.indexOf('/'));
                        }
                        rs = sc_trim(rs);

                        // if(rs == 0 && hasVar && hasRun === undefined){
                        //     delete window.api_cache_requests[ str_key_cache ];
                        //     ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, 1, img_before);
                        //     return;
                        // }
                        window.api_cache_requests[ str_key_cache ] = rs;
                        do_ajax_check_file(rs, field  ,t, iSeqRow)
                        if(rs == 0){
                            delete window.api_cache_requests[ str_key_cache ];

                           // $(t).attr('src',img_before);
                            do_ajax_check_file(img_before+'_@@NM@@_' + img_before, field  ,t, iSeqRow)

                        }


                    }
        });
    },100);
}

function do_ajax_check_file(rs, field  ,t, iSeqRow){
    if (rs != 0) {
        rs_split = rs.split('_@@NM@@_');
        rs_orig = rs_split[0];
        rs2 = rs_split[1];
        try{
            if(!$(t).is('img')){

                if($('#id_read_on_'+field+iSeqRow).length > 0 ){
                                    var usa_read_only = false;

                switch(field){

                }
                     if(usa_read_only && $('a',$('#id_read_on_'+field+iSeqRow)).length == 0){
                         $(t).html("<a href=\"javascript:nm_mostra_doc('0', '"+rs2+"', 'control_api_call')\">"+$('#id_read_on_'+field+iSeqRow).text()+"</a>");
                     }
                }
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href', target.join(','));
                }else{
                    var target = $(t).attr('href').split(',');
                     target[1] = "'"+rs2+"'";
                     $(t).attr('href', target.join(','));
                }
            }else{
                $(t).attr('src', rs2);
                $(t).css('display', '');
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $(t).attr('href', target.join(','));
                }else{
                     var t_link = $(t).parent('a');
                     var target = $(t_link).attr('href').split(',');
                     target[0] = "javascript:nm_mostra_img('"+rs_orig+"'";
                     $(t_link).attr('href', target.join(','));
                }

            }
            eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        } catch(err){
                        eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        }
    }
   /* hasFalseCacheRequest = false;
    $.each(api_cache_requests, function(i,v){
        if(v == false){
            hasFalseCacheRequest = true;
        }
    });
    if(hasFalseCacheRequest == false){
        scAjaxProcOff();
    }*/
}

$(document).ready(function(){
});
function scJQElementsAdd(iLine) {
  scJQEventsAdd(iLine);
  scEventControl_init(iLine);
  scJQPopupAdd(iLine);
  scJQHtmlEditorAdd(iLine);
  scJQUploadAdd(iLine);
} // scJQElementsAdd

function scGetFileExtension(fileName)
{
    fileNameParts = fileName.split(".");

    if (1 === fileNameParts.length || (2 === fileNameParts.length && "" == fileNameParts[0])) {
        return "";
    }

    return fileNameParts.pop().toLowerCase();
}

function scFormatExtensionSizeErrorMsg(errorMsg)
{
    var msgInfo = errorMsg.split("||"), returnMsg = "";

    if ("err_size" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_size'] ?>. <?php echo $this->Ini->Nm_lang['lang_errm_file_size_extension'] ?>".replace("{SC_EXTENSION}", msgInfo[1]).replace("{SC_LIMIT}", msgInfo[2]);
    } else if ("err_extension" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_invl'] ?>";
    }

    return returnMsg;
}

