
function scJQGeneralAdd() {
  scLoadScInput('input:text.sc-js-input');
  scLoadScInput('input:password.sc-js-input');
  scLoadScInput('input:checkbox.sc-js-input');
  scLoadScInput('input:radio.sc-js-input');
  scLoadScInput('select.sc-js-input');
  scLoadScInput('textarea.sc-js-input');

} // scJQGeneralAdd

function scFocusField(sField) {
  var $oField = $('#id_sc_field_' + sField);

  if (0 == $oField.length) {
    $oField = $('input[name=' + sField + ']');
  }

  if (0 == $oField.length && document.F1.elements[sField]) {
    $oField = $(document.F1.elements[sField]);
  }

  if ($("#id_ac_" + sField).length > 0) {
    if ($oField.hasClass("select2-hidden-accessible")) {
      if (false == scSetFocusOnField($oField)) {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
    else {
      if (false == scSetFocusOnField($oField)) {
        if (false == scSetFocusOnField($("#id_ac_" + sField))) {
          setTimeout(function() { scSetFocusOnField($("#id_ac_" + sField)); }, 500);
        }
      }
      else {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
  }
  else {
    setTimeout(function() { scSetFocusOnField($oField); }, 500);
  }
} // scFocusField

function scSetFocusOnField($oField) {
  if ($oField.length > 0 && $oField[0].offsetHeight > 0 && $oField[0].offsetWidth > 0 && !$oField[0].disabled) {
    $oField[0].focus();
    return true;
  }
  return false;
} // scSetFocusOnField

function scEventControl_init(iSeqRow) {
  scEventControl_data["signature" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["rating" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["select" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["select2" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["auto_complete" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["auto_complete_s2" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["radio" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["new_radio" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["checkbox" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["switch" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["slider" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
}

function scEventControl_active(iSeqRow) {
  if (scEventControl_data["signature" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["signature" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["rating" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["rating" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["select" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["select" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["select2" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["select2" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["auto_complete" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["auto_complete" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["auto_complete_s2" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["auto_complete_s2" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["radio" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["radio" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["new_radio" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["new_radio" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["checkbox" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["checkbox" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["switch" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["switch" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["slider" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["slider" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["auto_complete" + iSeqRow]["autocomp"]) {
    return true;
  }
  if (scEventControl_data["auto_complete_s2" + iSeqRow]["autocomp"]) {
    return true;
  }
  return false;
} // scEventControl_active

function scEventControl_onFocus(oField, iSeq) {
  var fieldId, fieldName;
  fieldId = $(oField).attr("id");
  fieldName = fieldId.substr(12);
  scEventControl_data[fieldName]["blur"] = true;
  if ("select" + iSeq == fieldName) {
    scEventControl_data[fieldName]["blur"] = false;
  }
  if ("select2" + iSeq == fieldName) {
    scEventControl_data[fieldName]["blur"] = false;
  }
  scEventControl_data[fieldName]["change"] = false;
} // scEventControl_onFocus

function scEventControl_onBlur(sFieldName) {
  scEventControl_data[sFieldName]["blur"] = false;
  if (scEventControl_data[sFieldName]["change"]) {
        if (scEventControl_data[sFieldName]["original"] == $("#id_sc_field_" + sFieldName).val() || scEventControl_data[sFieldName]["calculated"] == $("#id_sc_field_" + sFieldName).val()) {
          scEventControl_data[sFieldName]["change"] = false;
        }
  }
} // scEventControl_onBlur

function scEventControl_onChange(sFieldName) {
  scEventControl_data[sFieldName]["change"] = false;
} // scEventControl_onChange

function scEventControl_onAutocomp(sFieldName) {
  scEventControl_data[sFieldName]["autocomp"] = false;
} // scEventControl_onChange

var scEventControl_data = {};

function scJQEventsAdd(iSeqRow) {
  $('#id_sc_field_signature' + iSeqRow).bind('blur', function() { sc_new_fields_signature_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_new_fields_signature_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_new_fields_signature_onfocus(this, iSeqRow) });
  $('#id_sc_field_rating' + iSeqRow).bind('blur', function() { sc_new_fields_rating_onblur(this, iSeqRow) })
                                    .bind('change', function() { sc_new_fields_rating_onchange(this, iSeqRow) })
                                    .bind('focus', function() { sc_new_fields_rating_onfocus(this, iSeqRow) });
  $('#id_sc_field_select' + iSeqRow).bind('blur', function() { sc_new_fields_select_onblur(this, iSeqRow) })
                                    .bind('change', function() { sc_new_fields_select_onchange(this, iSeqRow) })
                                    .bind('focus', function() { sc_new_fields_select_onfocus(this, iSeqRow) });
  $('#id_sc_field_select2' + iSeqRow).bind('blur', function() { sc_new_fields_select2_onblur(this, iSeqRow) })
                                     .bind('change', function() { sc_new_fields_select2_onchange(this, iSeqRow) })
                                     .bind('focus', function() { sc_new_fields_select2_onfocus(this, iSeqRow) });
  $('#id_sc_field_auto_complete' + iSeqRow).bind('blur', function() { sc_new_fields_auto_complete_onblur(this, iSeqRow) })
                                           .bind('change', function() { sc_new_fields_auto_complete_onchange(this, iSeqRow) })
                                           .bind('focus', function() { sc_new_fields_auto_complete_onfocus(this, iSeqRow) });
  $('#id_sc_field_auto_complete_s2' + iSeqRow).bind('blur', function() { sc_new_fields_auto_complete_s2_onblur(this, iSeqRow) })
                                              .bind('change', function() { sc_new_fields_auto_complete_s2_onchange(this, iSeqRow) })
                                              .bind('focus', function() { sc_new_fields_auto_complete_s2_onfocus(this, iSeqRow) });
  $('#id_sc_field_slider' + iSeqRow).bind('blur', function() { sc_new_fields_slider_onblur(this, iSeqRow) })
                                    .bind('change', function() { sc_new_fields_slider_onchange(this, iSeqRow) })
                                    .bind('focus', function() { sc_new_fields_slider_onfocus(this, iSeqRow) });
  $('#id_sc_field_radio' + iSeqRow).bind('blur', function() { sc_new_fields_radio_onblur(this, iSeqRow) })
                                   .bind('change', function() { sc_new_fields_radio_onchange(this, iSeqRow) })
                                   .bind('focus', function() { sc_new_fields_radio_onfocus(this, iSeqRow) });
  $('#id_sc_field_new_radio' + iSeqRow).bind('blur', function() { sc_new_fields_new_radio_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_new_fields_new_radio_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_new_fields_new_radio_onfocus(this, iSeqRow) });
  $('#id_sc_field_checkbox' + iSeqRow).bind('blur', function() { sc_new_fields_checkbox_onblur(this, iSeqRow) })
                                      .bind('change', function() { sc_new_fields_checkbox_onchange(this, iSeqRow) })
                                      .bind('focus', function() { sc_new_fields_checkbox_onfocus(this, iSeqRow) });
  $('#id_sc_field_switch' + iSeqRow).bind('blur', function() { sc_new_fields_switch_onblur(this, iSeqRow) })
                                    .bind('change', function() { sc_new_fields_switch_onchange(this, iSeqRow) })
                                    .bind('focus', function() { sc_new_fields_switch_onfocus(this, iSeqRow) });
  $('.sc-ui-radio-radio' + iSeqRow).on('click', function() { scMarkFormAsChanged(); });
  $('.sc-ui-radio-new_radio' + iSeqRow).on('click', function() { scMarkFormAsChanged(); });
  $('.sc-ui-checkbox-checkbox' + iSeqRow).on('click', function() { scMarkFormAsChanged(); });
  $('.sc-ui-checkbox-switch' + iSeqRow).on('click', function() { scMarkFormAsChanged(); });
} // scJQEventsAdd

function sc_new_fields_signature_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_signature();
  scCssBlur(oThis);
}

function sc_new_fields_signature_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_signature_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_new_fields_rating_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_rating();
  scCssBlur(oThis);
}

function sc_new_fields_rating_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_rating_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_new_fields_select_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_select();
  scCssBlur(oThis);
}

function sc_new_fields_select_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_select_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_new_fields_select2_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_select2();
  scCssBlur(oThis);
}

function sc_new_fields_select2_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_select2_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_new_fields_auto_complete_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_auto_complete();
  scCssBlur(oThis);
}

function sc_new_fields_auto_complete_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_auto_complete_onfocus(oThis, iSeqRow) {
  scCssFocus(oThis);
}

function sc_new_fields_auto_complete_s2_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_auto_complete_s2();
  scCssBlur(oThis);
}

function sc_new_fields_auto_complete_s2_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_auto_complete_s2_onfocus(oThis, iSeqRow) {
  scCssFocus(oThis);
}

function sc_new_fields_slider_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_slider();
  scCssBlur(oThis);
}

function sc_new_fields_slider_onchange(oThis, iSeqRow) {
  scJQSlideValue("slider" + iSeqRow, iSeqRow);
  scMarkFormAsChanged();
}

function sc_new_fields_slider_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_new_fields_radio_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_radio();
  scCssBlur(oThis);
}

function sc_new_fields_radio_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_radio_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_new_fields_new_radio_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_new_radio();
  scCssBlur(oThis);
}

function sc_new_fields_new_radio_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_new_radio_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_new_fields_checkbox_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_checkbox();
  scCssBlur(oThis);
}

function sc_new_fields_checkbox_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_checkbox_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_new_fields_switch_onblur(oThis, iSeqRow) {
  do_ajax_new_fields_validate_switch();
  scCssBlur(oThis);
}

function sc_new_fields_switch_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_new_fields_switch_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function displayChange_block(block, status) {
	if ("0" == block) {
		displayChange_block_0(status);
	}
	if ("1" == block) {
		displayChange_block_1(status);
	}
	if ("2" == block) {
		displayChange_block_2(status);
	}
}

function displayChange_block_0(status) {
	displayChange_field("signature", "", status);
	displayChange_field("rating", "", status);
}

function displayChange_block_1(status) {
	displayChange_field("select", "", status);
	displayChange_field("select2", "", status);
	displayChange_field("auto_complete", "", status);
	displayChange_field("auto_complete_s2", "", status);
}

function displayChange_block_2(status) {
	displayChange_field("radio", "", status);
	displayChange_field("new_radio", "", status);
	displayChange_field("checkbox", "", status);
	displayChange_field("switch", "", status);
	displayChange_field("slider", "", status);
}

function displayChange_row(row, status) {
	displayChange_field_signature(row, status);
	displayChange_field_rating(row, status);
	displayChange_field_select(row, status);
	displayChange_field_select2(row, status);
	displayChange_field_auto_complete(row, status);
	displayChange_field_auto_complete_s2(row, status);
	displayChange_field_radio(row, status);
	displayChange_field_new_radio(row, status);
	displayChange_field_checkbox(row, status);
	displayChange_field_switch(row, status);
	displayChange_field_slider(row, status);
}

function displayChange_field(field, row, status) {
	if ("signature" == field) {
		displayChange_field_signature(row, status);
	}
	if ("rating" == field) {
		displayChange_field_rating(row, status);
	}
	if ("select" == field) {
		displayChange_field_select(row, status);
	}
	if ("select2" == field) {
		displayChange_field_select2(row, status);
	}
	if ("auto_complete" == field) {
		displayChange_field_auto_complete(row, status);
	}
	if ("auto_complete_s2" == field) {
		displayChange_field_auto_complete_s2(row, status);
	}
	if ("radio" == field) {
		displayChange_field_radio(row, status);
	}
	if ("new_radio" == field) {
		displayChange_field_new_radio(row, status);
	}
	if ("checkbox" == field) {
		displayChange_field_checkbox(row, status);
	}
	if ("switch" == field) {
		displayChange_field_switch(row, status);
	}
	if ("slider" == field) {
		displayChange_field_slider(row, status);
	}
}

function displayChange_field_signature(row, status) {
}

function displayChange_field_rating(row, status) {
}

function displayChange_field_select(row, status) {
}

function displayChange_field_select2(row, status) {
	if ("on" == status) {
		if ("all" == row) {
			var fieldList = $(".css_select2__obj");
			for (var i = 0; i < fieldList.length; i++) {
				$($(fieldList[i]).attr("id")).select2("destroy");
			}
		}
		else {
			$("#id_sc_field_select2" + row).select2("destroy");
		}
		scJQSelect2Add(row, "select2");
	}
}

function displayChange_field_auto_complete(row, status) {
}

function displayChange_field_auto_complete_s2(row, status) {
}

function displayChange_field_radio(row, status) {
}

function displayChange_field_new_radio(row, status) {
}

function displayChange_field_checkbox(row, status) {
}

function displayChange_field_switch(row, status) {
}

function displayChange_field_slider(row, status) {
}

function scRecreateSelect2() {
	displayChange_field_select2("all", "on");
}
function scResetPagesDisplay() {
	$(".sc-form-page").show();
}

function scHidePage(pageNo) {
	$("#id_new_fields_form" + pageNo).hide();
}

function scCheckNoPageSelected() {
	if (!$(".sc-form-page").filter(".scTabActive").filter(":visible").length) {
		var inactiveTabs = $(".sc-form-page").filter(".scTabInactive").filter(":visible");
		if (inactiveTabs.length) {
			var tabNo = $(inactiveTabs[0]).attr("id").substr(18);
		}
	}
}
function scJQUploadAdd(iSeqRow) {
} // scJQUploadAdd

var api_cache_requests = [];
function ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, hasRun, img_before){
    setTimeout(function(){
        if(img_name == '') return;
        iSeqRow= iSeqRow !== undefined && iSeqRow !== null ? iSeqRow : '';
        var hasVar = p.indexOf('_@NM@_') > -1 || p_cache.indexOf('_@NM@_') > -1 ? true : false;

        p = p.split('_@NM@_');
        $.each(p, function(i,v){
            try{
                p[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p[i] = v;
            }
        });
        p = p.join('');

        p_cache = p_cache.split('_@NM@_');
        $.each(p_cache, function(i,v){
            try{
                p_cache[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p_cache[i] = v;
            }
        });
        p_cache = p_cache.join('');

        img_before = img_before !== undefined ? img_before : $(t).attr('src');
        var str_key_cache = '<?php echo $this->Ini->sc_page; ?>' + img_name+field+p+p_cache;
        if(api_cache_requests[ str_key_cache ] !== undefined && api_cache_requests[ str_key_cache ] !== null){
            if(api_cache_requests[ str_key_cache ] != false){
                do_ajax_check_file(api_cache_requests[ str_key_cache ], field  ,t, iSeqRow);
            }
            return;
        }
        //scAjaxProcOn();
        $(t).attr('src', '<?php echo $this->Ini->path_icones ?>/scriptcase__NM__ajax_load.gif');
        api_cache_requests[ str_key_cache ] = false;
        var rs =$.ajax({
                    type: "POST",
                    url: 'index.php?script_case_init=<?php echo $this->Ini->sc_page; ?>',
                    async: true,
                    data:'nmgp_opcao=ajax_check_file&AjaxCheckImg=' + encodeURI(img_name) +'&rsargs='+ field + '&p=' + p + '&p_cache=' + p_cache,
                    success: function (rs) {
                        if(rs.indexOf('</span>') != -1){
                            rs = rs.substr(rs.indexOf('</span>') + 7);
                        }
                        if(rs.indexOf('/') != -1 && rs.indexOf('/') != 0){
                            rs = rs.substr(rs.indexOf('/'));
                        }
                        rs = sc_trim(rs);

                        // if(rs == 0 && hasVar && hasRun === undefined){
                        //     delete window.api_cache_requests[ str_key_cache ];
                        //     ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, 1, img_before);
                        //     return;
                        // }
                        window.api_cache_requests[ str_key_cache ] = rs;
                        do_ajax_check_file(rs, field  ,t, iSeqRow)
                        if(rs == 0){
                            delete window.api_cache_requests[ str_key_cache ];

                           // $(t).attr('src',img_before);
                            do_ajax_check_file(img_before+'_@@NM@@_' + img_before, field  ,t, iSeqRow)

                        }


                    }
        });
    },100);
}

function do_ajax_check_file(rs, field  ,t, iSeqRow){
    if (rs != 0) {
        rs_split = rs.split('_@@NM@@_');
        rs_orig = rs_split[0];
        rs2 = rs_split[1];
        try{
            if(!$(t).is('img')){

                if($('#id_read_on_'+field+iSeqRow).length > 0 ){
                                    var usa_read_only = false;

                switch(field){

                }
                     if(usa_read_only && $('a',$('#id_read_on_'+field+iSeqRow)).length == 0){
                         $(t).html("<a href=\"javascript:nm_mostra_doc('0', '"+rs2+"', 'new_fields')\">"+$('#id_read_on_'+field+iSeqRow).text()+"</a>");
                     }
                }
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href', target.join(','));
                }else{
                    var target = $(t).attr('href').split(',');
                     target[1] = "'"+rs2+"'";
                     $(t).attr('href', target.join(','));
                }
            }else{
                $(t).attr('src', rs2);
                $(t).css('display', '');
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $(t).attr('href', target.join(','));
                }else{
                     var t_link = $(t).parent('a');
                     var target = $(t_link).attr('href').split(',');
                     target[0] = "javascript:nm_mostra_img('"+rs_orig+"'";
                     $(t_link).attr('href', target.join(','));
                }

            }
            eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        } catch(err){
                        eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        }
    }
   /* hasFalseCacheRequest = false;
    $.each(api_cache_requests, function(i,v){
        if(v == false){
            hasFalseCacheRequest = true;
        }
    });
    if(hasFalseCacheRequest == false){
        scAjaxProcOff();
    }*/
}

$(document).ready(function(){
});function scJQSignatureAdd(seqRow) {
  $("#sc-id-sign-signature" + seqRow).jSignature({
    width: "500px",
    height: "200px",
    color: "#000000"
  }).bind("change", function(e) {
    $("#id_sc_field_signature" + seqRow).trigger("change");
    scJQSignatureRedrawReadonly("#id_sc_field_signature" + seqRow);
    var changedRow = $("input[name='sc_check_vert[" + seqRow + "]']");
    if (changedRow.length) {
      $(changedRow[0]).prop("checked", true);
    }
  });
  scJQSignatureRedraw("signature" + seqRow);
  var changedRow = $("input[name='sc_check_vert[" + seqRow + "]']");
  if (changedRow.length) {
    $(changedRow[0]).prop("checked", false);
  }
} // scJQSignatureAdd

function scJQSignatureRedraw(fieldName) {
  var thisFieldValue = $("#id_sc_field_" + fieldName).val();
  if ("" != thisFieldValue && "data:image/jsignature;base30," != thisFieldValue && "data:image/jsignature;base30," == thisFieldValue.substr(0, 29)) {
    $("#sc-id-sign-" + fieldName).jSignature("reset").jSignature("setData", thisFieldValue);
    var pngDataUrl = $("#sc-id-sign-" + fieldName).jSignature("getData", "image");
    $("#sc-id-disabled-" + fieldName).find("img").attr("src", "data:" + pngDataUrl);
    scJQSignatureRedrawReadonly(fieldName);
  }
  else {
    scJQSignatureClear(fieldName);
  }
} // scJQSignatureRedraw

function scJQSignatureRedrawReadonly(fieldName) {
  var thisFieldValue = $("#id_sc_field_" + fieldName).val();
  if ("" != thisFieldValue) {
    var pngDataUrl = $("#sc-id-sign-" + fieldName).jSignature("getData", "image");
    $("#sc-id-ronly-" + fieldName).find("img").attr("src", "data:" + pngDataUrl);
    $("#sc-id-ronly-" + fieldName).show();
  }
} // scJQSignatureRedraw

function scJQSignatureClear(fieldName) {
  $("#sc-id-sign-" + fieldName).jSignature("reset");
  $("#sc-id-disabled-" + fieldName).find("img").attr("src", "");
  scJQSignatureClearReadOnly(fieldName);
} // scJQSignatureRedraw

function scJQSignatureClearReadOnly(fieldName) {
    $("#sc-id-ronly-" + fieldName).find("img").attr("src", "");
} // scJQSignatureRedraw

function scJQRatingAdd(seqRow) {
  scJQRatingRedraw("rating", seqRow);
  $(".rat-ico-edit-rating" + seqRow).on("click", function() {
    if ($("#id_sc_field_rating" + seqRow).hasClass("sc-ui-field-disabled")) {
      return;
    }
    var i, clickValue = 0, itemCount = $(".rat-ico-edit-rating" + seqRow).length;
    for (i = 1; i <= itemCount; i++) {
      if ($(this).hasClass("rat-icon-item-" +i)) {
        clickValue = i;
      }
    }
    if (clickValue == $("#id_sc_field_rating" + seqRow).val()) {
      clickValue--;
    }
    $("#id_sc_field_rating" + seqRow).val(clickValue);
    var changedRow = $("input[name='sc_check_vert[" + seqRow + "]']");
    if (changedRow.length) {
      $(changedRow[0]).prop("checked", true);
    }
    scJQRatingRedraw("rating", seqRow);
    $("#id_sc_field_rating" + seqRow).trigger("change");
  }).on("mouseover", function() {
    if (!$("#id_sc_field_rating" + seqRow).hasClass("sc-ui-field-disabled")) {
      $(this).css("cursor", "pointer");
    }
  });
} // scJQRatingAdd

function scJQRatingRedraw(fieldName, seqRow) {
  var i, fieldValue = $("#id_sc_field_" + fieldName + seqRow).val(), itemCount = $(".rat-ico-edit-" + fieldName + seqRow).length;
  if ("" == fieldValue) {
    fieldValue = 0;
  }
  else {
    fieldValue = parseFloat(fieldValue);
  }
  for (i = 1; i <= itemCount; i++) {
    if (fieldValue >= i) {
      $(".rat-ico-edit-" + fieldName + seqRow + ".rat-icon-item-" + i).attr("src", "<?php echo $this->Ini->path_icones ?>/" + scRatingData[fieldName]["icon_on"]);
      $(".rat-ico-ronly-" + fieldName + seqRow + ".rat-icon-item-" + i).attr("src", "<?php echo $this->Ini->path_icones ?>/" + scRatingData[fieldName]["icon_on"]);
    }
    else {
      $(".rat-ico-edit-" + fieldName + seqRow + ".rat-icon-item-" + i).attr("src", "<?php echo $this->Ini->path_icones ?>/" + scRatingData[fieldName]["icon_off"]);
      $(".rat-ico-ronly-" + fieldName + seqRow + ".rat-icon-item-" + i).attr("src", "<?php echo $this->Ini->path_icones ?>/" + scRatingData[fieldName]["icon_off"]);
    }
  }
} // scJQRatingRedraw

function scJQSlideAdd(seqRow) {
  $("#sc-ui-slide-slider" + seqRow).slider({
    min: 0,
    max: 100,
    range: "min",
    step: 1,
    slide: function(event, ui) {
      var thisValue = ui.value;
      if (_scOnInputSupport && !_scMacOs) {
        $("#id_sc_field_slider" + seqRow).val(thisValue);
        $("#id_sc_field_slider" + seqRow).scInput("formatValue");
      }
      else {
        $("#id_sc_field_slider" + seqRow).val(scFormatValue_slider(thisValue));
      }
      var changedRow = $("input[name='sc_check_vert[" + seqRow + "]']");
      if (changedRow.length) {
        $(changedRow[0]).prop("checked", true);
      }
    },
    stop: function(event, ui) {
        $("#id_sc_field_slider" + seqRow).change();
    }
  });
  scJQSlideValue("slider" + seqRow, seqRow);
} // scJQSlideAdd

function scFormatValue_slider(thisValue) {
<?php
if ('.' == $this->field_config['slider']['symbol_grp']) {
?>
  thisValue = thisValue.toLocaleString("pt");
<?php
}
elseif (',' == $this->field_config['slider']['symbol_grp']) {
?>
  thisValue = thisValue.toLocaleString("en");
<?php
}
elseif ('' != $this->field_config['slider']['symbol_grp']) {
?>
  thisValue = thisValue.toLocaleString("pt").replace(new RegExp(scRegExpQuote("."), "g"), "<?php echo $this->field_config['slider']['symbol_grp']; ?>");
<?php
}
?>
  return thisValue;
} // scFormatValue_slider

function scUnformatValue_slider(thisValue) {
<?php
if ('' != $this->field_config['slider']['symbol_grp']) {
?>
  thisValue = thisValue.replace(new RegExp(scRegExpQuote("<?php echo $this->field_config['slider']['symbol_grp']; ?>"), "g"), "");
<?php
}
?>
  return thisValue;
} // scUnformatValue_slider

function scJQSlideValue(fieldName, seqRow) {
  var fieldValue = $("#id_sc_field_" + fieldName).val();
  var testFieldName = fieldName;
  if ("" != seqRow) {
    testFieldName = testFieldName.substr(0, testFieldName.length - seqRow.toString().length);
  }
  if ("slider" == testFieldName) {
    fieldValue = scUnformatValue_slider(fieldValue);
  }
  if ("" == fieldValue) {
    return;
  }
  fieldValue = parseInt(fieldValue);
  if ("number" != typeof(fieldValue)) {
    return;
  }
  $("#sc-ui-slide-" + fieldName).slider("value", fieldValue);
} // scJQSlideValue

function scRegExpQuote(str) {
  return str.replace(/([.?*+^$[\]\\(){}|-])/g, "\\$1");
} // scRegExpQuote

function scJQSelect2Add(seqRow, specificField) {
  if (null == specificField || "select2" == specificField) {
    scJQSelect2Add_select2(seqRow);
  }
} // scJQSelect2Add

function scJQSelect2Add_select2(seqRow) {
  var elemSelector = "all" == seqRow ? ".css_select2_obj" : "#id_sc_field_select2" + seqRow;
  $(elemSelector).select2(
    {
      containerCssClass: 'css_select2_obj',
      dropdownCssClass: 'css_select2_obj',
      language: {
        noResults: function() {
          return "<?php echo $this->Ini->Nm_lang['lang_autocomp_notfound'] ?>";
        },
        searching: function() {
          return "<?php echo $this->Ini->Nm_lang['lang_autocomp_searching'] ?>";
        }
      }
    }
  );
} // scJQSelect2Add


function scJQElementsAdd(iLine) {
  scJQEventsAdd(iLine);
  scEventControl_init(iLine);
  scJQUploadAdd(iLine);
  scJQSignatureAdd(iLine);
  scJQRatingAdd(iLine);
  scJQSlideAdd(iLine);
  scJQSelect2Add(iLine);
  setTimeout(function () { if ('function' == typeof displayChange_field_select2) { displayChange_field_select2(iLine, "on"); } }, 150);
} // scJQElementsAdd

function scGetFileExtension(fileName)
{
    fileNameParts = fileName.split(".");

    if (1 === fileNameParts.length || (2 === fileNameParts.length && "" == fileNameParts[0])) {
        return "";
    }

    return fileNameParts.pop().toLowerCase();
}

function scFormatExtensionSizeErrorMsg(errorMsg)
{
    var msgInfo = errorMsg.split("||"), returnMsg = "";

    if ("err_size" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_size'] ?>. <?php echo $this->Ini->Nm_lang['lang_errm_file_size_extension'] ?>".replace("{SC_EXTENSION}", msgInfo[1]).replace("{SC_LIMIT}", msgInfo[2]);
    } else if ("err_extension" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_invl'] ?>";
    }

    return returnMsg;
}

