<?php
class Header_Footer extends TCPDF
{
   var $nm_data;
   var $Nm_lang;
   function Header()
   {
            $Lin_extras = array();
            $this->default_font = $_SESSION['scriptcase']['pdf01']['default_font'];
            $str_lang = (isset($_SESSION['scriptcase']['str_lang']) && !empty($_SESSION['scriptcase']['str_lang'])) ? $_SESSION['scriptcase']['str_lang'] : "en_us";
            if (empty($this->Nm_lang))
            {
                include("../_lib/lang/" . $str_lang . ".lang.php");
            }
            $this->nm_data = new nm_data("en_us");
            $cell_itens_productid = array('posx' => '1.741831458333114', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_productid'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_unitprice = array('posx' => '70', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_unitprice'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_quantity = array('posx' => '48.98760416666049', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_quantity'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_discount = array('posx' => '110', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_discount'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_totalprice = array('posx' => '130', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_totalprice'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);

            foreach ($Lin_extras as $Lines => $Data_lines) 
            {
                $this->Ln(4.2333333333333);
                foreach ($Data_lines as $Col => $Parms) 
                {
                    if (isset($Parms["type"]) && $Parms["type"] == "img")
                    {
                        $posY = $this->GetY();
                        if (isset($Parms["data"]) && !empty($Parms["data"]) && is_file($Parms["data"]))
                        {
                            $this->Image($Parms['data'], $Col, $posY, $Parms['larg'], $Parms['alt']);
                        }
                    }
                    else
                    {
                        $this->SetX($Col);
                        $this->SetFont($Parms["font_type"], $Parms["font_style"], $Parms["font_size"]);
                        $this->pdf_text_color($Parms["data"], $Parms["color_r"], $Parms["color_g"], $Parms["color_b"]);
                        $this->Cell($Parms["width"], 0, $Parms["data"], 0, 0, $Parms["align"]);
                    }
                }
            }
            $this->SC_Y_lin_ini = 4.2333333333333;
   }
   function Footer()
   {
            $Lin_extras = array();
            $this->default_font = $_SESSION['scriptcase']['pdf01']['default_font'];
            $str_lang = (isset($_SESSION['scriptcase']['str_lang']) && !empty($_SESSION['scriptcase']['str_lang'])) ? $_SESSION['scriptcase']['str_lang'] : "en_us";
            if (empty($this->Nm_lang))
            {
                include("../_lib/lang/" . $str_lang . ".lang.php");
            }
            $this->nm_data = new nm_data("en_us");
            $cell_itens_productid = array('posx' => '1.741831458333114', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_productid_foot'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_unitprice = array('posx' => '70', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_unitprice_foot'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_quantity = array('posx' => '48.98760416666049', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_quantity_foot'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_discount = array('posx' => '110', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_discount_foot'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_totalprice = array('posx' => '130', 'posy' => '5.820833333332599', 'data' => $_SESSION['pdf01']['itens_totalprice_foot'], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);

            foreach ($Lin_extras as $Lines => $Data_lines) 
            {
                $this->Ln(4.2333333333333);
                foreach ($Data_lines as $Col => $Parms) 
                {
                    if (isset($Parms["type"]) && $Parms["type"] == "img")
                    {
                        $posY = $this->GetY();
                        if (isset($Parms["data"]) && !empty($Parms["data"]) && is_file($Parms["data"]))
                        {
                            $this->Image($Parms['data'], $Col, $posY, $Parms['larg'], $Parms['alt']);
                        }
                    }
                    else
                    {
                        $this->SetX($Col);
                        $this->SetFont($Parms["font_type"], $Parms["font_style"], $Parms["font_size"]);
                        $this->pdf_text_color($Parms["data"], $Parms["color_r"], $Parms["color_g"], $Parms["color_b"]);
                        $this->Cell($Parms["width"], 0, $Parms["data"], 0, 0, $Parms["align"]);
                    }
                }
            }
   }
   function pdf_text_color(&$val, $r, $g, $b)
   {
       $pos = strpos($val, "@SCNEG#");
       if ($pos !== false)
       {
           $cor = trim(substr($val, $pos + 7));
           $val = substr($val, 0, $pos);
           $cor = (substr($cor, 0, 1) == "#") ? substr($cor, 1) : $cor;
           if (strlen($cor) == 6)
           {
               $r = hexdec(substr($cor, 0, 2));
               $g = hexdec(substr($cor, 2, 2));
               $b = hexdec(substr($cor, 4, 2));
           }
       }
       $this->SetTextColor($r, $g, $b);
   }
   function SC_conv_utf8($input)
   {
        if ($_SESSION['scriptcase']['charset'] != "UTF-8" && !NM_is_utf8($input))
        {
            $input = sc_convert_encoding($input, "UTF-8", $_SESSION['scriptcase']['charset']);
        }
       return $input;
   }
   function nm_conv_data_db($dt_in, $form_in, $form_out)
   {
       $dt_out = $dt_in;
       if (strtoupper($form_in) == "DB_FORMAT") {
           if ($dt_out == "null" || $dt_out == "")
           {
               $dt_out = "";
               return $dt_out;
           }
           $form_in = "AAAA-MM-DD";
       }
       if (strtoupper($form_out) == "DB_FORMAT") {
           if (empty($dt_out))
           {
               $dt_out = "null";
               return $dt_out;
           }
           $form_out = "AAAA-MM-DD";
       }
       if (strtoupper($form_out) == "SC_FORMAT_REGION") {
           $this->nm_data->SetaData($dt_in, strtoupper($form_in));
           $prep_out  = (strpos(strtolower($form_in), "dd") !== false) ? "dd" : "";
           $prep_out .= (strpos(strtolower($form_in), "mm") !== false) ? "mm" : "";
           $prep_out .= (strpos(strtolower($form_in), "aa") !== false) ? "aaaa" : "";
           $prep_out .= (strpos(strtolower($form_in), "yy") !== false) ? "aaaa" : "";
           return $this->nm_data->FormataSaida($this->nm_data->FormatRegion("DT", $prep_out));
       }
       else {
           nm_conv_form_data($dt_out, $form_in, $form_out);
           return $dt_out;
       }
   }
}
?>
