
function scJQGeneralAdd() {
  scLoadScInput('input:text.sc-js-input');
  scLoadScInput('input:password.sc-js-input');
  scLoadScInput('input:checkbox.sc-js-input');
  scLoadScInput('input:radio.sc-js-input');
  scLoadScInput('select.sc-js-input');
  scLoadScInput('textarea.sc-js-input');

} // scJQGeneralAdd

function scFocusField(sField) {
  var $oField = $('#id_sc_field_' + sField);

  if (0 == $oField.length) {
    $oField = $('input[name=' + sField + ']');
  }

  if (0 == $oField.length && document.F1.elements[sField]) {
    $oField = $(document.F1.elements[sField]);
  }

  if ($("#id_ac_" + sField).length > 0) {
    if ($oField.hasClass("select2-hidden-accessible")) {
      if (false == scSetFocusOnField($oField)) {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
    else {
      if (false == scSetFocusOnField($oField)) {
        if (false == scSetFocusOnField($("#id_ac_" + sField))) {
          setTimeout(function() { scSetFocusOnField($("#id_ac_" + sField)); }, 500);
        }
      }
      else {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
  }
  else {
    setTimeout(function() { scSetFocusOnField($oField); }, 500);
  }
} // scFocusField

function scSetFocusOnField($oField) {
  if ($oField.length > 0 && $oField[0].offsetHeight > 0 && $oField[0].offsetWidth > 0 && !$oField[0].disabled) {
    $oField[0].focus();
    return true;
  }
  return false;
} // scSetFocusOnField

function scEventControl_init(iSeqRow) {
  scEventControl_data["api_gateway" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["appname" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["apikey" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["apisecret" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["accesstoken" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["jsonoauth" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["authcode" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["tokencode" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["api_region" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["api_bucket" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["files" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["destination" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
}

function scEventControl_active(iSeqRow) {
  if (scEventControl_data["api_gateway" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["api_gateway" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["appname" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["appname" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["apikey" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["apikey" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["apisecret" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["apisecret" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["accesstoken" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["accesstoken" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["jsonoauth" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["jsonoauth" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["authcode" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["authcode" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["tokencode" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["tokencode" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["api_region" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["api_region" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["api_bucket" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["api_bucket" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["destination" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["destination" + iSeqRow]["change"]) {
    return true;
  }
  return false;
} // scEventControl_active

function scEventControl_onFocus(oField, iSeq) {
  var fieldId, fieldName;
  fieldId = $(oField).attr("id");
  fieldName = fieldId.substr(12);
  scEventControl_data[fieldName]["blur"] = true;
  if ("api_gateway" + iSeq == fieldName) {
    scEventControl_data[fieldName]["blur"] = false;
  }
  if ("api_gateway" + iSeq == fieldName) {
    scEventControl_data[fieldName]["change"]   = true;
    scEventControl_data[fieldName]["original"] = $(oField).val();
    scEventControl_data[fieldName]["calculated"] = $(oField).val();
    return;
  }
  scEventControl_data[fieldName]["change"] = false;
} // scEventControl_onFocus

function scEventControl_onBlur(sFieldName) {
  scEventControl_data[sFieldName]["blur"] = false;
  if (scEventControl_data[sFieldName]["change"]) {
        if (scEventControl_data[sFieldName]["original"] == $("#id_sc_field_" + sFieldName).val() || scEventControl_data[sFieldName]["calculated"] == $("#id_sc_field_" + sFieldName).val()) {
          scEventControl_data[sFieldName]["change"] = false;
        }
  }
} // scEventControl_onBlur

function scEventControl_onChange(sFieldName) {
  scEventControl_data[sFieldName]["change"] = false;
} // scEventControl_onChange

function scEventControl_onAutocomp(sFieldName) {
  scEventControl_data[sFieldName]["autocomp"] = false;
} // scEventControl_onChange

var scEventControl_data = {};

function scJQEventsAdd(iSeqRow) {
  $('#id_sc_field_api_gateway' + iSeqRow).bind('blur', function() { sc_control_download_file_api_gateway_onblur(this, iSeqRow) })
                                         .bind('change', function() { sc_control_download_file_api_gateway_onchange(this, iSeqRow) })
                                         .bind('focus', function() { sc_control_download_file_api_gateway_onfocus(this, iSeqRow) });
  $('#id_sc_field_appname' + iSeqRow).bind('blur', function() { sc_control_download_file_appname_onblur(this, iSeqRow) })
                                     .bind('change', function() { sc_control_download_file_appname_onchange(this, iSeqRow) })
                                     .bind('focus', function() { sc_control_download_file_appname_onfocus(this, iSeqRow) });
  $('#id_sc_field_apikey' + iSeqRow).bind('blur', function() { sc_control_download_file_apikey_onblur(this, iSeqRow) })
                                    .bind('change', function() { sc_control_download_file_apikey_onchange(this, iSeqRow) })
                                    .bind('focus', function() { sc_control_download_file_apikey_onfocus(this, iSeqRow) });
  $('#id_sc_field_apisecret' + iSeqRow).bind('blur', function() { sc_control_download_file_apisecret_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_control_download_file_apisecret_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_control_download_file_apisecret_onfocus(this, iSeqRow) });
  $('#id_sc_field_accesstoken' + iSeqRow).bind('blur', function() { sc_control_download_file_accesstoken_onblur(this, iSeqRow) })
                                         .bind('change', function() { sc_control_download_file_accesstoken_onchange(this, iSeqRow) })
                                         .bind('focus', function() { sc_control_download_file_accesstoken_onfocus(this, iSeqRow) });
  $('#id_sc_field_jsonoauth' + iSeqRow).bind('blur', function() { sc_control_download_file_jsonoauth_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_control_download_file_jsonoauth_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_control_download_file_jsonoauth_onfocus(this, iSeqRow) });
  $('#id_sc_field_authcode' + iSeqRow).bind('blur', function() { sc_control_download_file_authcode_onblur(this, iSeqRow) })
                                      .bind('change', function() { sc_control_download_file_authcode_onchange(this, iSeqRow) })
                                      .bind('focus', function() { sc_control_download_file_authcode_onfocus(this, iSeqRow) });
  $('#id_sc_field_tokencode' + iSeqRow).bind('blur', function() { sc_control_download_file_tokencode_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_control_download_file_tokencode_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_control_download_file_tokencode_onfocus(this, iSeqRow) });
  $('#id_sc_field_api_region' + iSeqRow).bind('blur', function() { sc_control_download_file_api_region_onblur(this, iSeqRow) })
                                        .bind('change', function() { sc_control_download_file_api_region_onchange(this, iSeqRow) })
                                        .bind('focus', function() { sc_control_download_file_api_region_onfocus(this, iSeqRow) });
  $('#id_sc_field_api_bucket' + iSeqRow).bind('blur', function() { sc_control_download_file_api_bucket_onblur(this, iSeqRow) })
                                        .bind('change', function() { sc_control_download_file_api_bucket_onchange(this, iSeqRow) })
                                        .bind('focus', function() { sc_control_download_file_api_bucket_onfocus(this, iSeqRow) });
  $('#id_sc_field_files' + iSeqRow).bind('blur', function() { sc_control_download_file_files_onblur(this, iSeqRow) })
                                   .bind('change', function() { sc_control_download_file_files_onchange(this, iSeqRow) })
                                   .bind('focus', function() { sc_control_download_file_files_onfocus(this, iSeqRow) });
  $('#id_sc_field_destination' + iSeqRow).bind('blur', function() { sc_control_download_file_destination_onblur(this, iSeqRow) })
                                         .bind('change', function() { sc_control_download_file_destination_onchange(this, iSeqRow) })
                                         .bind('focus', function() { sc_control_download_file_destination_onfocus(this, iSeqRow) });
} // scJQEventsAdd

function sc_control_download_file_api_gateway_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_api_gateway();
  scCssBlur(oThis);
}

function sc_control_download_file_api_gateway_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
  do_ajax_control_download_file_event_api_gateway_onchange();
}

function sc_control_download_file_api_gateway_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_appname_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_appname();
  scCssBlur(oThis);
}

function sc_control_download_file_appname_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_appname_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_apikey_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_apikey();
  scCssBlur(oThis);
}

function sc_control_download_file_apikey_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_apikey_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_apisecret_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_apisecret();
  scCssBlur(oThis);
}

function sc_control_download_file_apisecret_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_apisecret_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_accesstoken_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_accesstoken();
  scCssBlur(oThis);
}

function sc_control_download_file_accesstoken_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_accesstoken_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_jsonoauth_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_jsonoauth();
  scCssBlur(oThis);
}

function sc_control_download_file_jsonoauth_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_jsonoauth_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_authcode_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_authcode();
  scCssBlur(oThis);
}

function sc_control_download_file_authcode_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_authcode_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_tokencode_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_tokencode();
  scCssBlur(oThis);
}

function sc_control_download_file_tokencode_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_tokencode_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_api_region_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_api_region();
  scCssBlur(oThis);
}

function sc_control_download_file_api_region_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_api_region_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_api_bucket_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_api_bucket();
  scCssBlur(oThis);
}

function sc_control_download_file_api_bucket_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_api_bucket_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_download_file_files_onblur(oThis, iSeqRow) {
  scCssBlur(oThis);
}

function sc_control_download_file_files_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_files_onfocus(oThis, iSeqRow) {
  scCssFocus(oThis);
}

function sc_control_download_file_destination_onblur(oThis, iSeqRow) {
  do_ajax_control_download_file_validate_destination();
  scCssBlur(oThis);
}

function sc_control_download_file_destination_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_download_file_destination_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function displayChange_block(block, status) {
	if ("0" == block) {
		displayChange_block_0(status);
	}
	if ("1" == block) {
		displayChange_block_1(status);
	}
}

function displayChange_block_0(status) {
	displayChange_field("api_gateway", "", status);
	displayChange_field("appname", "", status);
	displayChange_field("apikey", "", status);
	displayChange_field("apisecret", "", status);
	displayChange_field("accesstoken", "", status);
	displayChange_field("jsonoauth", "", status);
	displayChange_field("authcode", "", status);
	displayChange_field("tokencode", "", status);
	displayChange_field("api_region", "", status);
	displayChange_field("api_bucket", "", status);
}

function displayChange_block_1(status) {
	displayChange_field("files", "", status);
	displayChange_field("destination", "", status);
}

function displayChange_row(row, status) {
	displayChange_field_api_gateway(row, status);
	displayChange_field_appname(row, status);
	displayChange_field_apikey(row, status);
	displayChange_field_apisecret(row, status);
	displayChange_field_accesstoken(row, status);
	displayChange_field_jsonoauth(row, status);
	displayChange_field_authcode(row, status);
	displayChange_field_tokencode(row, status);
	displayChange_field_api_region(row, status);
	displayChange_field_api_bucket(row, status);
	displayChange_field_files(row, status);
	displayChange_field_destination(row, status);
}

function displayChange_field(field, row, status) {
	if ("api_gateway" == field) {
		displayChange_field_api_gateway(row, status);
	}
	if ("appname" == field) {
		displayChange_field_appname(row, status);
	}
	if ("apikey" == field) {
		displayChange_field_apikey(row, status);
	}
	if ("apisecret" == field) {
		displayChange_field_apisecret(row, status);
	}
	if ("accesstoken" == field) {
		displayChange_field_accesstoken(row, status);
	}
	if ("jsonoauth" == field) {
		displayChange_field_jsonoauth(row, status);
	}
	if ("authcode" == field) {
		displayChange_field_authcode(row, status);
	}
	if ("tokencode" == field) {
		displayChange_field_tokencode(row, status);
	}
	if ("api_region" == field) {
		displayChange_field_api_region(row, status);
	}
	if ("api_bucket" == field) {
		displayChange_field_api_bucket(row, status);
	}
	if ("files" == field) {
		displayChange_field_files(row, status);
	}
	if ("destination" == field) {
		displayChange_field_destination(row, status);
	}
}

function displayChange_field_api_gateway(row, status) {
}

function displayChange_field_appname(row, status) {
}

function displayChange_field_apikey(row, status) {
}

function displayChange_field_apisecret(row, status) {
}

function displayChange_field_accesstoken(row, status) {
}

function displayChange_field_jsonoauth(row, status) {
}

function displayChange_field_authcode(row, status) {
}

function displayChange_field_tokencode(row, status) {
}

function displayChange_field_api_region(row, status) {
}

function displayChange_field_api_bucket(row, status) {
}

function displayChange_field_files(row, status) {
}

function displayChange_field_destination(row, status) {
}

function scRecreateSelect2() {
}
function scResetPagesDisplay() {
	$(".sc-form-page").show();
}

function scHidePage(pageNo) {
	$("#id_control_download_file_form" + pageNo).hide();
}

function scCheckNoPageSelected() {
	if (!$(".sc-form-page").filter(".scTabActive").filter(":visible").length) {
		var inactiveTabs = $(".sc-form-page").filter(".scTabInactive").filter(":visible");
		if (inactiveTabs.length) {
			var tabNo = $(inactiveTabs[0]).attr("id").substr(29);
		}
	}
}
function scJQUploadAdd(iSeqRow) {
  $("#id_sc_field_files" + iSeqRow).fileupload({
    datatype: "json",
    url: "control_download_file_ul_save.php",
    dropZone: $("#hidden_field_data_files" + iSeqRow),
    formData: function() {
      return [
        {name: 'param_field', value: 'files'},
        {name: 'param_seq', value: '<?php echo $this->Ini->sc_page; ?>'},
        {name: 'upload_file_row', value: iSeqRow}
      ];
    },
    progress: function(e, data) {
      var loader, progress;
      if (data.lengthComputable && window.FormData !== undefined) {
        loader = $("#id_img_loader_files" + iSeqRow);
        loaderContent = $("#id_img_loader_files" + iSeqRow + " .scProgressBarLoading");
        loaderContent.html("&nbsp;");
        progress = parseInt(data.loaded / data.total * 100, 10);
        loader.show().find("div").css("width", progress + "%");
      }
      else {
        loader = $("#id_ajax_loader_files" + iSeqRow);
        loader.show();
      }
    },
    change: function(e, data) {
      var checkUploadSize = scCheckUploadExtensionSize_files(data);
      if ('ok' != checkUploadSize) {
        e.preventDefault();
        scJs_alert(scFormatExtensionSizeErrorMsg(checkUploadSize), function() {}, {'type': 'error'});
      }
    },
    drop: function(e, data) {
      var checkUploadSize = scCheckUploadExtensionSize_files(data);
      if ('ok' != checkUploadSize) {
        scJs_alert(scFormatExtensionSizeErrorMsg(checkUploadSize), function() {}, {'type': 'error'});
      }
    },
    done: function(e, data) {
      var fileData, respData, respPos, respMsg, thumbDisplay, checkDisplay, var_ajax_img_thumb, oTemp;
      fileData = null;
      respMsg = "";
      if (data && data.result && data.result[0] && data.result[0].body) {
        respData = data.result[0].body.innerText;
        respPos = respData.indexOf("[{");
        if (-1 !== respPos) {
          respMsg = respData.substr(0, respPos);
          respData = respData.substr(respPos);
          fileData = $.parseJSON(respData);
        }
        else {
          respMsg = respData;
        }
      }
      else {
        respData = data.result;
        respPos = respData.indexOf("[{");
        if (-1 !== respPos) {
          respMsg = respData.substr(0, respPos);
          respData = respData.substr(respPos);
          fileData = eval(respData);
        }
        else {
          respMsg = respData;
        }
      }
      if (window.FormData !== undefined)
      {
        $("#id_img_loader_files" + iSeqRow).hide();
      }
      else
      {
        $("#id_ajax_loader_files" + iSeqRow).hide();
      }
      if (null == fileData) {
        if ("" != respMsg) {
          oTemp = {"htmOutput" : "<?php echo $this->Ini->Nm_lang['lang_errm_upld_admn']; ?>"};
          scAjaxShowDebug(oTemp);
        }
        return;
      }
      if (fileData[0].error && "" != fileData[0].error) {
        var uploadErrorMessage = "";
        oResp = {};
        if ("acceptFileTypes" == fileData[0].error) {
          uploadErrorMessage = "<?php echo $this->form_encode_input($this->Ini->Nm_lang['lang_errm_file_invl']) ?>";
        }
        else if ("maxFileSize" == fileData[0].error) {
          uploadErrorMessage = "<?php echo $this->form_encode_input($this->Ini->Nm_lang['lang_errm_file_size']) ?>";
        }
        else if ("minFileSize" == fileData[0].error) {
          uploadErrorMessage = "<?php echo $this->form_encode_input($this->Ini->Nm_lang['lang_errm_file_size']) ?>";
        }
        else if ("emptyFile" == fileData[0].error) {
          uploadErrorMessage = "<?php echo $this->form_encode_input($this->Ini->Nm_lang['lang_errm_file_empty']) ?>";
        }
        scAjaxShowErrorDisplay("table", uploadErrorMessage);
        return;
      }
      $("#id_sc_field_files" + iSeqRow).val("");
      $("#id_sc_field_files_ul_name" + iSeqRow).val(fileData[0].sc_ul_name);
      $("#id_sc_field_files_ul_type" + iSeqRow).val(fileData[0].type);
      $("#id_ajax_doc_files" + iSeqRow).html(fileData[0].name);
      $("#id_ajax_doc_files" + iSeqRow).css("display", "");
      checkDisplay = ("" == fileData[0].sc_random_prot.substr(12)) ? "none" : "";
      $("#chk_ajax_img_files" + iSeqRow).css("display", checkDisplay);
      $("#id_ajax_link_files" + iSeqRow).html(fileData[0].sc_random_prot.substr(12));
    }
  });

} // scJQUploadAdd

var api_cache_requests = [];
function ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, hasRun, img_before){
    setTimeout(function(){
        if(img_name == '') return;
        iSeqRow= iSeqRow !== undefined && iSeqRow !== null ? iSeqRow : '';
        var hasVar = p.indexOf('_@NM@_') > -1 || p_cache.indexOf('_@NM@_') > -1 ? true : false;

        p = p.split('_@NM@_');
        $.each(p, function(i,v){
            try{
                p[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p[i] = v;
            }
        });
        p = p.join('');

        p_cache = p_cache.split('_@NM@_');
        $.each(p_cache, function(i,v){
            try{
                p_cache[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p_cache[i] = v;
            }
        });
        p_cache = p_cache.join('');

        img_before = img_before !== undefined ? img_before : $(t).attr('src');
        var str_key_cache = '<?php echo $this->Ini->sc_page; ?>' + img_name+field+p+p_cache;
        if(api_cache_requests[ str_key_cache ] !== undefined && api_cache_requests[ str_key_cache ] !== null){
            if(api_cache_requests[ str_key_cache ] != false){
                do_ajax_check_file(api_cache_requests[ str_key_cache ], field  ,t, iSeqRow);
            }
            return;
        }
        //scAjaxProcOn();
        $(t).attr('src', '<?php echo $this->Ini->path_icones ?>/scriptcase__NM__ajax_load.gif');
        api_cache_requests[ str_key_cache ] = false;
        var rs =$.ajax({
                    type: "POST",
                    url: 'index.php?script_case_init=<?php echo $this->Ini->sc_page; ?>',
                    async: true,
                    data:'nmgp_opcao=ajax_check_file&AjaxCheckImg=' + encodeURI(img_name) +'&rsargs='+ field + '&p=' + p + '&p_cache=' + p_cache,
                    success: function (rs) {
                        if(rs.indexOf('</span>') != -1){
                            rs = rs.substr(rs.indexOf('</span>') + 7);
                        }
                        if(rs.indexOf('/') != -1 && rs.indexOf('/') != 0){
                            rs = rs.substr(rs.indexOf('/'));
                        }
                        rs = sc_trim(rs);

                        // if(rs == 0 && hasVar && hasRun === undefined){
                        //     delete window.api_cache_requests[ str_key_cache ];
                        //     ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, 1, img_before);
                        //     return;
                        // }
                        window.api_cache_requests[ str_key_cache ] = rs;
                        do_ajax_check_file(rs, field  ,t, iSeqRow)
                        if(rs == 0){
                            delete window.api_cache_requests[ str_key_cache ];

                           // $(t).attr('src',img_before);
                            do_ajax_check_file(img_before+'_@@NM@@_' + img_before, field  ,t, iSeqRow)

                        }


                    }
        });
    },100);
}

function do_ajax_check_file(rs, field  ,t, iSeqRow){
    if (rs != 0) {
        rs_split = rs.split('_@@NM@@_');
        rs_orig = rs_split[0];
        rs2 = rs_split[1];
        try{
            if(!$(t).is('img')){

                if($('#id_read_on_'+field+iSeqRow).length > 0 ){
                                    var usa_read_only = false;

                switch(field){

                }
                     if(usa_read_only && $('a',$('#id_read_on_'+field+iSeqRow)).length == 0){
                         $(t).html("<a href=\"javascript:nm_mostra_doc('0', '"+rs2+"', 'control_download_file')\">"+$('#id_read_on_'+field+iSeqRow).text()+"</a>");
                     }
                }
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href', target.join(','));
                }else{
                    var target = $(t).attr('href').split(',');
                     target[1] = "'"+rs2+"'";
                     $(t).attr('href', target.join(','));
                }
            }else{
                $(t).attr('src', rs2);
                $(t).css('display', '');
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $(t).attr('href', target.join(','));
                }else{
                     var t_link = $(t).parent('a');
                     var target = $(t_link).attr('href').split(',');
                     target[0] = "javascript:nm_mostra_img('"+rs_orig+"'";
                     $(t_link).attr('href', target.join(','));
                }

            }
            eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        } catch(err){
                        eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        }
    }
   /* hasFalseCacheRequest = false;
    $.each(api_cache_requests, function(i,v){
        if(v == false){
            hasFalseCacheRequest = true;
        }
    });
    if(hasFalseCacheRequest == false){
        scAjaxProcOff();
    }*/
}

$(document).ready(function(){
});
function scJQElementsAdd(iLine) {
  scJQEventsAdd(iLine);
  scEventControl_init(iLine);
  scJQUploadAdd(iLine);
} // scJQElementsAdd

function scGetFileExtension(fileName)
{
    fileNameParts = fileName.split(".");

    if (1 === fileNameParts.length || (2 === fileNameParts.length && "" == fileNameParts[0])) {
        return "";
    }

    return fileNameParts.pop().toLowerCase();
}

function scFormatExtensionSizeErrorMsg(errorMsg)
{
    var msgInfo = errorMsg.split("||"), returnMsg = "";

    if ("err_size" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_size'] ?>. <?php echo $this->Ini->Nm_lang['lang_errm_file_size_extension'] ?>".replace("{SC_EXTENSION}", msgInfo[1]).replace("{SC_LIMIT}", msgInfo[2]);
    } else if ("err_extension" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_invl'] ?>";
    }

    return returnMsg;
}

function scCheckUploadExtensionSize_files(thisField)
{
    if ("files" in thisField && thisField.files.length > 0) {
        thisFileExtension = scGetFileExtension(thisField.files[0].name);


        if (!["docx", "xlsx", "pptx", "pdf", "txt"].includes(thisFileExtension)) {
            return 'err_extension||' + thisFileExtension.toUpperCase();
        }
    }

    return 'ok';
}

