
function scJQGeneralAdd() {
  scLoadScInput('input:text.sc-js-input');
  scLoadScInput('input:password.sc-js-input');
  scLoadScInput('input:checkbox.sc-js-input');
  scLoadScInput('input:radio.sc-js-input');
  scLoadScInput('select.sc-js-input');
  scLoadScInput('textarea.sc-js-input');

} // scJQGeneralAdd

function scFocusField(sField) {
  var $oField = $('#id_sc_field_' + sField);

  if (0 == $oField.length) {
    $oField = $('input[name=' + sField + ']');
  }

  if (0 == $oField.length && document.F1.elements[sField]) {
    $oField = $(document.F1.elements[sField]);
  }

  if ($("#id_ac_" + sField).length > 0) {
    if ($oField.hasClass("select2-hidden-accessible")) {
      if (false == scSetFocusOnField($oField)) {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
    else {
      if (false == scSetFocusOnField($oField)) {
        if (false == scSetFocusOnField($("#id_ac_" + sField))) {
          setTimeout(function() { scSetFocusOnField($("#id_ac_" + sField)); }, 500);
        }
      }
      else {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
  }
  else {
    setTimeout(function() { scSetFocusOnField($oField); }, 500);
  }
} // scFocusField

function scSetFocusOnField($oField) {
  if ($oField.length > 0 && $oField[0].offsetHeight > 0 && $oField[0].offsetWidth > 0 && !$oField[0].disabled) {
    $oField[0].focus();
    return true;
  }
  return false;
} // scSetFocusOnField

function scEventControl_init(iSeqRow) {
  scEventControl_data["sms_send_type" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_group" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_unique_to" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_gateway" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_charset" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_date_time" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_binary" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_periody" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_message" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["sms_msg_return" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
}

function scEventControl_active(iSeqRow) {
  if (scEventControl_data["sms_send_type" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_send_type" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_group" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_group" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_unique_to" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_unique_to" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_gateway" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_gateway" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_charset" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_charset" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_date_time" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_date_time" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_binary" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_binary" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_periody" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_periody" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_message" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_message" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["sms_msg_return" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["sms_msg_return" + iSeqRow]["change"]) {
    return true;
  }
  return false;
} // scEventControl_active

function scEventControl_onFocus(oField, iSeq) {
  var fieldId, fieldName;
  fieldId = $(oField).attr("id");
  fieldName = fieldId.substr(12);
  scEventControl_data[fieldName]["blur"] = true;
  if ("sms_group" + iSeq == fieldName) {
    scEventControl_data[fieldName]["blur"] = false;
  }
  if ("sms_gateway" + iSeq == fieldName) {
    scEventControl_data[fieldName]["blur"] = false;
  }
  if ("sms_charset" + iSeq == fieldName) {
    scEventControl_data[fieldName]["blur"] = false;
  }
  scEventControl_data[fieldName]["change"] = false;
} // scEventControl_onFocus

function scEventControl_onBlur(sFieldName) {
  scEventControl_data[sFieldName]["blur"] = false;
  if (scEventControl_data[sFieldName]["change"]) {
        if (scEventControl_data[sFieldName]["original"] == $("#id_sc_field_" + sFieldName).val() || scEventControl_data[sFieldName]["calculated"] == $("#id_sc_field_" + sFieldName).val()) {
          scEventControl_data[sFieldName]["change"] = false;
        }
  }
} // scEventControl_onBlur

function scEventControl_onChange(sFieldName) {
  scEventControl_data[sFieldName]["change"] = false;
} // scEventControl_onChange

function scEventControl_onAutocomp(sFieldName) {
  scEventControl_data[sFieldName]["autocomp"] = false;
} // scEventControl_onChange

var scEventControl_data = {};

function scJQEventsAdd(iSeqRow) {
  $('#id_sc_field_sms_group' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_group_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_control_sms_group_sms_group_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_control_sms_group_sms_group_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_gateway' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_gateway_onblur(this, iSeqRow) })
                                         .bind('change', function() { sc_control_sms_group_sms_gateway_onchange(this, iSeqRow) })
                                         .bind('focus', function() { sc_control_sms_group_sms_gateway_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_message' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_message_onblur(this, iSeqRow) })
                                         .bind('change', function() { sc_control_sms_group_sms_message_onchange(this, iSeqRow) })
                                         .bind('focus', function() { sc_control_sms_group_sms_message_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_msg_return' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_msg_return_onblur(this, iSeqRow) })
                                            .bind('change', function() { sc_control_sms_group_sms_msg_return_onchange(this, iSeqRow) })
                                            .bind('focus', function() { sc_control_sms_group_sms_msg_return_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_date_time' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_date_time_onblur(this, iSeqRow) })
                                           .bind('change', function() { sc_control_sms_group_sms_date_time_onchange(this, iSeqRow) })
                                           .bind('focus', function() { sc_control_sms_group_sms_date_time_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_date_time_hora' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_date_time_hora_onblur(this, iSeqRow) })
                                                .bind('change', function() { sc_control_sms_group_sms_date_time_hora_onchange(this, iSeqRow) })
                                                .bind('focus', function() { sc_control_sms_group_sms_date_time_hora_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_charset' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_charset_onblur(this, iSeqRow) })
                                         .bind('change', function() { sc_control_sms_group_sms_charset_onchange(this, iSeqRow) })
                                         .bind('focus', function() { sc_control_sms_group_sms_charset_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_binary' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_binary_onblur(this, iSeqRow) })
                                        .bind('change', function() { sc_control_sms_group_sms_binary_onchange(this, iSeqRow) })
                                        .bind('focus', function() { sc_control_sms_group_sms_binary_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_periody' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_periody_onblur(this, iSeqRow) })
                                         .bind('change', function() { sc_control_sms_group_sms_periody_onchange(this, iSeqRow) })
                                         .bind('focus', function() { sc_control_sms_group_sms_periody_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_send_type' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_send_type_onblur(this, iSeqRow) })
                                           .bind('change', function() { sc_control_sms_group_sms_send_type_onchange(this, iSeqRow) })
                                           .bind('click', function() { sc_control_sms_group_sms_send_type_onclick(this, iSeqRow) })
                                           .bind('focus', function() { sc_control_sms_group_sms_send_type_onfocus(this, iSeqRow) });
  $('#id_sc_field_sms_unique_to' + iSeqRow).bind('blur', function() { sc_control_sms_group_sms_unique_to_onblur(this, iSeqRow) })
                                           .bind('change', function() { sc_control_sms_group_sms_unique_to_onchange(this, iSeqRow) })
                                           .bind('focus', function() { sc_control_sms_group_sms_unique_to_onfocus(this, iSeqRow) });
  $('.sc-ui-radio-sms_send_type' + iSeqRow).on('click', function() { scMarkFormAsChanged(); });
  $('.sc-ui-checkbox-sms_binary' + iSeqRow).on('click', function() { scMarkFormAsChanged(); });
} // scJQEventsAdd

function sc_control_sms_group_sms_group_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_group();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_group_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_group_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_gateway_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_gateway();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_gateway_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_gateway_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_message_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_message();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_message_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_message_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_msg_return_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_msg_return();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_msg_return_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_msg_return_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_date_time_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_date_time();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_date_time_hora_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_date_time();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_date_time_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_date_time_hora_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_date_time_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_date_time_hora_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_charset_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_charset();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_charset_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_charset_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_binary_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_binary();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_binary_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_binary_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_periody_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_periody();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_periody_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_periody_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_send_type_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_send_type();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_send_type_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_send_type_onclick(oThis, iSeqRow) {
  do_ajax_control_sms_group_event_sms_send_type_onclick();
}

function sc_control_sms_group_sms_send_type_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_control_sms_group_sms_unique_to_onblur(oThis, iSeqRow) {
  do_ajax_control_sms_group_validate_sms_unique_to();
  scCssBlur(oThis);
}

function sc_control_sms_group_sms_unique_to_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_control_sms_group_sms_unique_to_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function displayChange_block(block, status) {
	if ("0" == block) {
		displayChange_block_0(status);
	}
	if ("1" == block) {
		displayChange_block_1(status);
	}
	if ("2" == block) {
		displayChange_block_2(status);
	}
	if ("3" == block) {
		displayChange_block_3(status);
	}
}

function displayChange_block_0(status) {
	displayChange_field("sms_send_type", "", status);
}

function displayChange_block_1(status) {
	displayChange_field("sms_group", "", status);
	displayChange_field("sms_unique_to", "", status);
	displayChange_field("sms_gateway", "", status);
	displayChange_field("sms_charset", "", status);
	displayChange_field("sms_date_time", "", status);
	displayChange_field("sms_binary", "", status);
	displayChange_field("sms_periody", "", status);
}

function displayChange_block_2(status) {
	displayChange_field("sms_message", "", status);
}

function displayChange_block_3(status) {
	displayChange_field("sms_msg_return", "", status);
}

function displayChange_row(row, status) {
	displayChange_field_sms_send_type(row, status);
	displayChange_field_sms_group(row, status);
	displayChange_field_sms_unique_to(row, status);
	displayChange_field_sms_gateway(row, status);
	displayChange_field_sms_charset(row, status);
	displayChange_field_sms_date_time(row, status);
	displayChange_field_sms_binary(row, status);
	displayChange_field_sms_periody(row, status);
	displayChange_field_sms_message(row, status);
	displayChange_field_sms_msg_return(row, status);
}

function displayChange_field(field, row, status) {
	if ("sms_send_type" == field) {
		displayChange_field_sms_send_type(row, status);
	}
	if ("sms_group" == field) {
		displayChange_field_sms_group(row, status);
	}
	if ("sms_unique_to" == field) {
		displayChange_field_sms_unique_to(row, status);
	}
	if ("sms_gateway" == field) {
		displayChange_field_sms_gateway(row, status);
	}
	if ("sms_charset" == field) {
		displayChange_field_sms_charset(row, status);
	}
	if ("sms_date_time" == field) {
		displayChange_field_sms_date_time(row, status);
	}
	if ("sms_binary" == field) {
		displayChange_field_sms_binary(row, status);
	}
	if ("sms_periody" == field) {
		displayChange_field_sms_periody(row, status);
	}
	if ("sms_message" == field) {
		displayChange_field_sms_message(row, status);
	}
	if ("sms_msg_return" == field) {
		displayChange_field_sms_msg_return(row, status);
	}
}

function displayChange_field_sms_send_type(row, status) {
}

function displayChange_field_sms_group(row, status) {
	if ("on" == status) {
		if ("all" == row) {
			var fieldList = $(".css_sms_group__obj");
			for (var i = 0; i < fieldList.length; i++) {
				$($(fieldList[i]).attr("id")).select2("destroy");
			}
		}
		else {
			$("#id_sc_field_sms_group" + row).select2("destroy");
		}
		scJQSelect2Add(row, "sms_group");
	}
}

function displayChange_field_sms_unique_to(row, status) {
}

function displayChange_field_sms_gateway(row, status) {
	if ("on" == status) {
		if ("all" == row) {
			var fieldList = $(".css_sms_gateway__obj");
			for (var i = 0; i < fieldList.length; i++) {
				$($(fieldList[i]).attr("id")).select2("destroy");
			}
		}
		else {
			$("#id_sc_field_sms_gateway" + row).select2("destroy");
		}
		scJQSelect2Add(row, "sms_gateway");
	}
}

function displayChange_field_sms_charset(row, status) {
	if ("on" == status) {
		if ("all" == row) {
			var fieldList = $(".css_sms_charset__obj");
			for (var i = 0; i < fieldList.length; i++) {
				$($(fieldList[i]).attr("id")).select2("destroy");
			}
		}
		else {
			$("#id_sc_field_sms_charset" + row).select2("destroy");
		}
		scJQSelect2Add(row, "sms_charset");
	}
}

function displayChange_field_sms_date_time(row, status) {
}

function displayChange_field_sms_binary(row, status) {
}

function displayChange_field_sms_periody(row, status) {
}

function displayChange_field_sms_message(row, status) {
}

function displayChange_field_sms_msg_return(row, status) {
}

function scRecreateSelect2() {
	displayChange_field_sms_group("all", "on");
	displayChange_field_sms_gateway("all", "on");
	displayChange_field_sms_charset("all", "on");
}
function scResetPagesDisplay() {
	$(".sc-form-page").show();
}

function scHidePage(pageNo) {
	$("#id_control_sms_group_form" + pageNo).hide();
}

function scCheckNoPageSelected() {
	if (!$(".sc-form-page").filter(".scTabActive").filter(":visible").length) {
		var inactiveTabs = $(".sc-form-page").filter(".scTabInactive").filter(":visible");
		if (inactiveTabs.length) {
			var tabNo = $(inactiveTabs[0]).attr("id").substr(25);
		}
	}
}
function scJQUploadAdd(iSeqRow) {
} // scJQUploadAdd

var api_cache_requests = [];
function ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, hasRun, img_before){
    setTimeout(function(){
        if(img_name == '') return;
        iSeqRow= iSeqRow !== undefined && iSeqRow !== null ? iSeqRow : '';
        var hasVar = p.indexOf('_@NM@_') > -1 || p_cache.indexOf('_@NM@_') > -1 ? true : false;

        p = p.split('_@NM@_');
        $.each(p, function(i,v){
            try{
                p[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p[i] = v;
            }
        });
        p = p.join('');

        p_cache = p_cache.split('_@NM@_');
        $.each(p_cache, function(i,v){
            try{
                p_cache[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p_cache[i] = v;
            }
        });
        p_cache = p_cache.join('');

        img_before = img_before !== undefined ? img_before : $(t).attr('src');
        var str_key_cache = '<?php echo $this->Ini->sc_page; ?>' + img_name+field+p+p_cache;
        if(api_cache_requests[ str_key_cache ] !== undefined && api_cache_requests[ str_key_cache ] !== null){
            if(api_cache_requests[ str_key_cache ] != false){
                do_ajax_check_file(api_cache_requests[ str_key_cache ], field  ,t, iSeqRow);
            }
            return;
        }
        //scAjaxProcOn();
        $(t).attr('src', '<?php echo $this->Ini->path_icones ?>/scriptcase__NM__ajax_load.gif');
        api_cache_requests[ str_key_cache ] = false;
        var rs =$.ajax({
                    type: "POST",
                    url: 'index.php?script_case_init=<?php echo $this->Ini->sc_page; ?>',
                    async: true,
                    data:'nmgp_opcao=ajax_check_file&AjaxCheckImg=' + encodeURI(img_name) +'&rsargs='+ field + '&p=' + p + '&p_cache=' + p_cache,
                    success: function (rs) {
                        if(rs.indexOf('</span>') != -1){
                            rs = rs.substr(rs.indexOf('</span>') + 7);
                        }
                        if(rs.indexOf('/') != -1 && rs.indexOf('/') != 0){
                            rs = rs.substr(rs.indexOf('/'));
                        }
                        rs = sc_trim(rs);

                        // if(rs == 0 && hasVar && hasRun === undefined){
                        //     delete window.api_cache_requests[ str_key_cache ];
                        //     ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, 1, img_before);
                        //     return;
                        // }
                        window.api_cache_requests[ str_key_cache ] = rs;
                        do_ajax_check_file(rs, field  ,t, iSeqRow)
                        if(rs == 0){
                            delete window.api_cache_requests[ str_key_cache ];

                           // $(t).attr('src',img_before);
                            do_ajax_check_file(img_before+'_@@NM@@_' + img_before, field  ,t, iSeqRow)

                        }


                    }
        });
    },100);
}

function do_ajax_check_file(rs, field  ,t, iSeqRow){
    if (rs != 0) {
        rs_split = rs.split('_@@NM@@_');
        rs_orig = rs_split[0];
        rs2 = rs_split[1];
        try{
            if(!$(t).is('img')){

                if($('#id_read_on_'+field+iSeqRow).length > 0 ){
                                    var usa_read_only = false;

                switch(field){

                }
                     if(usa_read_only && $('a',$('#id_read_on_'+field+iSeqRow)).length == 0){
                         $(t).html("<a href=\"javascript:nm_mostra_doc('0', '"+rs2+"', 'control_sms_group')\">"+$('#id_read_on_'+field+iSeqRow).text()+"</a>");
                     }
                }
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href', target.join(','));
                }else{
                    var target = $(t).attr('href').split(',');
                     target[1] = "'"+rs2+"'";
                     $(t).attr('href', target.join(','));
                }
            }else{
                $(t).attr('src', rs2);
                $(t).css('display', '');
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $(t).attr('href', target.join(','));
                }else{
                     var t_link = $(t).parent('a');
                     var target = $(t_link).attr('href').split(',');
                     target[0] = "javascript:nm_mostra_img('"+rs_orig+"'";
                     $(t_link).attr('href', target.join(','));
                }

            }
            eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        } catch(err){
                        eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        }
    }
   /* hasFalseCacheRequest = false;
    $.each(api_cache_requests, function(i,v){
        if(v == false){
            hasFalseCacheRequest = true;
        }
    });
    if(hasFalseCacheRequest == false){
        scAjaxProcOff();
    }*/
}

$(document).ready(function(){
});function scJQSelect2Add(seqRow, specificField) {
  if (null == specificField || "sms_group" == specificField) {
    scJQSelect2Add_sms_group(seqRow);
  }
  if (null == specificField || "sms_gateway" == specificField) {
    scJQSelect2Add_sms_gateway(seqRow);
  }
  if (null == specificField || "sms_charset" == specificField) {
    scJQSelect2Add_sms_charset(seqRow);
  }
} // scJQSelect2Add

function scJQSelect2Add_sms_group(seqRow) {
  var elemSelector = "all" == seqRow ? ".css_sms_group_obj" : "#id_sc_field_sms_group" + seqRow;
  $(elemSelector).select2(
    {
      containerCssClass: 'css_sms_group_obj',
      dropdownCssClass: 'css_sms_group_obj',
      language: {
        noResults: function() {
          return "<?php echo $this->Ini->Nm_lang['lang_autocomp_notfound'] ?>";
        },
        searching: function() {
          return "<?php echo $this->Ini->Nm_lang['lang_autocomp_searching'] ?>";
        }
      }
    }
  );
} // scJQSelect2Add

function scJQSelect2Add_sms_gateway(seqRow) {
  var elemSelector = "all" == seqRow ? ".css_sms_gateway_obj" : "#id_sc_field_sms_gateway" + seqRow;
  $(elemSelector).select2(
    {
      containerCssClass: 'css_sms_gateway_obj',
      dropdownCssClass: 'css_sms_gateway_obj',
      language: {
        noResults: function() {
          return "<?php echo $this->Ini->Nm_lang['lang_autocomp_notfound'] ?>";
        },
        searching: function() {
          return "<?php echo $this->Ini->Nm_lang['lang_autocomp_searching'] ?>";
        }
      }
    }
  );
} // scJQSelect2Add

function scJQSelect2Add_sms_charset(seqRow) {
  var elemSelector = "all" == seqRow ? ".css_sms_charset_obj" : "#id_sc_field_sms_charset" + seqRow;
  $(elemSelector).select2(
    {
      containerCssClass: 'css_sms_charset_obj',
      dropdownCssClass: 'css_sms_charset_obj',
      language: {
        noResults: function() {
          return "<?php echo $this->Ini->Nm_lang['lang_autocomp_notfound'] ?>";
        },
        searching: function() {
          return "<?php echo $this->Ini->Nm_lang['lang_autocomp_searching'] ?>";
        }
      }
    }
  );
} // scJQSelect2Add


function scJQElementsAdd(iLine) {
  scJQEventsAdd(iLine);
  scEventControl_init(iLine);
  scJQUploadAdd(iLine);
  scJQSelect2Add(iLine);
  setTimeout(function () { if ('function' == typeof displayChange_field_sms_group) { displayChange_field_sms_group(iLine, "on"); } }, 150);
  setTimeout(function () { if ('function' == typeof displayChange_field_sms_gateway) { displayChange_field_sms_gateway(iLine, "on"); } }, 150);
  setTimeout(function () { if ('function' == typeof displayChange_field_sms_charset) { displayChange_field_sms_charset(iLine, "on"); } }, 150);
} // scJQElementsAdd

function scGetFileExtension(fileName)
{
    fileNameParts = fileName.split(".");

    if (1 === fileNameParts.length || (2 === fileNameParts.length && "" == fileNameParts[0])) {
        return "";
    }

    return fileNameParts.pop().toLowerCase();
}

function scFormatExtensionSizeErrorMsg(errorMsg)
{
    var msgInfo = errorMsg.split("||"), returnMsg = "";

    if ("err_size" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_size'] ?>. <?php echo $this->Ini->Nm_lang['lang_errm_file_size_extension'] ?>".replace("{SC_EXTENSION}", msgInfo[1]).replace("{SC_LIMIT}", msgInfo[2]);
    } else if ("err_extension" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_invl'] ?>";
    }

    return returnMsg;
}

