
function scJQGeneralAdd() {
  scLoadScInput('input:text.sc-js-input');
  scLoadScInput('input:password.sc-js-input');
  scLoadScInput('input:checkbox.sc-js-input');
  scLoadScInput('input:radio.sc-js-input');
  scLoadScInput('select.sc-js-input');
  scLoadScInput('textarea.sc-js-input');

} // scJQGeneralAdd

function scFocusField(sField) {
  var $oField = $('#id_sc_field_' + sField);

  if (0 == $oField.length) {
    $oField = $('input[name=' + sField + ']');
  }

  if (0 == $oField.length && document.F1.elements[sField]) {
    $oField = $(document.F1.elements[sField]);
  }

  if ($("#id_ac_" + sField).length > 0) {
    if ($oField.hasClass("select2-hidden-accessible")) {
      if (false == scSetFocusOnField($oField)) {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
    else {
      if (false == scSetFocusOnField($oField)) {
        if (false == scSetFocusOnField($("#id_ac_" + sField))) {
          setTimeout(function() { scSetFocusOnField($("#id_ac_" + sField)); }, 500);
        }
      }
      else {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
  }
  else {
    setTimeout(function() { scSetFocusOnField($oField); }, 500);
  }
} // scFocusField

function scSetFocusOnField($oField) {
  if ($oField.length > 0 && $oField[0].offsetHeight > 0 && $oField[0].offsetWidth > 0 && !$oField[0].disabled) {
    $oField[0].focus();
    return true;
  }
  return false;
} // scSetFocusOnField

function scEventControl_init(iSeqRow) {
  scEventControl_data["firstname" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["lastname" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["title" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["birthdate" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["picture" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["country" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["postalcode" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["homephone" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
}

function scEventControl_active(iSeqRow) {
  if (scEventControl_data["firstname" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["firstname" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["lastname" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["lastname" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["title" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["title" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["birthdate" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["birthdate" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["picture" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["picture" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["country" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["country" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["postalcode" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["postalcode" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["homephone" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["homephone" + iSeqRow]["change"]) {
    return true;
  }
  return false;
} // scEventControl_active

function scEventControl_onFocus(oField, iSeq) {
  var fieldId, fieldName;
  fieldId = $(oField).attr("id");
  fieldName = fieldId.substr(12);
  scEventControl_data[fieldName]["blur"] = true;
  scEventControl_data[fieldName]["change"] = false;
} // scEventControl_onFocus

function scEventControl_onBlur(sFieldName) {
  scEventControl_data[sFieldName]["blur"] = false;
  if (scEventControl_data[sFieldName]["change"]) {
        if (scEventControl_data[sFieldName]["original"] == $("#id_sc_field_" + sFieldName).val() || scEventControl_data[sFieldName]["calculated"] == $("#id_sc_field_" + sFieldName).val()) {
          scEventControl_data[sFieldName]["change"] = false;
        }
  }
} // scEventControl_onBlur

function scEventControl_onChange(sFieldName) {
  scEventControl_data[sFieldName]["change"] = false;
} // scEventControl_onChange

function scEventControl_onAutocomp(sFieldName) {
  scEventControl_data[sFieldName]["autocomp"] = false;
} // scEventControl_onChange

var scEventControl_data = {};

function scJQEventsAdd(iSeqRow) {
  $('#id_sc_field_employeeid' + iSeqRow).bind('change', function() { sc_form_employee_upload_employeeid_onchange(this, iSeqRow) });
  $('#id_sc_field_lastname' + iSeqRow).bind('blur', function() { sc_form_employee_upload_lastname_onblur(this, iSeqRow) })
                                      .bind('change', function() { sc_form_employee_upload_lastname_onchange(this, iSeqRow) })
                                      .bind('focus', function() { sc_form_employee_upload_lastname_onfocus(this, iSeqRow) });
  $('#id_sc_field_firstname' + iSeqRow).bind('blur', function() { sc_form_employee_upload_firstname_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_form_employee_upload_firstname_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_form_employee_upload_firstname_onfocus(this, iSeqRow) });
  $('#id_sc_field_title' + iSeqRow).bind('blur', function() { sc_form_employee_upload_title_onblur(this, iSeqRow) })
                                   .bind('change', function() { sc_form_employee_upload_title_onchange(this, iSeqRow) })
                                   .bind('focus', function() { sc_form_employee_upload_title_onfocus(this, iSeqRow) });
  $('#id_sc_field_titleofcourtesy' + iSeqRow).bind('change', function() { sc_form_employee_upload_titleofcourtesy_onchange(this, iSeqRow) });
  $('#id_sc_field_birthdate' + iSeqRow).bind('blur', function() { sc_form_employee_upload_birthdate_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_form_employee_upload_birthdate_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_form_employee_upload_birthdate_onfocus(this, iSeqRow) });
  $('#id_sc_field_hiredate' + iSeqRow).bind('change', function() { sc_form_employee_upload_hiredate_onchange(this, iSeqRow) });
  $('#id_sc_field_country' + iSeqRow).bind('change', function() { sc_form_employee_upload_country_onchange(this, iSeqRow) });
  $('#id_sc_field_regionid' + iSeqRow).bind('change', function() { sc_form_employee_upload_regionid_onchange(this, iSeqRow) });
  $('#id_sc_field_stateid' + iSeqRow).bind('change', function() { sc_form_employee_upload_stateid_onchange(this, iSeqRow) });
  $('#id_sc_field_cityid' + iSeqRow).bind('change', function() { sc_form_employee_upload_cityid_onchange(this, iSeqRow) });
  $('#id_sc_field_postalcode' + iSeqRow).bind('change', function() { sc_form_employee_upload_postalcode_onchange(this, iSeqRow) });
  $('#id_sc_field_address' + iSeqRow).bind('change', function() { sc_form_employee_upload_address_onchange(this, iSeqRow) });
  $('#id_sc_field_homephone' + iSeqRow).bind('change', function() { sc_form_employee_upload_homephone_onchange(this, iSeqRow) });
  $('#id_sc_field_extension' + iSeqRow).bind('change', function() { sc_form_employee_upload_extension_onchange(this, iSeqRow) });
  $('#id_sc_field_photo' + iSeqRow).bind('change', function() { sc_form_employee_upload_photo_onchange(this, iSeqRow) });
  $('#id_sc_field_notes' + iSeqRow).bind('change', function() { sc_form_employee_upload_notes_onchange(this, iSeqRow) });
  $('#id_sc_field_reportsto' + iSeqRow).bind('change', function() { sc_form_employee_upload_reportsto_onchange(this, iSeqRow) });
  $('#id_sc_field_photopath' + iSeqRow).bind('change', function() { sc_form_employee_upload_photopath_onchange(this, iSeqRow) });
  $('#id_sc_field_ssn' + iSeqRow).bind('change', function() { sc_form_employee_upload_ssn_onchange(this, iSeqRow) });
  $('#id_sc_field_picture' + iSeqRow).bind('blur', function() { sc_form_employee_upload_picture_onblur(this, iSeqRow) })
                                     .bind('change', function() { sc_form_employee_upload_picture_onchange(this, iSeqRow) })
                                     .bind('focus', function() { sc_form_employee_upload_picture_onfocus(this, iSeqRow) });
} // scJQEventsAdd

function sc_form_employee_upload_employeeid_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_lastname_onblur(oThis, iSeqRow) {
  do_ajax_form_employee_upload_validate_lastname();
  scCssBlur(oThis);
}

function sc_form_employee_upload_lastname_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_lastname_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_form_employee_upload_firstname_onblur(oThis, iSeqRow) {
  do_ajax_form_employee_upload_validate_firstname();
  scCssBlur(oThis);
}

function sc_form_employee_upload_firstname_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_firstname_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_form_employee_upload_title_onblur(oThis, iSeqRow) {
  do_ajax_form_employee_upload_validate_title();
  scCssBlur(oThis);
}

function sc_form_employee_upload_title_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_title_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_form_employee_upload_titleofcourtesy_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_birthdate_onblur(oThis, iSeqRow) {
  do_ajax_form_employee_upload_validate_birthdate();
  scCssBlur(oThis);
}

function sc_form_employee_upload_birthdate_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_birthdate_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_form_employee_upload_hiredate_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_country_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_regionid_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_stateid_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_cityid_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_postalcode_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_address_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_homephone_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_extension_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_photo_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_notes_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_reportsto_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_photopath_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_ssn_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_picture_onblur(oThis, iSeqRow) {
  scCssBlur(oThis);
}

function sc_form_employee_upload_picture_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_form_employee_upload_picture_onfocus(oThis, iSeqRow) {
  scCssFocus(oThis);
}

function displayChange_block(block, status) {
	if ("0" == block) {
		displayChange_block_0(status);
	}
	if ("1" == block) {
		displayChange_block_1(status);
	}
}

function displayChange_block_0(status) {
	displayChange_field("firstname", "", status);
	displayChange_field("lastname", "", status);
	displayChange_field("title", "", status);
	displayChange_field("birthdate", "", status);
}

function displayChange_block_1(status) {
	displayChange_field("picture", "", status);
}

function displayChange_row(row, status) {
	displayChange_field_firstname(row, status);
	displayChange_field_lastname(row, status);
	displayChange_field_title(row, status);
	displayChange_field_birthdate(row, status);
	displayChange_field_picture(row, status);
	displayChange_field_country(row, status);
	displayChange_field_postalcode(row, status);
	displayChange_field_homephone(row, status);
}

function displayChange_field(field, row, status) {
	if ("firstname" == field) {
		displayChange_field_firstname(row, status);
	}
	if ("lastname" == field) {
		displayChange_field_lastname(row, status);
	}
	if ("title" == field) {
		displayChange_field_title(row, status);
	}
	if ("birthdate" == field) {
		displayChange_field_birthdate(row, status);
	}
	if ("picture" == field) {
		displayChange_field_picture(row, status);
	}
	if ("country" == field) {
		displayChange_field_country(row, status);
	}
	if ("postalcode" == field) {
		displayChange_field_postalcode(row, status);
	}
	if ("homephone" == field) {
		displayChange_field_homephone(row, status);
	}
}

function displayChange_field_firstname(row, status) {
}

function displayChange_field_lastname(row, status) {
}

function displayChange_field_title(row, status) {
}

function displayChange_field_birthdate(row, status) {
}

function displayChange_field_picture(row, status) {
}

function displayChange_field_country(row, status) {
}

function displayChange_field_postalcode(row, status) {
}

function displayChange_field_homephone(row, status) {
}

function scRecreateSelect2() {
}
function scResetPagesDisplay() {
	$(".sc-form-page").show();
}

function scHidePage(pageNo) {
	$("#id_form_employee_upload_form" + pageNo).hide();
}

function scCheckNoPageSelected() {
	if (!$(".sc-form-page").filter(".scTabActive").filter(":visible").length) {
		var inactiveTabs = $(".sc-form-page").filter(".scTabInactive").filter(":visible");
		if (inactiveTabs.length) {
			var tabNo = $(inactiveTabs[0]).attr("id").substr(28);
		}
	}
}
var sc_jq_calendar_value = {};

function scJQCalendarAdd(iSeqRow) {
  $("#id_sc_field_birthdate" + iSeqRow).datepicker({
    beforeShow: function(input, inst) {
      var $oField = $(this),
          aParts  = $oField.val().split(" "),
          sTime   = "";
      sc_jq_calendar_value["#id_sc_field_birthdate" + iSeqRow] = $oField.val();
    },
    onClose: function(dateText, inst) {
      do_ajax_form_employee_upload_validate_birthdate(iSeqRow);
    },
    showWeek: true,
    numberOfMonths: 1,
    changeMonth: true,
    changeYear: true,
    yearRange: 'c-5:c+5',
    dayNames: ["<?php        echo html_entity_decode($this->Ini->Nm_lang['lang_days_sund'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_mond'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_tued'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_wend'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_thud'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_frid'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_satd'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>"],
    dayNamesMin: ["<?php     echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_sund'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_mond'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_tued'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_wend'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_thud'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_frid'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_satd'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>"],
    monthNames: ["<?php      echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_janu"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_febr"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_marc"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_apri"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_mayy"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_june"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_july"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_augu"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_sept"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_octo"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_nove"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_dece"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>"],
    monthNamesShort: ["<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_janu'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_febr'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_marc'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_apri'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_mayy'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_june'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_july'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_augu'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_sept'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_octo'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_nove'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_dece'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>"],
    weekHeader: "<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_days_sem'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>",
    firstDay: <?php echo $this->jqueryCalendarWeekInit("" . $_SESSION['scriptcase']['reg_conf']['date_week_ini'] . ""); ?>,
    dateFormat: "<?php echo $this->jqueryCalendarDtFormat("" . str_replace(array('/', 'aaaa', $_SESSION['scriptcase']['reg_conf']['date_sep']), array('', 'yyyy', ''), $this->field_config['birthdate']['date_format']) . "", "" . $_SESSION['scriptcase']['reg_conf']['date_sep'] . ""); ?>",
    showOtherMonths: true,
    showOn: "button",
<?php
$miniCalendarIcon   = $this->jqueryIconFile('calendar');
$miniCalendarFA     = $this->jqueryFAFile('calendar');
$miniCalendarButton = $this->jqueryButtonText('calendar');
if ('' != $miniCalendarIcon) {
?>
    buttonImage: "<?php echo $miniCalendarIcon; ?>",
    buttonImageOnly: true,
<?php
}
elseif ('' != $miniCalendarFA) {
?>
    buttonText: "<?php echo $miniCalendarFA; ?>",
<?php
}
elseif ('' != $miniCalendarButton[0]) {
?>
    buttonText: "<?php echo $miniCalendarButton[0]; ?>",
<?php
}
?>
    currentText: "<?php  echo html_entity_decode($this->Ini->Nm_lang["lang_per_today"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);       ?>",
    closeText: "<?php  echo html_entity_decode($this->Ini->Nm_lang["lang_btns_mess_clse"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);       ?>",
  });
  $("#id_sc_field_hiredate" + iSeqRow).datepicker({
    beforeShow: function(input, inst) {
      var $oField = $(this),
          aParts  = $oField.val().split(" "),
          sTime   = "";
      sc_jq_calendar_value["#id_sc_field_hiredate" + iSeqRow] = $oField.val();
    },
    onClose: function(dateText, inst) {
      do_ajax_form_employee_upload_validate_hiredate(iSeqRow);
    },
    showWeek: true,
    numberOfMonths: 1,
    changeMonth: true,
    changeYear: true,
    yearRange: 'c-5:c+5',
    dayNames: ["<?php        echo html_entity_decode($this->Ini->Nm_lang['lang_days_sund'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_mond'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_tued'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_wend'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_thud'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_frid'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_days_satd'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);        ?>"],
    dayNamesMin: ["<?php     echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_sund'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_mond'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_tued'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_wend'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_thud'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_frid'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_substr_days_satd'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>"],
    monthNames: ["<?php      echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_janu"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_febr"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_marc"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_apri"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_mayy"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_june"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_july"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_augu"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_sept"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_octo"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_nove"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>","<?php echo html_entity_decode($this->Ini->Nm_lang["lang_mnth_dece"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);      ?>"],
    monthNamesShort: ["<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_janu'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_febr'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_marc'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_apri'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_mayy'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_june'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_july'], ENT_COMPAT, $_SESSION['scriptcase']['charset']);   ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_augu'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_sept'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_octo'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_nove'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>","<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_mnth_dece'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>"],
    weekHeader: "<?php echo html_entity_decode($this->Ini->Nm_lang['lang_shrt_days_sem'], ENT_COMPAT, $_SESSION['scriptcase']['charset']); ?>",
    firstDay: <?php echo $this->jqueryCalendarWeekInit("" . $_SESSION['scriptcase']['reg_conf']['date_week_ini'] . ""); ?>,
    dateFormat: "<?php echo $this->jqueryCalendarDtFormat("" . str_replace(array('/', 'aaaa', $_SESSION['scriptcase']['reg_conf']['date_sep']), array('', 'yyyy', ''), $this->field_config['hiredate']['date_format']) . "", "" . $_SESSION['scriptcase']['reg_conf']['date_sep'] . ""); ?>",
    showOtherMonths: true,
    showOn: "button",
<?php
$miniCalendarIcon   = $this->jqueryIconFile('calendar');
$miniCalendarFA     = $this->jqueryFAFile('calendar');
$miniCalendarButton = $this->jqueryButtonText('calendar');
if ('' != $miniCalendarIcon) {
?>
    buttonImage: "<?php echo $miniCalendarIcon; ?>",
    buttonImageOnly: true,
<?php
}
elseif ('' != $miniCalendarFA) {
?>
    buttonText: "<?php echo $miniCalendarFA; ?>",
<?php
}
elseif ('' != $miniCalendarButton[0]) {
?>
    buttonText: "<?php echo $miniCalendarButton[0]; ?>",
<?php
}
?>
    currentText: "<?php  echo html_entity_decode($this->Ini->Nm_lang["lang_per_today"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);       ?>",
    closeText: "<?php  echo html_entity_decode($this->Ini->Nm_lang["lang_btns_mess_clse"], ENT_COMPAT, $_SESSION["scriptcase"]["charset"]);       ?>",
  });
} // scJQCalendarAdd

function scJQUploadAdd(iSeqRow) {
} // scJQUploadAdd

var api_cache_requests = [];
function ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, hasRun, img_before){
    setTimeout(function(){
        if(img_name == '') return;
        iSeqRow= iSeqRow !== undefined && iSeqRow !== null ? iSeqRow : '';
        var hasVar = p.indexOf('_@NM@_') > -1 || p_cache.indexOf('_@NM@_') > -1 ? true : false;

        p = p.split('_@NM@_');
        $.each(p, function(i,v){
            try{
                p[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p[i] = v;
            }
        });
        p = p.join('');

        p_cache = p_cache.split('_@NM@_');
        $.each(p_cache, function(i,v){
            try{
                p_cache[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p_cache[i] = v;
            }
        });
        p_cache = p_cache.join('');

        img_before = img_before !== undefined ? img_before : $(t).attr('src');
        var str_key_cache = '<?php echo $this->Ini->sc_page; ?>' + img_name+field+p+p_cache;
        if(api_cache_requests[ str_key_cache ] !== undefined && api_cache_requests[ str_key_cache ] !== null){
            if(api_cache_requests[ str_key_cache ] != false){
                do_ajax_check_file(api_cache_requests[ str_key_cache ], field  ,t, iSeqRow);
            }
            return;
        }
        //scAjaxProcOn();
        $(t).attr('src', '<?php echo $this->Ini->path_icones ?>/scriptcase__NM__ajax_load.gif');
        api_cache_requests[ str_key_cache ] = false;
        var rs =$.ajax({
                    type: "POST",
                    url: 'index.php?script_case_init=<?php echo $this->Ini->sc_page; ?>',
                    async: true,
                    data:'nmgp_opcao=ajax_check_file&AjaxCheckImg=' + encodeURI(img_name) +'&rsargs='+ field + '&p=' + p + '&p_cache=' + p_cache,
                    success: function (rs) {
                        if(rs.indexOf('</span>') != -1){
                            rs = rs.substr(rs.indexOf('</span>') + 7);
                        }
                        if(rs.indexOf('/') != -1 && rs.indexOf('/') != 0){
                            rs = rs.substr(rs.indexOf('/'));
                        }
                        rs = sc_trim(rs);

                        // if(rs == 0 && hasVar && hasRun === undefined){
                        //     delete window.api_cache_requests[ str_key_cache ];
                        //     ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, 1, img_before);
                        //     return;
                        // }
                        window.api_cache_requests[ str_key_cache ] = rs;
                        do_ajax_check_file(rs, field  ,t, iSeqRow)
                        if(rs == 0){
                            delete window.api_cache_requests[ str_key_cache ];

                           // $(t).attr('src',img_before);
                            do_ajax_check_file(img_before+'_@@NM@@_' + img_before, field  ,t, iSeqRow)

                        }


                    }
        });
    },100);
}

function do_ajax_check_file(rs, field  ,t, iSeqRow){
    if (rs != 0) {
        rs_split = rs.split('_@@NM@@_');
        rs_orig = rs_split[0];
        rs2 = rs_split[1];
        try{
            if(!$(t).is('img')){

                if($('#id_read_on_'+field+iSeqRow).length > 0 ){
                                    var usa_read_only = false;

                switch(field){

                }
                     if(usa_read_only && $('a',$('#id_read_on_'+field+iSeqRow)).length == 0){
                         $(t).html("<a href=\"javascript:nm_mostra_doc('0', '"+rs2+"', 'form_employee_upload')\">"+$('#id_read_on_'+field+iSeqRow).text()+"</a>");
                     }
                }
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href', target.join(','));
                }else{
                    var target = $(t).attr('href').split(',');
                     target[1] = "'"+rs2+"'";
                     $(t).attr('href', target.join(','));
                }
            }else{
                $(t).attr('src', rs2);
                $(t).css('display', '');
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $(t).attr('href', target.join(','));
                }else{
                     var t_link = $(t).parent('a');
                     var target = $(t_link).attr('href').split(',');
                     target[0] = "javascript:nm_mostra_img('"+rs_orig+"'";
                     $(t_link).attr('href', target.join(','));
                }

            }
            eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        } catch(err){
                        eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        }
    }
   /* hasFalseCacheRequest = false;
    $.each(api_cache_requests, function(i,v){
        if(v == false){
            hasFalseCacheRequest = true;
        }
    });
    if(hasFalseCacheRequest == false){
        scAjaxProcOff();
    }*/
}

$(document).ready(function(){
});<?php

if (isset($GLOBALS['erro_incl']) && 1 == $GLOBALS['erro_incl'] && isset($this->ul_info_picture) && '' != $this->ul_info_picture)
{
    $aTmpUploads = explode('@scl@', $this->ul_info_picture);
?>
var scUploadCount_picture = <?php echo sizeof($aTmpUploads); ?>;
var scUploadQueue_picture = new Array("<?php echo implode('", "', $aTmpUploads); ?>");
<?php
}
else
{
?>
var scUploadCount_picture = 0;
var scUploadQueue_picture = new Array();
<?php
}

?>
var scUploadFiles_picture = 0;
var scFileQ_picture = [];
function scJQMultiUploadAdd(iSeqRow) {
  $("#id_sc_field_picture" + iSeqRow).fileupload({
    datatype: "json",
    url: "form_employee_upload_ul_save.php",
    dropZone: $("#id_sc_dragdrop_picture" + iSeqRow),
    formData: function() {
      return [
        {name: 'param_field', value: 'picture'},
        {name: 'param_seq', value: '<?php echo $this->Ini->sc_page; ?>'},
        {name: 'upload_file_row', value: iSeqRow}
      ];
    },
    add: function (e, data) {
      var checkUploadSize = scCheckUploadExtensionSize_picture(data);
      if ('ok' != checkUploadSize) {
        e.preventDefault();
        scJs_alert(scFormatExtensionSizeErrorMsg(checkUploadSize), function() {}, {'type': 'error'});
        return;
      }
      var $elemSubmit, $divUpload, htmlUpload;
      $elemSubmit = $("#id_sc_submit_picture" + iSeqRow);
      if (!$elemSubmit.hasClass("sc_upload_submit")) {
        $elemSubmit.click(function () {
          data.submit();
        }).add("sc_upload_submit");
      }
      $divUpload = $("#id_sc_upload_todo_picture" + iSeqRow);
      $.each(data.files, function (index, file) {
        var tableUploadId = 'id_sc_file_picture_' + scUploadFiles_picture;
        scFileQ_picture.push(file.name);
        htmlUpload = $("<table id='" + tableUploadId + "' style='border-collapse: collapse; border-width: 0'><tr><td style='padding: 0'><img src='" + sc_img_mupload_pending + "' style='border-width: 0' title='<?php echo $this->Ini->Nm_lang['lang_upload_pending'] ?>' /></td><td class='sc_ui_mu_status_picture' style='padding: 1px 5px 1px 2px; white-space: nowrap'>" + file.name + " <a href='javascript:scJQMultiUploadRemove_picture(\"" + tableUploadId + "\", \"" + file.name + "\")'><img src='<?php echo $this->Ini->path_icones ?>/scriptcase__NM__trash.gif' style='border-width: 0; vertical-align: middle'></a></td><td style='padding: 1px 5px'><?php echo $this->Ini->Nm_lang['lang_errm_mu_pending'] ?></td></table>");
        $divUpload.append(htmlUpload);
        scUploadFiles_picture++;
      });
      sc_mupload_ok = false;
      scJQMultiFixStatus("picture");
    },
    send: function (e, data) {
      if (scFileQ_picture.includes(data.files[0].name)) {
        scFileQ_picture.splice(scFileQ_picture.indexOf(data.files[0].name), 1);
      } else {
        e.preventDefault();
      }
    },
    progressall: function (e, data) {
      var loader, progress;
      if (data.lengthComputable && window.FormData !== undefined) {
        loader = $("#id_img_loader_picture" + iSeqRow);
        progress = parseInt(data.loaded / data.total * 100, 10);
        loader.show().find("div").css("width", progress + "%");
      }
      else {
        loader = $("#id_ajax_loader_picture" + iSeqRow);
        loader.show();
      }
    },
    done: function(e, data) {
      var i, fileData, respData, respPos, respMsg, $loader, $elemSubmit, $divUploadTodo, $divUploadDone, oTemp;
      fileData = null;
      respMsg = "";
      if (data && data.result && data.result[0] && data.result[0].body) {
        respData = data.result[0].body.innerText;
        respPos = respData.indexOf("[{");
        if (-1 !== respPos) {
          respMsg = respData.substr(0, respPos);
          respData = respData.substr(respPos);
          fileData = $.parseJSON(respData);
        }
        else {
          respMsg = respData;
        }
      }
      else {
        respData = data.result;
        respPos = respData.indexOf("[{");
        if (-1 !== respPos) {
          respMsg = respData.substr(0, respPos);
          respData = respData.substr(respPos);
          fileData = eval(respData);
        }
        else {
          respMsg = respData;
        }
      }
      if (window.FormData !== undefined)
      {
        $loader = $("#id_img_loader_picture" + iSeqRow);
        $loader.hide();
      }
      else
      {
        $loader = $("#id_ajax_loader_picture" + iSeqRow);
        $loader.hide();
      }
      if (null == fileData) {
        if ("" != respMsg) {
          oTemp = {"htmOutput" : "<?php echo $this->Ini->Nm_lang['lang_errm_upld_admn']; ?>"};
          scAjaxShowDebug(oTemp);
        }
        return;
      }
      if (fileData[0].error && "" != fileData[0].error) {
        var uploadErrorMessage = fileData[0].error;
        oResp = {};
        if ("acceptFileTypes" == fileData[0].error) {
          uploadErrorMessage = "<?php echo $this->form_encode_input($this->Ini->Nm_lang['lang_errm_file_invl']) ?>";
        }
        else if ("maxFileSize" == fileData[0].error) {
          uploadErrorMessage = "<?php echo $this->form_encode_input($this->Ini->Nm_lang['lang_errm_file_size']) ?>";
        }
        else if ("emptyFile" == fileData[0].error) {
          uploadErrorMessage = "<?php echo $this->form_encode_input($this->Ini->Nm_lang['lang_errm_file_empty']) ?>";
        }
        scAjaxShowErrorDisplay("table", uploadErrorMessage);
        return;
      }
      $elemSubmit = $("#id_sc_submit_picture" + iSeqRow);
      $elemSubmit.unbind("click").removeClass("sc_upload_submit");
      $divUploadTodo = $("#id_sc_upload_todo_picture" + iSeqRow);
      $divUploadTodo.html("");
      $divUploadDone = $("#id_sc_upload_done_picture" + iSeqRow);
      for (i = 0; i < fileData.length; i++) {
        scUploadCount_picture++;
        scUploadQueue_picture.push("add@sci@" + fileData[i].name_prot + "@sci@" + fileData[i].sc_random_prot + "@sci@" + scUploadCount_picture);
        $divUploadDone.html($divUploadDone.html() + "<table id='id_sc_fileok_picture_" + scUploadCount_picture + "' style='border-collapse: collapse; border-width: 0'><tr><td style='padding: 0'><img src='" + sc_img_mupload_finished + "' style='border-width: 0' title='<?php echo $this->Ini->Nm_lang['lang_upload_completed'] ?>' /></td><td class='sc_ui_mu_status_picture' style='padding: 1px 5px 1px 2px; white-space: nowrap'>" + fileData[i].name + "&nbsp;<a href='javascript:scJQMultiUploadCancel_picture(" + scUploadCount_picture + ")'><img src='<?php echo $this->Ini->path_icones ?>/scriptcase__NM__trash.gif' style='border-width: 0; vertical-align: middle'></a></td><td style='padding: 1px 5px'><?php echo $this->Ini->Nm_lang['lang_errm_mu_complete'] ?></td></tr></table>");
      }
      sc_mupload_ok = true;
      scJQMultiFixStatus("picture");
    }
  });

} // scJQMultiUploadAdd

function scJQMultiFixStatus(fieldName) {
  var i, maxWidth = 0, $itemList;
  $itemList = $(".sc_ui_mu_status_" + fieldName);
  for (i = 0; i < $itemList.length; i++) {
    maxWidth = Math.max(maxWidth, $($itemList[i]).width());
  }
  if (0 < maxWidth) {
    $itemList.css("width", maxWidth + "px");
  }
} // scJQMultiFixStatus

function scJQMultiUploadPrepare_picture() {
  var i, $delItems = $(".id_mu_chkbx_picture:checked");
  for (i = 0; i < $delItems.length; i++) {
    scUploadCount_picture++;
    scUploadQueue_picture.push("del@sci@" + $($delItems[i]).val() + "@sci@@sci@" + scUploadCount_picture);
  }
  return scUploadQueue_picture.join("@scl@");
} // scJQMultiUploadPrepare_picture

function scJQMultiUploadCancel_picture(itemIndex) {
  var i, ulInfo;
  for (i = 0; i < scUploadQueue_picture.length; i++) {
    ulInfo = scUploadQueue_picture[i].split("@sci@");
    if (ulInfo[3] == itemIndex) {
      scUploadQueue_picture.splice(i, 1);
      $("#id_sc_fileok_picture_" + itemIndex).hide();
    }
  }
} // scJQMultiUploadCancel_picture

function scJQMultiUploadRemove_picture(tableRow, fileName) {
  if (scFileQ_picture.includes(fileName)) {
    scFileQ_picture.splice(scFileQ_picture.indexOf(fileName), 1);
  }
  $("#" + tableRow).remove();
} // scJQMultiUploadRemove_picture


function scJQElementsAdd(iLine) {
  scJQEventsAdd(iLine);
  scEventControl_init(iLine);
  scJQCalendarAdd(iLine);
  scJQUploadAdd(iLine);
  scJQMultiUploadAdd(iLine);
} // scJQElementsAdd

function scGetFileExtension(fileName)
{
    fileNameParts = fileName.split(".");

    if (1 === fileNameParts.length || (2 === fileNameParts.length && "" == fileNameParts[0])) {
        return "";
    }

    return fileNameParts.pop().toLowerCase();
}

function scFormatExtensionSizeErrorMsg(errorMsg)
{
    var msgInfo = errorMsg.split("||"), returnMsg = "";

    if ("err_size" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_size'] ?>. <?php echo $this->Ini->Nm_lang['lang_errm_file_size_extension'] ?>".replace("{SC_EXTENSION}", msgInfo[1]).replace("{SC_LIMIT}", msgInfo[2]);
    } else if ("err_extension" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_invl'] ?>";
    }

    return returnMsg;
}

function scCheckUploadExtensionSize_picture(thisField)
{
    if ("files" in thisField && thisField.files.length > 0) {
        thisFileExtension = scGetFileExtension(thisField.files[0].name);

        if ("gif" == thisFileExtension && 512000 < thisField.files[0].size) {
            return 'err_size||GIF||500 KB';
        }
        if ("png" == thisFileExtension && 1048576 < thisField.files[0].size) {
            return 'err_size||PNG||1 MB';
        }
        if ("jpg" == thisFileExtension && 1024000 < thisField.files[0].size) {
            return 'err_size||JPG||1000 KB';
        }
        if ("jpeg" == thisFileExtension && 1048576 < thisField.files[0].size) {
            return 'err_size||JPEG||1 MB';
        }

        if (!["gif", "png", "jpg", "jpeg"].includes(thisFileExtension)) {
            return 'err_extension||' + thisFileExtension.toUpperCase();
        }
    }

    return 'ok';
}

