
function scJQGeneralAdd() {
  scLoadScInput('input:text.sc-js-input');
  scLoadScInput('input:password.sc-js-input');
  scLoadScInput('input:checkbox.sc-js-input');
  scLoadScInput('input:radio.sc-js-input');
  scLoadScInput('select.sc-js-input');
  scLoadScInput('textarea.sc-js-input');

} // scJQGeneralAdd

function scFocusField(sField) {
  var $oField = $('#id_sc_field_' + sField);

  if (0 == $oField.length) {
    $oField = $('input[name=' + sField + ']');
  }

  if (0 == $oField.length && document.F1.elements[sField]) {
    $oField = $(document.F1.elements[sField]);
  }

  if ($("#id_ac_" + sField).length > 0) {
    if ($oField.hasClass("select2-hidden-accessible")) {
      if (false == scSetFocusOnField($oField)) {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
    else {
      if (false == scSetFocusOnField($oField)) {
        if (false == scSetFocusOnField($("#id_ac_" + sField))) {
          setTimeout(function() { scSetFocusOnField($("#id_ac_" + sField)); }, 500);
        }
      }
      else {
        setTimeout(function() { scSetFocusOnField($oField); }, 500);
      }
    }
  }
  else {
    setTimeout(function() { scSetFocusOnField($oField); }, 500);
  }
} // scFocusField

function scSetFocusOnField($oField) {
  if ($oField.length > 0 && $oField[0].offsetHeight > 0 && $oField[0].offsetWidth > 0 && !$oField[0].disabled) {
    $oField[0].focus();
    return true;
  }
  return false;
} // scSetFocusOnField

function scEventControl_init(iSeqRow) {
  scEventControl_data["employeeid" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["lastname" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["firstname" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["title" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["titleofcourtesy" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["birthdate" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["hiredate" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["address" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["postalcode" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["country" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
  scEventControl_data["homephone" + iSeqRow] = {"blur": false, "change": false, "autocomp": false, "original": "", "calculated": ""};
}

function scEventControl_active(iSeqRow) {
  if (scEventControl_data["employeeid" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["employeeid" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["lastname" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["lastname" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["firstname" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["firstname" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["title" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["title" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["titleofcourtesy" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["titleofcourtesy" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["birthdate" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["birthdate" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["hiredate" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["hiredate" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["address" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["address" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["postalcode" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["postalcode" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["country" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["country" + iSeqRow]["change"]) {
    return true;
  }
  if (scEventControl_data["homephone" + iSeqRow]["blur"]) {
    return true;
  }
  if (scEventControl_data["homephone" + iSeqRow]["change"]) {
    return true;
  }
  return false;
} // scEventControl_active

function scEventControl_onFocus(oField, iSeq) {
  var fieldId, fieldName;
  fieldId = $(oField).attr("id");
  fieldName = fieldId.substr(12);
  scEventControl_data[fieldName]["blur"] = true;
  scEventControl_data[fieldName]["change"] = false;
} // scEventControl_onFocus

function scEventControl_onBlur(sFieldName) {
  scEventControl_data[sFieldName]["blur"] = false;
  if (scEventControl_data[sFieldName]["change"]) {
        if (scEventControl_data[sFieldName]["original"] == $("#id_sc_field_" + sFieldName).val() || scEventControl_data[sFieldName]["calculated"] == $("#id_sc_field_" + sFieldName).val()) {
          scEventControl_data[sFieldName]["change"] = false;
        }
  }
} // scEventControl_onBlur

function scEventControl_onChange(sFieldName) {
  scEventControl_data[sFieldName]["change"] = false;
} // scEventControl_onChange

function scEventControl_onAutocomp(sFieldName) {
  scEventControl_data[sFieldName]["autocomp"] = false;
} // scEventControl_onChange

var scEventControl_data = {};

function scJQEventsAdd(iSeqRow) {
  $('#id_sc_field_employeeid' + iSeqRow).bind('blur', function() { sc_grid16_1_employeeid_onblur(this, iSeqRow) })
                                        .bind('change', function() { sc_grid16_1_employeeid_onchange(this, iSeqRow) })
                                        .bind('focus', function() { sc_grid16_1_employeeid_onfocus(this, iSeqRow) });
  $('#id_sc_field_lastname' + iSeqRow).bind('blur', function() { sc_grid16_1_lastname_onblur(this, iSeqRow) })
                                      .bind('change', function() { sc_grid16_1_lastname_onchange(this, iSeqRow) })
                                      .bind('focus', function() { sc_grid16_1_lastname_onfocus(this, iSeqRow) });
  $('#id_sc_field_firstname' + iSeqRow).bind('blur', function() { sc_grid16_1_firstname_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_grid16_1_firstname_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_grid16_1_firstname_onfocus(this, iSeqRow) });
  $('#id_sc_field_title' + iSeqRow).bind('blur', function() { sc_grid16_1_title_onblur(this, iSeqRow) })
                                   .bind('change', function() { sc_grid16_1_title_onchange(this, iSeqRow) })
                                   .bind('focus', function() { sc_grid16_1_title_onfocus(this, iSeqRow) });
  $('#id_sc_field_titleofcourtesy' + iSeqRow).bind('blur', function() { sc_grid16_1_titleofcourtesy_onblur(this, iSeqRow) })
                                             .bind('change', function() { sc_grid16_1_titleofcourtesy_onchange(this, iSeqRow) })
                                             .bind('focus', function() { sc_grid16_1_titleofcourtesy_onfocus(this, iSeqRow) });
  $('#id_sc_field_birthdate' + iSeqRow).bind('blur', function() { sc_grid16_1_birthdate_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_grid16_1_birthdate_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_grid16_1_birthdate_onfocus(this, iSeqRow) });
  $('#id_sc_field_hiredate' + iSeqRow).bind('blur', function() { sc_grid16_1_hiredate_onblur(this, iSeqRow) })
                                      .bind('change', function() { sc_grid16_1_hiredate_onchange(this, iSeqRow) })
                                      .bind('focus', function() { sc_grid16_1_hiredate_onfocus(this, iSeqRow) });
  $('#id_sc_field_country' + iSeqRow).bind('blur', function() { sc_grid16_1_country_onblur(this, iSeqRow) })
                                     .bind('change', function() { sc_grid16_1_country_onchange(this, iSeqRow) })
                                     .bind('focus', function() { sc_grid16_1_country_onfocus(this, iSeqRow) });
  $('#id_sc_field_regionid' + iSeqRow).bind('change', function() { sc_grid16_1_regionid_onchange(this, iSeqRow) });
  $('#id_sc_field_stateid' + iSeqRow).bind('change', function() { sc_grid16_1_stateid_onchange(this, iSeqRow) });
  $('#id_sc_field_cityid' + iSeqRow).bind('change', function() { sc_grid16_1_cityid_onchange(this, iSeqRow) });
  $('#id_sc_field_postalcode' + iSeqRow).bind('blur', function() { sc_grid16_1_postalcode_onblur(this, iSeqRow) })
                                        .bind('change', function() { sc_grid16_1_postalcode_onchange(this, iSeqRow) })
                                        .bind('focus', function() { sc_grid16_1_postalcode_onfocus(this, iSeqRow) });
  $('#id_sc_field_address' + iSeqRow).bind('blur', function() { sc_grid16_1_address_onblur(this, iSeqRow) })
                                     .bind('change', function() { sc_grid16_1_address_onchange(this, iSeqRow) })
                                     .bind('focus', function() { sc_grid16_1_address_onfocus(this, iSeqRow) });
  $('#id_sc_field_homephone' + iSeqRow).bind('blur', function() { sc_grid16_1_homephone_onblur(this, iSeqRow) })
                                       .bind('change', function() { sc_grid16_1_homephone_onchange(this, iSeqRow) })
                                       .bind('focus', function() { sc_grid16_1_homephone_onfocus(this, iSeqRow) });
  $('#id_sc_field_extension' + iSeqRow).bind('change', function() { sc_grid16_1_extension_onchange(this, iSeqRow) });
  $('#id_sc_field_photo' + iSeqRow).bind('change', function() { sc_grid16_1_photo_onchange(this, iSeqRow) });
  $('#id_sc_field_notes' + iSeqRow).bind('change', function() { sc_grid16_1_notes_onchange(this, iSeqRow) });
  $('#id_sc_field_reportsto' + iSeqRow).bind('change', function() { sc_grid16_1_reportsto_onchange(this, iSeqRow) });
  $('#id_sc_field_photopath' + iSeqRow).bind('change', function() { sc_grid16_1_photopath_onchange(this, iSeqRow) });
} // scJQEventsAdd

function sc_grid16_1_employeeid_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_employeeid();
  scCssBlur(oThis);
}

function sc_grid16_1_employeeid_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_employeeid_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_lastname_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_lastname();
  scCssBlur(oThis);
}

function sc_grid16_1_lastname_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_lastname_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_firstname_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_firstname();
  scCssBlur(oThis);
}

function sc_grid16_1_firstname_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_firstname_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_title_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_title();
  scCssBlur(oThis);
}

function sc_grid16_1_title_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_title_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_titleofcourtesy_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_titleofcourtesy();
  scCssBlur(oThis);
}

function sc_grid16_1_titleofcourtesy_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_titleofcourtesy_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_birthdate_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_birthdate();
  scCssBlur(oThis);
}

function sc_grid16_1_birthdate_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_birthdate_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_hiredate_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_hiredate();
  scCssBlur(oThis);
}

function sc_grid16_1_hiredate_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_hiredate_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_country_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_country();
  scCssBlur(oThis);
}

function sc_grid16_1_country_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_country_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_regionid_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_stateid_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_cityid_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_postalcode_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_postalcode();
  scCssBlur(oThis);
}

function sc_grid16_1_postalcode_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_postalcode_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_address_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_address();
  scCssBlur(oThis);
}

function sc_grid16_1_address_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_address_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_homephone_onblur(oThis, iSeqRow) {
  do_ajax_grid16_1_validate_homephone();
  scCssBlur(oThis);
}

function sc_grid16_1_homephone_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_homephone_onfocus(oThis, iSeqRow) {
  scEventControl_onFocus(oThis, iSeqRow);
  scCssFocus(oThis);
}

function sc_grid16_1_extension_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_photo_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_notes_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_reportsto_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function sc_grid16_1_photopath_onchange(oThis, iSeqRow) {
  scMarkFormAsChanged();
}

function displayChange_block(block, status) {
	if ("0" == block) {
		displayChange_block_0(status);
	}
	if ("1" == block) {
		displayChange_block_1(status);
	}
	if ("2" == block) {
		displayChange_block_2(status);
	}
}

function displayChange_block_0(status) {
	displayChange_field("employeeid", "", status);
}

function displayChange_block_1(status) {
	displayChange_field("lastname", "", status);
	displayChange_field("firstname", "", status);
	displayChange_field("title", "", status);
	displayChange_field("titleofcourtesy", "", status);
	displayChange_field("birthdate", "", status);
	displayChange_field("hiredate", "", status);
	displayChange_field("address", "", status);
	displayChange_field("postalcode", "", status);
}

function displayChange_block_2(status) {
	displayChange_field("country", "", status);
	displayChange_field("homephone", "", status);
}

function displayChange_row(row, status) {
	displayChange_field_employeeid(row, status);
	displayChange_field_lastname(row, status);
	displayChange_field_firstname(row, status);
	displayChange_field_title(row, status);
	displayChange_field_titleofcourtesy(row, status);
	displayChange_field_birthdate(row, status);
	displayChange_field_hiredate(row, status);
	displayChange_field_address(row, status);
	displayChange_field_postalcode(row, status);
	displayChange_field_country(row, status);
	displayChange_field_homephone(row, status);
}

function displayChange_field(field, row, status) {
	if ("employeeid" == field) {
		displayChange_field_employeeid(row, status);
	}
	if ("lastname" == field) {
		displayChange_field_lastname(row, status);
	}
	if ("firstname" == field) {
		displayChange_field_firstname(row, status);
	}
	if ("title" == field) {
		displayChange_field_title(row, status);
	}
	if ("titleofcourtesy" == field) {
		displayChange_field_titleofcourtesy(row, status);
	}
	if ("birthdate" == field) {
		displayChange_field_birthdate(row, status);
	}
	if ("hiredate" == field) {
		displayChange_field_hiredate(row, status);
	}
	if ("address" == field) {
		displayChange_field_address(row, status);
	}
	if ("postalcode" == field) {
		displayChange_field_postalcode(row, status);
	}
	if ("country" == field) {
		displayChange_field_country(row, status);
	}
	if ("homephone" == field) {
		displayChange_field_homephone(row, status);
	}
}

function displayChange_field_employeeid(row, status) {
}

function displayChange_field_lastname(row, status) {
}

function displayChange_field_firstname(row, status) {
}

function displayChange_field_title(row, status) {
}

function displayChange_field_titleofcourtesy(row, status) {
}

function displayChange_field_birthdate(row, status) {
}

function displayChange_field_hiredate(row, status) {
}

function displayChange_field_address(row, status) {
}

function displayChange_field_postalcode(row, status) {
}

function displayChange_field_country(row, status) {
}

function displayChange_field_homephone(row, status) {
}

function scRecreateSelect2() {
}
function scResetPagesDisplay() {
	$(".sc-form-page").show();
}

function scHidePage(pageNo) {
	$("#id_grid16_1_form" + pageNo).hide();
}

function scCheckNoPageSelected() {
	if (!$(".sc-form-page").filter(".scTabActive").filter(":visible").length) {
		var inactiveTabs = $(".sc-form-page").filter(".scTabInactive").filter(":visible");
		if (inactiveTabs.length) {
			var tabNo = $(inactiveTabs[0]).attr("id").substr(16);
		}
	}
}
function scJQUploadAdd(iSeqRow) {
} // scJQUploadAdd

var api_cache_requests = [];
function ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, hasRun, img_before){
    setTimeout(function(){
        if(img_name == '') return;
        iSeqRow= iSeqRow !== undefined && iSeqRow !== null ? iSeqRow : '';
        var hasVar = p.indexOf('_@NM@_') > -1 || p_cache.indexOf('_@NM@_') > -1 ? true : false;

        p = p.split('_@NM@_');
        $.each(p, function(i,v){
            try{
                p[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p[i] = v;
            }
        });
        p = p.join('');

        p_cache = p_cache.split('_@NM@_');
        $.each(p_cache, function(i,v){
            try{
                p_cache[i] = $('[name='+v+iSeqRow+']').val();
            }
            catch(err){
                p_cache[i] = v;
            }
        });
        p_cache = p_cache.join('');

        img_before = img_before !== undefined ? img_before : $(t).attr('src');
        var str_key_cache = '<?php echo $this->Ini->sc_page; ?>' + img_name+field+p+p_cache;
        if(api_cache_requests[ str_key_cache ] !== undefined && api_cache_requests[ str_key_cache ] !== null){
            if(api_cache_requests[ str_key_cache ] != false){
                do_ajax_check_file(api_cache_requests[ str_key_cache ], field  ,t, iSeqRow);
            }
            return;
        }
        //scAjaxProcOn();
        $(t).attr('src', '<?php echo $this->Ini->path_icones ?>/scriptcase__NM__ajax_load.gif');
        api_cache_requests[ str_key_cache ] = false;
        var rs =$.ajax({
                    type: "POST",
                    url: 'index.php?script_case_init=<?php echo $this->Ini->sc_page; ?>',
                    async: true,
                    data:'nmgp_opcao=ajax_check_file&AjaxCheckImg=' + encodeURI(img_name) +'&rsargs='+ field + '&p=' + p + '&p_cache=' + p_cache,
                    success: function (rs) {
                        if(rs.indexOf('</span>') != -1){
                            rs = rs.substr(rs.indexOf('</span>') + 7);
                        }
                        if(rs.indexOf('/') != -1 && rs.indexOf('/') != 0){
                            rs = rs.substr(rs.indexOf('/'));
                        }
                        rs = sc_trim(rs);

                        // if(rs == 0 && hasVar && hasRun === undefined){
                        //     delete window.api_cache_requests[ str_key_cache ];
                        //     ajax_check_file(img_name, field  ,t, p, p_cache, iSeqRow, 1, img_before);
                        //     return;
                        // }
                        window.api_cache_requests[ str_key_cache ] = rs;
                        do_ajax_check_file(rs, field  ,t, iSeqRow)
                        if(rs == 0){
                            delete window.api_cache_requests[ str_key_cache ];

                           // $(t).attr('src',img_before);
                            do_ajax_check_file(img_before+'_@@NM@@_' + img_before, field  ,t, iSeqRow)

                        }


                    }
        });
    },100);
}

function do_ajax_check_file(rs, field  ,t, iSeqRow){
    if (rs != 0) {
        rs_split = rs.split('_@@NM@@_');
        rs_orig = rs_split[0];
        rs2 = rs_split[1];
        try{
            if(!$(t).is('img')){

                if($('#id_read_on_'+field+iSeqRow).length > 0 ){
                                    var usa_read_only = false;

                switch(field){

                }
                     if(usa_read_only && $('a',$('#id_read_on_'+field+iSeqRow)).length == 0){
                         $(t).html("<a href=\"javascript:nm_mostra_doc('0', '"+rs2+"', 'grid16_1')\">"+$('#id_read_on_'+field+iSeqRow).text()+"</a>");
                     }
                }
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href', target.join(','));
                }else{
                    var target = $(t).attr('href').split(',');
                     target[1] = "'"+rs2+"'";
                     $(t).attr('href', target.join(','));
                }
            }else{
                $(t).attr('src', rs2);
                $(t).css('display', '');
                if($('#id_ajax_doc_'+field+iSeqRow+' a').length > 0){
                    var target = $('#id_ajax_doc_'+field+iSeqRow+' a').attr('href').split(',');
                    target[1] = "'"+rs2+"'";
                    $(t).attr('href', target.join(','));
                }else{
                     var t_link = $(t).parent('a');
                     var target = $(t_link).attr('href').split(',');
                     target[0] = "javascript:nm_mostra_img('"+rs_orig+"'";
                     $(t_link).attr('href', target.join(','));
                }

            }
            eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        } catch(err){
                        eval("window.var_ajax_img_"+field+iSeqRow+" = '"+rs_orig+"';");

        }
    }
   /* hasFalseCacheRequest = false;
    $.each(api_cache_requests, function(i,v){
        if(v == false){
            hasFalseCacheRequest = true;
        }
    });
    if(hasFalseCacheRequest == false){
        scAjaxProcOff();
    }*/
}

$(document).ready(function(){
});
function scJQElementsAdd(iLine) {
  scJQEventsAdd(iLine);
  scEventControl_init(iLine);
  scJQUploadAdd(iLine);
} // scJQElementsAdd

function scGetFileExtension(fileName)
{
    fileNameParts = fileName.split(".");

    if (1 === fileNameParts.length || (2 === fileNameParts.length && "" == fileNameParts[0])) {
        return "";
    }

    return fileNameParts.pop().toLowerCase();
}

function scFormatExtensionSizeErrorMsg(errorMsg)
{
    var msgInfo = errorMsg.split("||"), returnMsg = "";

    if ("err_size" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_size'] ?>. <?php echo $this->Ini->Nm_lang['lang_errm_file_size_extension'] ?>".replace("{SC_EXTENSION}", msgInfo[1]).replace("{SC_LIMIT}", msgInfo[2]);
    } else if ("err_extension" == msgInfo[0]) {
        returnMsg = "<?php echo $this->Ini->Nm_lang['lang_errm_file_invl'] ?>";
    }

    return returnMsg;
}

