<?php
class pdf01_grid
{
   var $Ini;
   var $Erro;
   var $Pdf;
   var $Db;
   var $rs_grid;
   var $nm_grid_sem_reg;
   var $SC_seq_register;
   var $nm_location;
   var $nm_data;
   var $nm_cod_barra;
   var $sc_proc_grid; 
   var $nmgp_botoes = array();
   var $Campos_Mens_erro;
   var $NM_raiz_img; 
   var $Font_ttf; 
   var $array_itens_productid = array();
   var $itens = array();
   var $itens_productid = array();
   var $itens_unitprice = array();
   var $itens_quantity = array();
   var $itens_discount = array();
   var $itens_totalprice = array();
   var $orderid = array();
   var $customerid = array();
//--- 
 function monta_grid($linhas = 0)
 {

   clearstatcache();
   $this->inicializa();
   $this->grid();
 }
//--- 
 function inicializa()
 {
   global $nm_saida, 
   $rec, $nmgp_chave, $nmgp_opcao, $nmgp_ordem, $nmgp_chave_det, 
   $nmgp_quant_linhas, $nmgp_quant_colunas, $nmgp_url_saida, $nmgp_parms;
//
   $this->nm_data = new nm_data("en_us");
   include_once("../_lib/lib/php/nm_font_tcpdf.php");
   $this->default_font = '';
   $this->default_font_sr  = 'Helvetica';
   $this->default_style    = '';
   $this->default_style_sr = 'B';
   $Tp_papel = "A4";
   $old_dir = getcwd();
   $File_font_ttf     = "";
   $temp_font_ttf     = "";
   $this->Font_ttf    = false;
   $this->Font_ttf_sr = false;
   if (empty($this->default_font) && isset($arr_font_tcpdf[$this->Ini->str_lang]))
   {
       $this->default_font = $arr_font_tcpdf[$this->Ini->str_lang];
   }
   elseif (empty($this->default_font))
   {
       $this->default_font = "Times";
   }
   if (empty($this->default_font_sr) && isset($arr_font_tcpdf[$this->Ini->str_lang]))
   {
       $this->default_font_sr = $arr_font_tcpdf[$this->Ini->str_lang];
   }
   elseif (empty($this->default_font_sr))
   {
       $this->default_font_sr = "Times";
   }
   $_SESSION['scriptcase']['pdf01']['default_font'] = $this->default_font;
   chdir($this->Ini->path_third . "/tcpdf/");
   include_once("tcpdf.php");
   chdir($old_dir);
   include_once($this->Ini->path_aplicacao . "pdf01_head_foot.php"); 
   $this->Pdf = new Header_Footer('P', 'mm', $Tp_papel, true, 'UTF-8', false);
   $this->Pdf->Db   = $this->Db;
   $this->Pdf->Erro = $this->Erro;
   if (!empty($File_font_ttf))
   {
       $this->Pdf->addTTFfont($File_font_ttf, "", "", 32, $_SESSION['scriptcase']['dir_temp'] . "/");
   }
   $this->Pdf->SetDisplayMode('real');
   $this->aba_iframe = false;
   if (isset($_SESSION['scriptcase']['sc_aba_iframe']))
   {
       foreach ($_SESSION['scriptcase']['sc_aba_iframe'] as $aba => $apls_aba)
       {
           if (in_array("pdf01", $apls_aba))
           {
               $this->aba_iframe = true;
               break;
           }
       }
   }
   if ($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['iframe_menu'] && (!isset($_SESSION['scriptcase']['menu_mobile']) || empty($_SESSION['scriptcase']['menu_mobile'])))
   {
       $this->aba_iframe = true;
   }
   $this->nmgp_botoes['exit'] = "off";
   $this->sc_proc_grid = false; 
   $this->NM_raiz_img = $this->Ini->root;
   $_SESSION['scriptcase']['sc_sql_ult_conexao'] = ''; 
   $this->nm_where_dinamico = "";
   $this->nm_grid_colunas = 0;
   if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['campos_busca']) && !empty($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['campos_busca']))
   { 
       $Busca_temp = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['campos_busca'];
       if ($_SESSION['scriptcase']['charset'] != "UTF-8")
       {
           $Busca_temp = NM_conv_charset($Busca_temp, $_SESSION['scriptcase']['charset'], "UTF-8");
       }
       $this->orderid[0] = $Busca_temp['orderid']; 
       $tmp_pos = strpos($this->orderid[0], "##@@");
       if ($tmp_pos !== false && !is_array($this->orderid[0]))
       {
           $this->orderid[0] = substr($this->orderid[0], 0, $tmp_pos);
       }
       $this->customerid[0] = $Busca_temp['customerid']; 
       $tmp_pos = strpos($this->customerid[0], "##@@");
       if ($tmp_pos !== false && !is_array($this->customerid[0]))
       {
           $this->customerid[0] = substr($this->customerid[0], 0, $tmp_pos);
       }
   } 
   $this->nm_field_dinamico = array();
   $this->nm_order_dinamico = array();
   $this->sc_where_orig   = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_orig'];
   $this->sc_where_atual  = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq'];
   $this->sc_where_filtro = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq_filtro'];
   $dir_raiz          = strrpos($_SERVER['PHP_SELF'],"/") ;  
   $dir_raiz          = substr($_SERVER['PHP_SELF'], 0, $dir_raiz + 1) ;  
   $this->nm_location = $this->Ini->sc_protocolo . $this->Ini->server . $dir_raiz; 
   $_SESSION['scriptcase']['contr_link_emb'] = $this->nm_location;
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['qt_col_grid'] = 1 ;  
   if (isset($_SESSION['scriptcase']['sc_apl_conf']['pdf01']['cols']) && !empty($_SESSION['scriptcase']['sc_apl_conf']['pdf01']['cols']))
   {
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['qt_col_grid'] = $_SESSION['scriptcase']['sc_apl_conf']['pdf01']['cols'];  
       unset($_SESSION['scriptcase']['sc_apl_conf']['pdf01']['cols']);
   }
   if (!isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_select']))  
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_select'] = array(); 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_select_orig'] = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_select']; 
   } 
   if (!isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_quebra']))  
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_grid'] = "" ; 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_ant']  = ""; 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_desc'] = "" ; 
   }   
   if (!empty($nmgp_parms) && $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['opcao'] != "pdf")   
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['opcao'] = "igual";
       $rec = "ini";
   }
   if (!isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_orig']) || $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['prim_cons'] || !empty($nmgp_parms))  
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['prim_cons'] = false;  
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_orig'] = "";  
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq']        = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_orig'];  
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq_ant']    = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_orig'];  
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['cond_pesq']         = ""; 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq_filtro'] = "";
   }   
   if  (!empty($this->nm_where_dinamico)) 
   {   
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq'] .= $this->nm_where_dinamico;
   }   
   $this->sc_where_orig   = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_orig'];
   $this->sc_where_atual  = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq'];
   $this->sc_where_filtro = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq_filtro'];
//
   if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['tot_geral'][1])) 
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['sc_total'] = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['tot_geral'][1] ;  
   }
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq_ant'] = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq'];  
//----- 
   if (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_sybase))
   { 
       $nmgp_select = "SELECT orderid, customerid from " . $this->Ini->nm_tabela; 
   } 
   elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_mysql))
   { 
       $nmgp_select = "SELECT orderid, customerid from " . $this->Ini->nm_tabela; 
   } 
   elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_mssql))
   { 
       $nmgp_select = "SELECT orderid, customerid from " . $this->Ini->nm_tabela; 
   } 
   elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_oracle))
   { 
       $nmgp_select = "SELECT orderid, customerid from " . $this->Ini->nm_tabela; 
   } 
   elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_informix))
   { 
       $nmgp_select = "SELECT orderid, customerid from " . $this->Ini->nm_tabela; 
   } 
   else 
   { 
       $nmgp_select = "SELECT orderid, customerid from " . $this->Ini->nm_tabela; 
   } 
   $nmgp_select .= " " . $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq']; 
   $nmgp_order_by = ""; 
   $campos_order_select = "";
   foreach($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_select'] as $campo => $ordem) 
   {
        if ($campo != $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_grid']) 
        {
           if (!empty($campos_order_select)) 
           {
               $campos_order_select .= ", ";
           }
           $campos_order_select .= $campo . " " . $ordem;
        }
   }
   if (!empty($_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_grid'])) 
   { 
       $nmgp_order_by = " order by " . $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_grid'] . $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['ordem_desc']; 
   } 
   if (!empty($campos_order_select)) 
   { 
       if (!empty($nmgp_order_by)) 
       { 
          $nmgp_order_by .= ", " . $campos_order_select; 
       } 
       else 
       { 
          $nmgp_order_by = " order by $campos_order_select"; 
       } 
   } 
   $nmgp_select .= $nmgp_order_by; 
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['order_grid'] = $nmgp_order_by;
   $_SESSION['scriptcase']['sc_sql_ult_comando'] = $nmgp_select; 
   $this->rs_grid = $this->Db->Execute($nmgp_select) ; 
   if ($this->rs_grid === false && !$this->rs_grid->EOF && $GLOBALS["NM_ERRO_IBASE"] != 1) 
   { 
       $this->Erro->mensagem(__FILE__, __LINE__, "banco", $this->Ini->Nm_lang['lang_errm_dber'], $this->Db->ErrorMsg()); 
       exit ; 
   }  
   if ($this->rs_grid->EOF || ($this->rs_grid === false && $GLOBALS["NM_ERRO_IBASE"] == 1)) 
   { 
       $this->nm_grid_sem_reg = $this->SC_conv_utf8($this->Ini->Nm_lang['lang_errm_empt']); 
   }  
// 
 }  
// 
 function Pdf_init()
 {
     if ($_SESSION['scriptcase']['reg_conf']['css_dir'] == "RTL")
     {
         $this->Pdf->setRTL(true);
     }
     $this->Pdf->setHeaderMargin(0);
     $this->Pdf->setFooterMargin(0);
     if ($this->Font_ttf)
     {
         $this->Pdf->SetFont($this->default_font, $this->default_style, 12, $this->def_TTF);
     }
     else
     {
         $this->Pdf->SetFont($this->default_font, $this->default_style, 12);
     }
     $this->Pdf->SetTextColor(0, 0, 0);
 }
// 
//----- 
 function grid($linhas = 0)
 {
    global 
           $nm_saida, $nm_url_saida;
   $HTTP_REFERER = (isset($_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : ""; 
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['seq_dir'] = 0; 
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['sub_dir'] = array(); 
   $this->sc_where_orig   = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_orig'];
   $this->sc_where_atual  = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq'];
   $this->sc_where_filtro = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['where_pesq_filtro'];
   if (isset($_SESSION['scriptcase']['sc_apl_conf']['pdf01']['lig_edit']) && $_SESSION['scriptcase']['sc_apl_conf']['pdf01']['lig_edit'] != '')
   {
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['mostra_edit'] = $_SESSION['scriptcase']['sc_apl_conf']['pdf01']['lig_edit'];
   }
   if (!empty($this->nm_grid_sem_reg))
   {
       $this->Pdf_init();
       $this->Pdf->AddPage();
       if ($this->Font_ttf_sr)
       {
           $this->Pdf->SetFont($this->default_font_sr, 'B', 12, $this->def_TTF);
       }
       else
       {
           $this->Pdf->SetFont($this->default_font_sr, 'B', 12);
       }
       $this->Pdf->SetTextColor(0, 0, 0);
       $this->Pdf->Text(10, 10, html_entity_decode($this->nm_grid_sem_reg, ENT_COMPAT, $_SESSION['scriptcase']['charset']));
       $this->Pdf->Output($this->Ini->root . $this->Ini->nm_path_pdf, 'F');
       return;
   }
// 
   $Init_Pdf = true;
   $this->SC_seq_register = 0; 
   while (!$this->rs_grid->EOF) 
   {  
      $this->nm_grid_colunas = 0; 
      $nm_quant_linhas = 0;
      while (!$this->rs_grid->EOF && $nm_quant_linhas < $_SESSION['sc_session'][$this->Ini->sc_page]['pdf01']['qt_col_grid']) 
      {  
          $this->sc_proc_grid = true;
          $this->SC_seq_register++; 
          $this->orderid[$this->nm_grid_colunas] = $this->rs_grid->fields[0] ;  
          $this->orderid[$this->nm_grid_colunas] = (string)$this->orderid[$this->nm_grid_colunas];
          $this->customerid[$this->nm_grid_colunas] = $this->rs_grid->fields[1] ;  
          $this->itens_productid[$this->nm_grid_colunas] = array();
          $this->itens_unitprice[$this->nm_grid_colunas] = array();
          $this->itens_quantity[$this->nm_grid_colunas] = array();
          $this->itens_discount[$this->nm_grid_colunas] = array();
          $this->itens_totalprice[$this->nm_grid_colunas] = array();
          $this->Lookup->lookup_itens($this->itens[$this->nm_grid_colunas] , $this->orderid[$this->nm_grid_colunas], $array_itens); 
          $NM_ind = 0;
          $this->itens = array();
          foreach ($array_itens as $cada_subselect) 
          {
              $this->itens[$this->nm_grid_colunas][$NM_ind] = "";
              $this->itens_productid[$this->nm_grid_colunas][$NM_ind] = $cada_subselect[0];
              $this->itens_unitprice[$this->nm_grid_colunas][$NM_ind] = $cada_subselect[1];
              $this->itens_quantity[$this->nm_grid_colunas][$NM_ind] = $cada_subselect[2];
              $this->itens_discount[$this->nm_grid_colunas][$NM_ind] = $cada_subselect[3];
              $this->itens_totalprice[$this->nm_grid_colunas][$NM_ind] = $cada_subselect[4];
              $NM_ind++;
          }
          $this->orderid[$this->nm_grid_colunas] = sc_strip_script($this->orderid[$this->nm_grid_colunas]);
          if ($this->orderid[$this->nm_grid_colunas] === "") 
          { 
              $this->orderid[$this->nm_grid_colunas] = "" ;  
          } 
          else    
          { 
              nmgp_Form_Num_Val($this->orderid[$this->nm_grid_colunas], ".", "", "0", "S", "2", "", "N:4", "-") ; 
          } 
          $this->orderid[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->orderid[$this->nm_grid_colunas]);
          $this->Lookup->lookup_customerid($this->customerid[$this->nm_grid_colunas] , $this->customerid[$this->nm_grid_colunas]) ; 
          $this->customerid[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->customerid[$this->nm_grid_colunas]);
          foreach ($this->itens_productid[$this->nm_grid_colunas] as $NM_ind => $Dados) 
          {
              $this->Lookup->lookup_itens_productid($this->itens_productid[$this->nm_grid_colunas][$NM_ind] , $this->itens_productid[$this->nm_grid_colunas][$NM_ind], $array_itens_productid) ; 
              $this->itens_productid[$this->nm_grid_colunas][$NM_ind] = $this->SC_conv_utf8($this->itens_productid[$this->nm_grid_colunas][$NM_ind]);
          }
          foreach ($this->itens_unitprice[$this->nm_grid_colunas] as $NM_ind => $Dados) 
          {
          if ($this->itens_unitprice[$this->nm_grid_colunas][$NM_ind] === "") 
          { 
              $this->itens_unitprice[$this->nm_grid_colunas][$NM_ind] = "" ;  
          } 
              $this->itens_unitprice[$this->nm_grid_colunas][$NM_ind] = $this->SC_conv_utf8($this->itens_unitprice[$this->nm_grid_colunas][$NM_ind]);
          }
          foreach ($this->itens_quantity[$this->nm_grid_colunas] as $NM_ind => $Dados) 
          {
          if ($this->itens_quantity[$this->nm_grid_colunas][$NM_ind] === "") 
          { 
              $this->itens_quantity[$this->nm_grid_colunas][$NM_ind] = "" ;  
          } 
              $this->itens_quantity[$this->nm_grid_colunas][$NM_ind] = $this->SC_conv_utf8($this->itens_quantity[$this->nm_grid_colunas][$NM_ind]);
          }
          foreach ($this->itens_discount[$this->nm_grid_colunas] as $NM_ind => $Dados) 
          {
          if ($this->itens_discount[$this->nm_grid_colunas][$NM_ind] === "") 
          { 
              $this->itens_discount[$this->nm_grid_colunas][$NM_ind] = "" ;  
          } 
              $this->itens_discount[$this->nm_grid_colunas][$NM_ind] = $this->SC_conv_utf8($this->itens_discount[$this->nm_grid_colunas][$NM_ind]);
          }
          foreach ($this->itens_totalprice[$this->nm_grid_colunas] as $NM_ind => $Dados) 
          {
          if ($this->itens_totalprice[$this->nm_grid_colunas][$NM_ind] === "") 
          { 
              $this->itens_totalprice[$this->nm_grid_colunas][$NM_ind] = "" ;  
          } 
              $this->itens_totalprice[$this->nm_grid_colunas][$NM_ind] = $this->SC_conv_utf8($this->itens_totalprice[$this->nm_grid_colunas][$NM_ind]);
          }
          if ($Init_Pdf)
          {
              $this->Pdf_init();
              $this->Pdf->setImageScale(1.33);
              $this->Pdf->AddPage();
              $Init_Pdf = false;
          }
          $Lin_extras = array();
            $cell_itens_productid = array('posx' => '1.741831458333114', 'posy' => '5.820833333332599', 'data' => $this->itens_productid[$this->nm_grid_colunas], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_unitprice = array('posx' => '70', 'posy' => '5.820833333332599', 'data' => $this->itens_unitprice[$this->nm_grid_colunas], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_quantity = array('posx' => '48.98760416666049', 'posy' => '5.820833333332599', 'data' => $this->itens_quantity[$this->nm_grid_colunas], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_discount = array('posx' => '110', 'posy' => '5.820833333332599', 'data' => $this->itens_discount[$this->nm_grid_colunas], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_itens_totalprice = array('posx' => '130', 'posy' => '5.820833333332599', 'data' => $this->itens_totalprice[$this->nm_grid_colunas], 'width'      => '0', 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => '12', 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
$this->Pdf->SetY(5.820833333332599);
            foreach ($this->itens[$this->nm_grid_colunas] as $NM_ind => $Dados)
            {
                $this->Pdf->SetFont($cell_itens_productid['font_type'], $cell_itens_productid['font_style'], $cell_itens_productid['font_size']);
                if (!empty($cell_itens_productid['posx']))
                {
                    $this->Pdf->SetX($cell_itens_productid['posx']);
                }
                if ($lin_inic)
                {
                    $atu_X = $this->Pdf->GetX();
                    $atu_Y = $this->Pdf->GetY();
                    $this->Pdf->SetTextColor($cell_itens_productid['color_r'], $cell_itens_productid['color_g'], $cell_itens_productid['color_b']);
                    $this->Pdf->writeHTMLCell($cell_itens_productid['width'], 0, $atu_X, $atu_Y, $this->itens_productid[$this->nm_grid_colunas][$NM_ind], 0, 0, false, true, $cell_itens_productid['align']);
                    $this->Pdf->SetY($atu_Y);
                }
                else
                {
                    $Lin_extras[$IX][(string)$cell_itens_productid['posx']] = array("width" => $cell_itens_productid['width'], "data" =>  $this->itens_productid[$this->nm_grid_colunas][$NM_ind], "align" => $cell_itens_productid['align'], "font_type" => $cell_itens_productid['font_type'], "font_style" => $cell_itens_productid['font_style'], "font_size" => $cell_itens_productid['font_size'], "color_r" => $cell_itens_productid['color_r'], "color_g" => $cell_itens_productid['color_g'], "color_b" => $cell_itens_productid['color_b']);
                }
                $this->Pdf->SetFont($cell_itens_unitprice['font_type'], $cell_itens_unitprice['font_style'], $cell_itens_unitprice['font_size']);
                if (!empty($cell_itens_unitprice['posx']))
                {
                    $this->Pdf->SetX($cell_itens_unitprice['posx']);
                }
                if ($lin_inic)
                {
                    $atu_X = $this->Pdf->GetX();
                    $atu_Y = $this->Pdf->GetY();
                    $this->Pdf->SetTextColor($cell_itens_unitprice['color_r'], $cell_itens_unitprice['color_g'], $cell_itens_unitprice['color_b']);
                    $this->Pdf->writeHTMLCell($cell_itens_unitprice['width'], 0, $atu_X, $atu_Y, $this->itens_unitprice[$this->nm_grid_colunas][$NM_ind], 0, 0, false, true, $cell_itens_unitprice['align']);
                    $this->Pdf->SetY($atu_Y);
                }
                else
                {
                    $Lin_extras[$IX][(string)$cell_itens_unitprice['posx']] = array("width" => $cell_itens_unitprice['width'], "data" =>  $this->itens_unitprice[$this->nm_grid_colunas][$NM_ind], "align" => $cell_itens_unitprice['align'], "font_type" => $cell_itens_unitprice['font_type'], "font_style" => $cell_itens_unitprice['font_style'], "font_size" => $cell_itens_unitprice['font_size'], "color_r" => $cell_itens_unitprice['color_r'], "color_g" => $cell_itens_unitprice['color_g'], "color_b" => $cell_itens_unitprice['color_b']);
                }
                $this->Pdf->SetFont($cell_itens_quantity['font_type'], $cell_itens_quantity['font_style'], $cell_itens_quantity['font_size']);
                if (!empty($cell_itens_quantity['posx']))
                {
                    $this->Pdf->SetX($cell_itens_quantity['posx']);
                }
                if ($lin_inic)
                {
                    $atu_X = $this->Pdf->GetX();
                    $atu_Y = $this->Pdf->GetY();
                    $this->Pdf->SetTextColor($cell_itens_quantity['color_r'], $cell_itens_quantity['color_g'], $cell_itens_quantity['color_b']);
                    $this->Pdf->writeHTMLCell($cell_itens_quantity['width'], 0, $atu_X, $atu_Y, $this->itens_quantity[$this->nm_grid_colunas][$NM_ind], 0, 0, false, true, $cell_itens_quantity['align']);
                    $this->Pdf->SetY($atu_Y);
                }
                else
                {
                    $Lin_extras[$IX][(string)$cell_itens_quantity['posx']] = array("width" => $cell_itens_quantity['width'], "data" =>  $this->itens_quantity[$this->nm_grid_colunas][$NM_ind], "align" => $cell_itens_quantity['align'], "font_type" => $cell_itens_quantity['font_type'], "font_style" => $cell_itens_quantity['font_style'], "font_size" => $cell_itens_quantity['font_size'], "color_r" => $cell_itens_quantity['color_r'], "color_g" => $cell_itens_quantity['color_g'], "color_b" => $cell_itens_quantity['color_b']);
                }
                $this->Pdf->SetFont($cell_itens_discount['font_type'], $cell_itens_discount['font_style'], $cell_itens_discount['font_size']);
                if (!empty($cell_itens_discount['posx']))
                {
                    $this->Pdf->SetX($cell_itens_discount['posx']);
                }
                if ($lin_inic)
                {
                    $atu_X = $this->Pdf->GetX();
                    $atu_Y = $this->Pdf->GetY();
                    $this->Pdf->SetTextColor($cell_itens_discount['color_r'], $cell_itens_discount['color_g'], $cell_itens_discount['color_b']);
                    $this->Pdf->writeHTMLCell($cell_itens_discount['width'], 0, $atu_X, $atu_Y, $this->itens_discount[$this->nm_grid_colunas][$NM_ind], 0, 0, false, true, $cell_itens_discount['align']);
                    $this->Pdf->SetY($atu_Y);
                }
                else
                {
                    $Lin_extras[$IX][(string)$cell_itens_discount['posx']] = array("width" => $cell_itens_discount['width'], "data" =>  $this->itens_discount[$this->nm_grid_colunas][$NM_ind], "align" => $cell_itens_discount['align'], "font_type" => $cell_itens_discount['font_type'], "font_style" => $cell_itens_discount['font_style'], "font_size" => $cell_itens_discount['font_size'], "color_r" => $cell_itens_discount['color_r'], "color_g" => $cell_itens_discount['color_g'], "color_b" => $cell_itens_discount['color_b']);
                }
                $this->Pdf->SetFont($cell_itens_totalprice['font_type'], $cell_itens_totalprice['font_style'], $cell_itens_totalprice['font_size']);
                if (!empty($cell_itens_totalprice['posx']))
                {
                    $this->Pdf->SetX($cell_itens_totalprice['posx']);
                }
                if ($lin_inic)
                {
                    $atu_X = $this->Pdf->GetX();
                    $atu_Y = $this->Pdf->GetY();
                    $this->Pdf->SetTextColor($cell_itens_totalprice['color_r'], $cell_itens_totalprice['color_g'], $cell_itens_totalprice['color_b']);
                    $this->Pdf->writeHTMLCell($cell_itens_totalprice['width'], 0, $atu_X, $atu_Y, $this->itens_totalprice[$this->nm_grid_colunas][$NM_ind], 0, 0, false, true, $cell_itens_totalprice['align']);
                    $this->Pdf->SetY($atu_Y);
                }
                else
                {
                    $Lin_extras[$IX][(string)$cell_itens_totalprice['posx']] = array("width" => $cell_itens_totalprice['width'], "data" =>  $this->itens_totalprice[$this->nm_grid_colunas][$NM_ind], "align" => $cell_itens_totalprice['align'], "font_type" => $cell_itens_totalprice['font_type'], "font_style" => $cell_itens_totalprice['font_style'], "font_size" => $cell_itens_totalprice['font_size'], "color_r" => $cell_itens_totalprice['color_r'], "color_g" => $cell_itens_totalprice['color_g'], "color_b" => $cell_itens_totalprice['color_b']);
                }
                if ($lin_inic)
                {
                    $lin_inic = false;
                }
                else
                {
                    $IX++;
                    $IX_max = ($IX > $IX_max) ? $IX : $IX_max;
                }
                $IX = $IX_max;

            }
          $this->Pdf->Ln(4.2333333333333);
          foreach ($Lin_extras as $Lines => $Data_lines) 
          {
              foreach ($Data_lines as $Col => $Parms) 
              {
                  if (isset($Parms["type"]) && $Parms["type"] == "img")
                  {
                      $posY = $this->Pdf->GetY();
                      if (isset($Parms["data"]) && !empty($Parms["data"]) && is_file($Parms["data"]))
                      {
                          $this->Pdf->Image($Parms['data'], $Col, $posY, $Parms['larg'], $Parms['alt']);
                      }
                  }
                  else
                  {
                      $this->Pdf->SetX($Col);
                      $this->Pdf->SetFont($Parms["font_type"], $Parms["font_style"], $Parms["font_size"]);
                      $this->pdf_text_color($Parms["data"], $Parms["color_r"], $Parms["color_g"], $Parms["color_b"]);
                      $this->Pdf->Cell($Parms["width"], 0, $Parms["data"], 0, 0, $Parms["align"]);
                  }
              }
              $this->Pdf->Ln(4.2333333333333);
          }
          $this->rs_grid->MoveNext();
          $this->sc_proc_grid = false;
          $nm_quant_linhas++ ;
      }  
   }  
   $this->rs_grid->Close();
   $this->Pdf->Output($this->Ini->root . $this->Ini->nm_path_pdf, 'F');
 }
 function pdf_text_color(&$val, $r, $g, $b)
 {
     $pos = strpos($val, "@SCNEG#");
     if ($pos !== false)
     {
         $cor = trim(substr($val, $pos + 7));
         $val = substr($val, 0, $pos);
         $cor = (substr($cor, 0, 1) == "#") ? substr($cor, 1) : $cor;
         if (strlen($cor) == 6)
         {
             $r = hexdec(substr($cor, 0, 2));
             $g = hexdec(substr($cor, 2, 2));
             $b = hexdec(substr($cor, 4, 2));
         }
     }
     $this->Pdf->SetTextColor($r, $g, $b);
 }
 function SC_conv_utf8($input)
 {
     if ($_SESSION['scriptcase']['charset'] != "UTF-8" && !NM_is_utf8($input))
     {
         $input = sc_convert_encoding($input, "UTF-8", $_SESSION['scriptcase']['charset']);
     }
     return $input;
 }
   function nm_conv_data_db($dt_in, $form_in, $form_out)
   {
       $dt_out = $dt_in;
       if (strtoupper($form_in) == "DB_FORMAT") {
           if ($dt_out == "null" || $dt_out == "")
           {
               $dt_out = "";
               return $dt_out;
           }
           $form_in = "AAAA-MM-DD";
       }
       if (strtoupper($form_out) == "DB_FORMAT") {
           if (empty($dt_out))
           {
               $dt_out = "null";
               return $dt_out;
           }
           $form_out = "AAAA-MM-DD";
       }
       if (strtoupper($form_out) == "SC_FORMAT_REGION") {
           $this->nm_data->SetaData($dt_in, strtoupper($form_in));
           $prep_out  = (strpos(strtolower($form_in), "dd") !== false) ? "dd" : "";
           $prep_out .= (strpos(strtolower($form_in), "mm") !== false) ? "mm" : "";
           $prep_out .= (strpos(strtolower($form_in), "aa") !== false) ? "aaaa" : "";
           $prep_out .= (strpos(strtolower($form_in), "yy") !== false) ? "aaaa" : "";
           return $this->nm_data->FormataSaida($this->nm_data->FormatRegion("DT", $prep_out));
       }
       else {
           nm_conv_form_data($dt_out, $form_in, $form_out);
           return $dt_out;
       }
   }
   function nm_gera_mask(&$nm_campo, $nm_mask)
   { 
      $trab_campo = $nm_campo;
      $trab_mask  = $nm_mask;
      $tam_campo  = strlen($nm_campo);
      $trab_saida = "";
      $str_highlight_ini = "";
      $str_highlight_fim = "";
      if(substr($nm_campo, 0, 23) == '<div class="highlight">' && substr($nm_campo, -6) == '</div>')
      {
           $str_highlight_ini = substr($nm_campo, 0, 23);
           $str_highlight_fim = substr($nm_campo, -6);

           $trab_campo = substr($nm_campo, 23, -6);
           $tam_campo  = strlen($trab_campo);
      }      $mask_num = false;
      for ($x=0; $x < strlen($trab_mask); $x++)
      {
          if (substr($trab_mask, $x, 1) == "#")
          {
              $mask_num = true;
              break;
          }
      }
      if ($mask_num )
      {
          $ver_duas = explode(";", $trab_mask);
          if (isset($ver_duas[1]) && !empty($ver_duas[1]))
          {
              $cont1 = count(explode("#", $ver_duas[0])) - 1;
              $cont2 = count(explode("#", $ver_duas[1])) - 1;
              if ($cont2 >= $tam_campo)
              {
                  $trab_mask = $ver_duas[1];
              }
              else
              {
                  $trab_mask = $ver_duas[0];
              }
          }
          $tam_mask = strlen($trab_mask);
          $xdados = 0;
          for ($x=0; $x < $tam_mask; $x++)
          {
              if (substr($trab_mask, $x, 1) == "#" && $xdados < $tam_campo)
              {
                  $trab_saida .= substr($trab_campo, $xdados, 1);
                  $xdados++;
              }
              elseif ($xdados < $tam_campo)
              {
                  $trab_saida .= substr($trab_mask, $x, 1);
              }
          }
          if ($xdados < $tam_campo)
          {
              $trab_saida .= substr($trab_campo, $xdados);
          }
          $nm_campo = $str_highlight_ini . $trab_saida . $str_highlight_ini;
          return;
      }
      for ($ix = strlen($trab_mask); $ix > 0; $ix--)
      {
           $char_mask = substr($trab_mask, $ix - 1, 1);
           if ($char_mask != "x" && $char_mask != "z")
           {
               $trab_saida = $char_mask . $trab_saida;
           }
           else
           {
               if ($tam_campo != 0)
               {
                   $trab_saida = substr($trab_campo, $tam_campo - 1, 1) . $trab_saida;
                   $tam_campo--;
               }
               else
               {
                   $trab_saida = "0" . $trab_saida;
               }
           }
      }
      if ($tam_campo != 0)
      {
          $trab_saida = substr($trab_campo, 0, $tam_campo) . $trab_saida;
          $trab_mask  = str_repeat("z", $tam_campo) . $trab_mask;
      }
   
      $iz = 0; 
      for ($ix = 0; $ix < strlen($trab_mask); $ix++)
      {
           $char_mask = substr($trab_mask, $ix, 1);
           if ($char_mask != "x" && $char_mask != "z")
           {
               if ($char_mask == "." || $char_mask == ",")
               {
                   $trab_saida = substr($trab_saida, 0, $iz) . substr($trab_saida, $iz + 1);
               }
               else
               {
                   $iz++;
               }
           }
           elseif ($char_mask == "x" || substr($trab_saida, $iz, 1) != "0")
           {
               $ix = strlen($trab_mask) + 1;
           }
           else
           {
               $trab_saida = substr($trab_saida, 0, $iz) . substr($trab_saida, $iz + 1);
           }
      }
      $nm_campo = $str_highlight_ini . $trab_saida . $str_highlight_ini;
   } 
}
?>
