<?php
class pdf02_grid
{
   var $Ini;
   var $Erro;
   var $Pdf;
   var $Db;
   var $rs_grid;
   var $nm_grid_sem_reg;
   var $SC_seq_register;
   var $nm_location;
   var $nm_data;
   var $nm_cod_barra;
   var $sc_proc_grid; 
   var $nmgp_botoes = array();
   var $Campos_Mens_erro;
   var $NM_raiz_img; 
   var $Font_ttf; 
   var $SC_incr_col;
   var $SC_incr_lin;
   var $SC_desloca_col; 
   var $SC_desloca_lin; 
   var $name = array();
   var $email = array();
   var $lastname = array();
   var $firstname = array();
   var $title = array();
   var $homephone = array();
   var $address = array();
   var $cityid = array();
   var $country = array();
   var $postalcode = array();
//--- 
 function monta_grid($linhas = 0)
 {

   clearstatcache();
   $this->inicializa();
   $this->grid();
 }
//--- 
 function inicializa()
 {
   global $nm_saida, 
   $rec, $nmgp_chave, $nmgp_opcao, $nmgp_ordem, $nmgp_chave_det, 
   $nmgp_quant_linhas, $nmgp_quant_colunas, $nmgp_url_saida, $nmgp_parms;
//
   $this->nm_data = new nm_data("en_us");
   include_once("../_lib/lib/php/nm_font_tcpdf.php");
   $this->default_font = 'Times';
   $this->default_font_sr  = 'Helvetica';
   $this->default_style    = '';
   $this->default_style_sr = 'B';
   $Tp_papel = "A4";
   $old_dir = getcwd();
   $File_font_ttf     = "";
   $temp_font_ttf     = "";
   $this->Font_ttf    = false;
   $this->Font_ttf_sr = false;
   if (empty($this->default_font) && isset($arr_font_tcpdf[$this->Ini->str_lang]))
   {
       $this->default_font = $arr_font_tcpdf[$this->Ini->str_lang];
   }
   elseif (empty($this->default_font))
   {
       $this->default_font = "Times";
   }
   if (empty($this->default_font_sr) && isset($arr_font_tcpdf[$this->Ini->str_lang]))
   {
       $this->default_font_sr = $arr_font_tcpdf[$this->Ini->str_lang];
   }
   elseif (empty($this->default_font_sr))
   {
       $this->default_font_sr = "Times";
   }
   $_SESSION['scriptcase']['pdf02']['default_font'] = $this->default_font;
   chdir($this->Ini->path_third . "/tcpdf/");
   include_once("tcpdf.php");
   chdir($old_dir);
   $this->Pdf = new TCPDF('P', 'mm', $Tp_papel, true, 'UTF-8', false);
   $this->Pdf->setPrintHeader(false);
   $this->Pdf->setPrintFooter(false);
   if (!empty($File_font_ttf))
   {
       $this->Pdf->addTTFfont($File_font_ttf, "", "", 32, $_SESSION['scriptcase']['dir_temp'] . "/");
   }
   $this->Pdf->SetDisplayMode('real');
   $this->aba_iframe = false;
   if (isset($_SESSION['scriptcase']['sc_aba_iframe']))
   {
       foreach ($_SESSION['scriptcase']['sc_aba_iframe'] as $aba => $apls_aba)
       {
           if (in_array("pdf02", $apls_aba))
           {
               $this->aba_iframe = true;
               break;
           }
       }
   }
   if ($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['iframe_menu'] && (!isset($_SESSION['scriptcase']['menu_mobile']) || empty($_SESSION['scriptcase']['menu_mobile'])))
   {
       $this->aba_iframe = true;
   }
   $this->nmgp_botoes['exit'] = "off";
   $this->sc_proc_grid = false; 
   $this->NM_raiz_img = $this->Ini->root;
   $_SESSION['scriptcase']['sc_sql_ult_conexao'] = ''; 
   $this->nm_where_dinamico = "";
   $this->nm_grid_colunas = 0;
   if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['campos_busca']) && !empty($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['campos_busca']))
   { 
       $Busca_temp = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['campos_busca'];
       if ($_SESSION['scriptcase']['charset'] != "UTF-8")
       {
           $Busca_temp = NM_conv_charset($Busca_temp, $_SESSION['scriptcase']['charset'], "UTF-8");
       }
       $this->firstname[0] = $Busca_temp['firstname']; 
       $tmp_pos = strpos($this->firstname[0], "##@@");
       if ($tmp_pos !== false && !is_array($this->firstname[0]))
       {
           $this->firstname[0] = substr($this->firstname[0], 0, $tmp_pos);
       }
       $this->title[0] = $Busca_temp['title']; 
       $tmp_pos = strpos($this->title[0], "##@@");
       if ($tmp_pos !== false && !is_array($this->title[0]))
       {
           $this->title[0] = substr($this->title[0], 0, $tmp_pos);
       }
       $this->address[0] = $Busca_temp['address']; 
       $tmp_pos = strpos($this->address[0], "##@@");
       if ($tmp_pos !== false && !is_array($this->address[0]))
       {
           $this->address[0] = substr($this->address[0], 0, $tmp_pos);
       }
       $this->country[0] = $Busca_temp['country']; 
       $tmp_pos = strpos($this->country[0], "##@@");
       if ($tmp_pos !== false && !is_array($this->country[0]))
       {
           $this->country[0] = substr($this->country[0], 0, $tmp_pos);
       }
   } 
   $this->nm_field_dinamico = array();
   $this->nm_order_dinamico = array();
   $this->sc_where_orig   = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_orig'];
   $this->sc_where_atual  = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq'];
   $this->sc_where_filtro = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq_filtro'];
   $dir_raiz          = strrpos($_SERVER['PHP_SELF'],"/") ;  
   $dir_raiz          = substr($_SERVER['PHP_SELF'], 0, $dir_raiz + 1) ;  
   $this->nm_location = $this->Ini->sc_protocolo . $this->Ini->server . $dir_raiz; 
   $_SESSION['scriptcase']['contr_link_emb'] = $this->nm_location;
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['qt_col_grid'] = 2 ;  
   if (isset($_SESSION['scriptcase']['sc_apl_conf']['pdf02']['cols']) && !empty($_SESSION['scriptcase']['sc_apl_conf']['pdf02']['cols']))
   {
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['qt_col_grid'] = $_SESSION['scriptcase']['sc_apl_conf']['pdf02']['cols'];  
       unset($_SESSION['scriptcase']['sc_apl_conf']['pdf02']['cols']);
   }
   if (!isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_select']))  
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_select'] = array(); 
   } 
   if (!isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_quebra']))  
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_grid'] = "" ; 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_ant']  = ""; 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_desc'] = "" ; 
   }   
   if (!empty($nmgp_parms) && $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['opcao'] != "pdf")   
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['opcao'] = "igual";
       $rec = "ini";
   }
   if (!isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_orig']) || $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['prim_cons'] || !empty($nmgp_parms))  
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['prim_cons'] = false;  
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_orig'] = "";  
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq']        = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_orig'];  
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq_ant']    = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_orig'];  
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['cond_pesq']         = ""; 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq_filtro'] = "";
   }   
   if  (!empty($this->nm_where_dinamico)) 
   {   
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq'] .= $this->nm_where_dinamico;
   }   
   $this->sc_where_orig   = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_orig'];
   $this->sc_where_atual  = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq'];
   $this->sc_where_filtro = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq_filtro'];
//
   if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['tot_geral'][1])) 
   { 
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['sc_total'] = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['tot_geral'][1] ;  
   }
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq_ant'] = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq'];  
//----- 
   if (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_sybase))
   { 
       $nmgp_select = "SELECT lastname, firstname, title, homephone, address, cityid, country, postalcode from " . $this->Ini->nm_tabela; 
   } 
   elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_mysql))
   { 
       $nmgp_select = "SELECT lastname, firstname, title, homephone, address, cityid, country, postalcode from " . $this->Ini->nm_tabela; 
   } 
   elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_mssql))
   { 
       $nmgp_select = "SELECT lastname, firstname, title, homephone, address, cityid, country, postalcode from " . $this->Ini->nm_tabela; 
   } 
   elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_oracle))
   { 
       $nmgp_select = "SELECT lastname, firstname, title, homephone, address, cityid, country, postalcode from " . $this->Ini->nm_tabela; 
   } 
   elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_informix))
   { 
       $nmgp_select = "SELECT lastname, firstname, title, homephone, address, cityid, country, postalcode from " . $this->Ini->nm_tabela; 
   } 
   else 
   { 
       $nmgp_select = "SELECT lastname, firstname, title, homephone, address, cityid, country, postalcode from " . $this->Ini->nm_tabela; 
   } 
   $nmgp_select .= " " . $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq']; 
   $nmgp_order_by = ""; 
   $campos_order_select = "";
   foreach($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_select'] as $campo => $ordem) 
   {
        if ($campo != $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_grid']) 
        {
           if (!empty($campos_order_select)) 
           {
               $campos_order_select .= ", ";
           }
           $campos_order_select .= $campo . " " . $ordem;
        }
   }
   if (!empty($_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_grid'])) 
   { 
       $nmgp_order_by = " order by " . $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_grid'] . $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['ordem_desc']; 
   } 
   if (!empty($campos_order_select)) 
   { 
       if (!empty($nmgp_order_by)) 
       { 
          $nmgp_order_by .= ", " . $campos_order_select; 
       } 
       else 
       { 
          $nmgp_order_by = " order by $campos_order_select"; 
       } 
   } 
   $nmgp_select .= $nmgp_order_by; 
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['order_grid'] = $nmgp_order_by;
   $_SESSION['scriptcase']['sc_sql_ult_comando'] = $nmgp_select; 
   $this->rs_grid = $this->Db->Execute($nmgp_select) ; 
   if ($this->rs_grid === false && !$this->rs_grid->EOF && $GLOBALS["NM_ERRO_IBASE"] != 1) 
   { 
       $this->Erro->mensagem(__FILE__, __LINE__, "banco", $this->Ini->Nm_lang['lang_errm_dber'], $this->Db->ErrorMsg()); 
       exit ; 
   }  
   if ($this->rs_grid->EOF || ($this->rs_grid === false && $GLOBALS["NM_ERRO_IBASE"] == 1)) 
   { 
       $this->nm_grid_sem_reg = $this->SC_conv_utf8($this->Ini->Nm_lang['lang_errm_empt']); 
   }  
// 
 }  
// 
 function Pdf_init()
 {
     if ($_SESSION['scriptcase']['reg_conf']['css_dir'] == "RTL")
     {
         $this->Pdf->setRTL(true);
     }
     $this->Pdf->setHeaderMargin(0);
     $this->Pdf->setFooterMargin(0);
     $this->Pdf->setCellMargins($left = 0, $top = 0, $right = 0, $bottom = 0);
     $this->Pdf->SetAutoPageBreak(false);
     if ($this->Font_ttf)
     {
         $this->Pdf->SetFont($this->default_font, $this->default_style, 10, $this->def_TTF);
     }
     else
     {
         $this->Pdf->SetFont($this->default_font, $this->default_style, 10);
     }
     $this->Pdf->SetTextColor(0, 0, 0);
     $this->Pdf->SetAutoPageBreak(false);
 }
// 
 function Pdf_image()
 {
   if ($_SESSION['scriptcase']['reg_conf']['css_dir'] == "RTL")
   {
       $this->Pdf->setRTL(false);
   }
   $SV_margin = $this->Pdf->getBreakMargin();
   $SV_auto_page_break = $this->Pdf->getAutoPageBreak();
   $this->Pdf->SetAutoPageBreak(false, 0);
   $this->Pdf->Image($this->NM_raiz_img . $this->Ini->path_img_global . "/grp__NM__bussiness_card.jpg", "1", "1", "210", "297", '', '', '', false, 300, '', false, false, 0);
   $this->Pdf->SetAutoPageBreak($SV_auto_page_break, $SV_margin);
   $this->Pdf->setPageMark();
   if ($_SESSION['scriptcase']['reg_conf']['css_dir'] == "RTL")
   {
       $this->Pdf->setRTL(true);
   }
 }
// 
//----- 
 function grid($linhas = 0)
 {
    global 
           $nm_saida, $nm_url_saida;
   $HTTP_REFERER = (isset($_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : ""; 
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['seq_dir'] = 0; 
   $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['sub_dir'] = array(); 
   $this->sc_where_orig   = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_orig'];
   $this->sc_where_atual  = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq'];
   $this->sc_where_filtro = $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['where_pesq_filtro'];
   if (isset($_SESSION['scriptcase']['sc_apl_conf']['pdf02']['lig_edit']) && $_SESSION['scriptcase']['sc_apl_conf']['pdf02']['lig_edit'] != '')
   {
       $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['mostra_edit'] = $_SESSION['scriptcase']['sc_apl_conf']['pdf02']['lig_edit'];
   }
   if (!empty($this->nm_grid_sem_reg))
   {
       $this->Pdf_init();
       $this->Pdf->AddPage();
       if ($this->Font_ttf_sr)
       {
           $this->Pdf->SetFont($this->default_font_sr, 'B', 12, $this->def_TTF);
       }
       else
       {
           $this->Pdf->SetFont($this->default_font_sr, 'B', 12);
       }
       $this->Pdf->SetTextColor(0, 0, 0);
       $this->Pdf->Text(10, 10, html_entity_decode($this->nm_grid_sem_reg, ENT_COMPAT, $_SESSION['scriptcase']['charset']));
       $this->Pdf->Output($this->Ini->root . $this->Ini->nm_path_pdf, 'F');
       return;
   }
// 
   $Init_Pdf = true;
   $this->SC_seq_register = 0; 
   $Contr_Y_init          = 27; 
   $Contr_lin_Pdf         = 0; 
   $this->SC_desloca_col  = 105; 
   $this->SC_desloca_lin  = 59; 
   while (!$this->rs_grid->EOF) 
   {  
      $this->nm_grid_colunas = 0; 
      $nm_quant_linhas = 0;
      $this->SC_incr_col = 0; 
      $this->SC_incr_lin = $this->SC_desloca_lin * $Contr_lin_Pdf; 
      $Contr_lin_Pdf++; 
      if ($Init_Pdf || ($this->SC_incr_lin + $this->SC_desloca_lin + $Contr_Y_init) > 297)
      {
          $this->Pdf->setImageScale(1.33);
          $this->Pdf->AddPage();
          $this->Pdf_init();
          $this->Pdf_image();
          $this->SC_incr_lin = 0; 
          $Contr_lin_Pdf     = 1; 
          $Init_Pdf          = false; 
      }
      while (!$this->rs_grid->EOF && $nm_quant_linhas < $_SESSION['sc_session'][$this->Ini->sc_page]['pdf02']['qt_col_grid']) 
      {  
          $this->sc_proc_grid = true;
          $this->SC_seq_register++; 
          $this->SC_incr_col = $this->SC_desloca_col * $nm_quant_linhas; 
          $this->lastname[$this->nm_grid_colunas] = $this->rs_grid->fields[0] ;  
          $this->firstname[$this->nm_grid_colunas] = $this->rs_grid->fields[1] ;  
          $this->title[$this->nm_grid_colunas] = $this->rs_grid->fields[2] ;  
          $this->homephone[$this->nm_grid_colunas] = $this->rs_grid->fields[3] ;  
          $this->address[$this->nm_grid_colunas] = $this->rs_grid->fields[4] ;  
          $this->cityid[$this->nm_grid_colunas] = $this->rs_grid->fields[5] ;  
          $this->cityid[$this->nm_grid_colunas] = (string)$this->cityid[$this->nm_grid_colunas];
          $this->country[$this->nm_grid_colunas] = $this->rs_grid->fields[6] ;  
          $this->postalcode[$this->nm_grid_colunas] = $this->rs_grid->fields[7] ;  
          $this->name[$this->nm_grid_colunas] = "";
          $this->email[$this->nm_grid_colunas] = "";
          $_SESSION['scriptcase']['pdf02']['contr_erro'] = 'on';
 $this->name[$this->nm_grid_colunas]  = $this->lastname[$this->nm_grid_colunas] .', '.$this->firstname[$this->nm_grid_colunas] ;

$this->email[$this->nm_grid_colunas]  = $this->lastname[$this->nm_grid_colunas] .'.'.$this->firstname[$this->nm_grid_colunas] .'@scriptcase.net';

$this->postalcode[$this->nm_grid_colunas]  = 'Postal code: '.$this->postalcode[$this->nm_grid_colunas] ;
$_SESSION['scriptcase']['pdf02']['contr_erro'] = 'off';
          $this->lastname[$this->nm_grid_colunas] = sc_strip_script($this->lastname[$this->nm_grid_colunas]);
          if ($this->lastname[$this->nm_grid_colunas] === "") 
          { 
              $this->lastname[$this->nm_grid_colunas] = "" ;  
          } 
          $this->lastname[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->lastname[$this->nm_grid_colunas]);
          $this->firstname[$this->nm_grid_colunas] = sc_strip_script($this->firstname[$this->nm_grid_colunas]);
          if ($this->firstname[$this->nm_grid_colunas] === "") 
          { 
              $this->firstname[$this->nm_grid_colunas] = "" ;  
          } 
          $this->firstname[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->firstname[$this->nm_grid_colunas]);
          $this->title[$this->nm_grid_colunas] = sc_strip_script($this->title[$this->nm_grid_colunas]);
          if ($this->title[$this->nm_grid_colunas] === "") 
          { 
              $this->title[$this->nm_grid_colunas] = "" ;  
          } 
          $this->title[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->title[$this->nm_grid_colunas]);
          $this->homephone[$this->nm_grid_colunas] = sc_strip_script($this->homephone[$this->nm_grid_colunas]);
          if ($this->homephone[$this->nm_grid_colunas] === "") 
          { 
              $this->homephone[$this->nm_grid_colunas] = "" ;  
          } 
          $this->homephone[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->homephone[$this->nm_grid_colunas]);
          $this->address[$this->nm_grid_colunas] = sc_strip_script($this->address[$this->nm_grid_colunas]);
          if ($this->address[$this->nm_grid_colunas] === "") 
          { 
              $this->address[$this->nm_grid_colunas] = "" ;  
          } 
          $this->address[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->address[$this->nm_grid_colunas]);
          $this->cityid[$this->nm_grid_colunas] = sc_strip_script($this->cityid[$this->nm_grid_colunas]);
          if ($this->cityid[$this->nm_grid_colunas] === "") 
          { 
              $this->cityid[$this->nm_grid_colunas] = "" ;  
          } 
          $this->cityid[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->cityid[$this->nm_grid_colunas]);
          $this->country[$this->nm_grid_colunas] = sc_strip_script($this->country[$this->nm_grid_colunas]);
          if ($this->country[$this->nm_grid_colunas] === "") 
          { 
              $this->country[$this->nm_grid_colunas] = "" ;  
          } 
          $this->country[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->country[$this->nm_grid_colunas]);
          $this->postalcode[$this->nm_grid_colunas] = sc_strip_script($this->postalcode[$this->nm_grid_colunas]);
          if ($this->postalcode[$this->nm_grid_colunas] === "") 
          { 
              $this->postalcode[$this->nm_grid_colunas] = "" ;  
          } 
          $this->postalcode[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->postalcode[$this->nm_grid_colunas]);
          if ($this->name[$this->nm_grid_colunas] === "") 
          { 
              $this->name[$this->nm_grid_colunas] = "" ;  
          } 
          $this->name[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->name[$this->nm_grid_colunas]);
          if ($this->email[$this->nm_grid_colunas] === "") 
          { 
              $this->email[$this->nm_grid_colunas] = "" ;  
          } 
          $this->email[$this->nm_grid_colunas] = $this->SC_conv_utf8($this->email[$this->nm_grid_colunas]);
            $cell_Title = array('posx' => 4, 'posy' => 30, 'data' => $this->title[$this->nm_grid_colunas], 'width'      => 0, 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => 8, 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => I);
            $cell_HomePhone = array('posx' => 4, 'posy' => 43, 'data' => $this->homephone[$this->nm_grid_colunas], 'width'      => 0, 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => 10, 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_Address = array('posx' => 65, 'posy' => 50, 'data' => $this->address[$this->nm_grid_colunas], 'width'      => 0, 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => 10, 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_Country = array('posx' => 80, 'posy' => 53, 'data' => $this->country[$this->nm_grid_colunas], 'width'      => 0, 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => 10, 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_PostalCode = array('posx' => 65, 'posy' => 56, 'data' => $this->postalcode[$this->nm_grid_colunas], 'width'      => 0, 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => 10, 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_CityID = array('posx' => 65, 'posy' => 53, 'data' => $this->cityid[$this->nm_grid_colunas], 'width'      => 0, 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => 10, 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_Email = array('posx' => 4, 'posy' => 40, 'data' => $this->email[$this->nm_grid_colunas], 'width'      => 0, 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => 10, 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);
            $cell_Name = array('posx' => 4, 'posy' => 27, 'data' => $this->name[$this->nm_grid_colunas], 'width'      => 0, 'align'      => 'L', 'font_type'  => $this->default_font, 'font_size'  => 10, 'color_r'    => '0', 'color_g'    => '0', 'color_b'    => '0', 'font_style' => $this->default_style);


            $this->Pdf->SetFont($cell_Title['font_type'], $cell_Title['font_style'], $cell_Title['font_size']);
            $this->pdf_text_color($cell_Title['data'], $cell_Title['color_r'], $cell_Title['color_g'], $cell_Title['color_b']);
            if (!empty($cell_Title['posx']) && !empty($cell_Title['posy']))
            {
                $this->Pdf->SetXY($cell_Title['posx'] + $this->SC_incr_col,  $cell_Title['posy'] + $this->SC_incr_lin);
            }
            elseif (!empty($cell_Title['posx']))
            {
                $this->Pdf->SetX($cell_Title['posx'] + $this->SC_incr_col);
            }
            elseif (!empty($cell_Title['posy']))
            {
                $this->Pdf->SetY($cell_Title['posy'] + $this->SC_incr_lin);
            }
            $this->Pdf->Cell($cell_Title['width'], 0, $cell_Title['data'], 0, 0, $cell_Title['align']);

            $this->Pdf->SetFont($cell_HomePhone['font_type'], $cell_HomePhone['font_style'], $cell_HomePhone['font_size']);
            $this->pdf_text_color($cell_HomePhone['data'], $cell_HomePhone['color_r'], $cell_HomePhone['color_g'], $cell_HomePhone['color_b']);
            if (!empty($cell_HomePhone['posx']) && !empty($cell_HomePhone['posy']))
            {
                $this->Pdf->SetXY($cell_HomePhone['posx'] + $this->SC_incr_col,  $cell_HomePhone['posy'] + $this->SC_incr_lin);
            }
            elseif (!empty($cell_HomePhone['posx']))
            {
                $this->Pdf->SetX($cell_HomePhone['posx'] + $this->SC_incr_col);
            }
            elseif (!empty($cell_HomePhone['posy']))
            {
                $this->Pdf->SetY($cell_HomePhone['posy'] + $this->SC_incr_lin);
            }
            $this->Pdf->Cell($cell_HomePhone['width'], 0, $cell_HomePhone['data'], 0, 0, $cell_HomePhone['align']);

            $this->Pdf->SetFont($cell_Address['font_type'], $cell_Address['font_style'], $cell_Address['font_size']);
            $this->pdf_text_color($cell_Address['data'], $cell_Address['color_r'], $cell_Address['color_g'], $cell_Address['color_b']);
            if (!empty($cell_Address['posx']) && !empty($cell_Address['posy']))
            {
                $this->Pdf->SetXY($cell_Address['posx'] + $this->SC_incr_col,  $cell_Address['posy'] + $this->SC_incr_lin);
            }
            elseif (!empty($cell_Address['posx']))
            {
                $this->Pdf->SetX($cell_Address['posx'] + $this->SC_incr_col);
            }
            elseif (!empty($cell_Address['posy']))
            {
                $this->Pdf->SetY($cell_Address['posy'] + $this->SC_incr_lin);
            }
            $this->Pdf->Cell($cell_Address['width'], 0, $cell_Address['data'], 0, 0, $cell_Address['align']);

            $this->Pdf->SetFont($cell_Country['font_type'], $cell_Country['font_style'], $cell_Country['font_size']);
            $this->pdf_text_color($cell_Country['data'], $cell_Country['color_r'], $cell_Country['color_g'], $cell_Country['color_b']);
            if (!empty($cell_Country['posx']) && !empty($cell_Country['posy']))
            {
                $this->Pdf->SetXY($cell_Country['posx'] + $this->SC_incr_col,  $cell_Country['posy'] + $this->SC_incr_lin);
            }
            elseif (!empty($cell_Country['posx']))
            {
                $this->Pdf->SetX($cell_Country['posx'] + $this->SC_incr_col);
            }
            elseif (!empty($cell_Country['posy']))
            {
                $this->Pdf->SetY($cell_Country['posy'] + $this->SC_incr_lin);
            }
            $this->Pdf->Cell($cell_Country['width'], 0, $cell_Country['data'], 0, 0, $cell_Country['align']);

            $this->Pdf->SetFont($cell_PostalCode['font_type'], $cell_PostalCode['font_style'], $cell_PostalCode['font_size']);
            $this->pdf_text_color($cell_PostalCode['data'], $cell_PostalCode['color_r'], $cell_PostalCode['color_g'], $cell_PostalCode['color_b']);
            if (!empty($cell_PostalCode['posx']) && !empty($cell_PostalCode['posy']))
            {
                $this->Pdf->SetXY($cell_PostalCode['posx'] + $this->SC_incr_col,  $cell_PostalCode['posy'] + $this->SC_incr_lin);
            }
            elseif (!empty($cell_PostalCode['posx']))
            {
                $this->Pdf->SetX($cell_PostalCode['posx'] + $this->SC_incr_col);
            }
            elseif (!empty($cell_PostalCode['posy']))
            {
                $this->Pdf->SetY($cell_PostalCode['posy'] + $this->SC_incr_lin);
            }
            $this->Pdf->Cell($cell_PostalCode['width'], 0, $cell_PostalCode['data'], 0, 0, $cell_PostalCode['align']);

            $this->Pdf->SetFont($cell_CityID['font_type'], $cell_CityID['font_style'], $cell_CityID['font_size']);
            $this->pdf_text_color($cell_CityID['data'], $cell_CityID['color_r'], $cell_CityID['color_g'], $cell_CityID['color_b']);
            if (!empty($cell_CityID['posx']) && !empty($cell_CityID['posy']))
            {
                $this->Pdf->SetXY($cell_CityID['posx'] + $this->SC_incr_col,  $cell_CityID['posy'] + $this->SC_incr_lin);
            }
            elseif (!empty($cell_CityID['posx']))
            {
                $this->Pdf->SetX($cell_CityID['posx'] + $this->SC_incr_col);
            }
            elseif (!empty($cell_CityID['posy']))
            {
                $this->Pdf->SetY($cell_CityID['posy'] + $this->SC_incr_lin);
            }
            $this->Pdf->Cell($cell_CityID['width'], 0, $cell_CityID['data'], 0, 0, $cell_CityID['align']);

            $this->Pdf->SetFont($cell_Email['font_type'], $cell_Email['font_style'], $cell_Email['font_size']);
            $this->pdf_text_color($cell_Email['data'], $cell_Email['color_r'], $cell_Email['color_g'], $cell_Email['color_b']);
            if (!empty($cell_Email['posx']) && !empty($cell_Email['posy']))
            {
                $this->Pdf->SetXY($cell_Email['posx'] + $this->SC_incr_col,  $cell_Email['posy'] + $this->SC_incr_lin);
            }
            elseif (!empty($cell_Email['posx']))
            {
                $this->Pdf->SetX($cell_Email['posx'] + $this->SC_incr_col);
            }
            elseif (!empty($cell_Email['posy']))
            {
                $this->Pdf->SetY($cell_Email['posy'] + $this->SC_incr_lin);
            }
            $this->Pdf->Cell($cell_Email['width'], 0, $cell_Email['data'], 0, 0, $cell_Email['align']);

            $this->Pdf->SetFont($cell_Name['font_type'], $cell_Name['font_style'], $cell_Name['font_size']);
            $this->pdf_text_color($cell_Name['data'], $cell_Name['color_r'], $cell_Name['color_g'], $cell_Name['color_b']);
            if (!empty($cell_Name['posx']) && !empty($cell_Name['posy']))
            {
                $this->Pdf->SetXY($cell_Name['posx'] + $this->SC_incr_col,  $cell_Name['posy'] + $this->SC_incr_lin);
            }
            elseif (!empty($cell_Name['posx']))
            {
                $this->Pdf->SetX($cell_Name['posx'] + $this->SC_incr_col);
            }
            elseif (!empty($cell_Name['posy']))
            {
                $this->Pdf->SetY($cell_Name['posy'] + $this->SC_incr_lin);
            }
            $this->Pdf->Cell($cell_Name['width'], 0, $cell_Name['data'], 0, 0, $cell_Name['align']);
          $max_Y = 0;
          $this->rs_grid->MoveNext();
          $this->sc_proc_grid = false;
          $nm_quant_linhas++ ;
      }  
   }  
   $this->rs_grid->Close();
   $this->Pdf->Output($this->Ini->root . $this->Ini->nm_path_pdf, 'F');
 }
 function pdf_text_color(&$val, $r, $g, $b)
 {
     $pos = strpos($val, "@SCNEG#");
     if ($pos !== false)
     {
         $cor = trim(substr($val, $pos + 7));
         $val = substr($val, 0, $pos);
         $cor = (substr($cor, 0, 1) == "#") ? substr($cor, 1) : $cor;
         if (strlen($cor) == 6)
         {
             $r = hexdec(substr($cor, 0, 2));
             $g = hexdec(substr($cor, 2, 2));
             $b = hexdec(substr($cor, 4, 2));
         }
     }
     $this->Pdf->SetTextColor($r, $g, $b);
 }
 function SC_conv_utf8($input)
 {
     if ($_SESSION['scriptcase']['charset'] != "UTF-8" && !NM_is_utf8($input))
     {
         $input = sc_convert_encoding($input, "UTF-8", $_SESSION['scriptcase']['charset']);
     }
     return $input;
 }
   function nm_conv_data_db($dt_in, $form_in, $form_out)
   {
       $dt_out = $dt_in;
       if (strtoupper($form_in) == "DB_FORMAT") {
           if ($dt_out == "null" || $dt_out == "")
           {
               $dt_out = "";
               return $dt_out;
           }
           $form_in = "AAAA-MM-DD";
       }
       if (strtoupper($form_out) == "DB_FORMAT") {
           if (empty($dt_out))
           {
               $dt_out = "null";
               return $dt_out;
           }
           $form_out = "AAAA-MM-DD";
       }
       if (strtoupper($form_out) == "SC_FORMAT_REGION") {
           $this->nm_data->SetaData($dt_in, strtoupper($form_in));
           $prep_out  = (strpos(strtolower($form_in), "dd") !== false) ? "dd" : "";
           $prep_out .= (strpos(strtolower($form_in), "mm") !== false) ? "mm" : "";
           $prep_out .= (strpos(strtolower($form_in), "aa") !== false) ? "aaaa" : "";
           $prep_out .= (strpos(strtolower($form_in), "yy") !== false) ? "aaaa" : "";
           return $this->nm_data->FormataSaida($this->nm_data->FormatRegion("DT", $prep_out));
       }
       else {
           nm_conv_form_data($dt_out, $form_in, $form_out);
           return $dt_out;
       }
   }
   function nm_gera_mask(&$nm_campo, $nm_mask)
   { 
      $trab_campo = $nm_campo;
      $trab_mask  = $nm_mask;
      $tam_campo  = strlen($nm_campo);
      $trab_saida = "";
      $str_highlight_ini = "";
      $str_highlight_fim = "";
      if(substr($nm_campo, 0, 23) == '<div class="highlight">' && substr($nm_campo, -6) == '</div>')
      {
           $str_highlight_ini = substr($nm_campo, 0, 23);
           $str_highlight_fim = substr($nm_campo, -6);

           $trab_campo = substr($nm_campo, 23, -6);
           $tam_campo  = strlen($trab_campo);
      }      $mask_num = false;
      for ($x=0; $x < strlen($trab_mask); $x++)
      {
          if (substr($trab_mask, $x, 1) == "#")
          {
              $mask_num = true;
              break;
          }
      }
      if ($mask_num )
      {
          $ver_duas = explode(";", $trab_mask);
          if (isset($ver_duas[1]) && !empty($ver_duas[1]))
          {
              $cont1 = count(explode("#", $ver_duas[0])) - 1;
              $cont2 = count(explode("#", $ver_duas[1])) - 1;
              if ($cont2 >= $tam_campo)
              {
                  $trab_mask = $ver_duas[1];
              }
              else
              {
                  $trab_mask = $ver_duas[0];
              }
          }
          $tam_mask = strlen($trab_mask);
          $xdados = 0;
          for ($x=0; $x < $tam_mask; $x++)
          {
              if (substr($trab_mask, $x, 1) == "#" && $xdados < $tam_campo)
              {
                  $trab_saida .= substr($trab_campo, $xdados, 1);
                  $xdados++;
              }
              elseif ($xdados < $tam_campo)
              {
                  $trab_saida .= substr($trab_mask, $x, 1);
              }
          }
          if ($xdados < $tam_campo)
          {
              $trab_saida .= substr($trab_campo, $xdados);
          }
          $nm_campo = $str_highlight_ini . $trab_saida . $str_highlight_ini;
          return;
      }
      for ($ix = strlen($trab_mask); $ix > 0; $ix--)
      {
           $char_mask = substr($trab_mask, $ix - 1, 1);
           if ($char_mask != "x" && $char_mask != "z")
           {
               $trab_saida = $char_mask . $trab_saida;
           }
           else
           {
               if ($tam_campo != 0)
               {
                   $trab_saida = substr($trab_campo, $tam_campo - 1, 1) . $trab_saida;
                   $tam_campo--;
               }
               else
               {
                   $trab_saida = "0" . $trab_saida;
               }
           }
      }
      if ($tam_campo != 0)
      {
          $trab_saida = substr($trab_campo, 0, $tam_campo) . $trab_saida;
          $trab_mask  = str_repeat("z", $tam_campo) . $trab_mask;
      }
   
      $iz = 0; 
      for ($ix = 0; $ix < strlen($trab_mask); $ix++)
      {
           $char_mask = substr($trab_mask, $ix, 1);
           if ($char_mask != "x" && $char_mask != "z")
           {
               if ($char_mask == "." || $char_mask == ",")
               {
                   $trab_saida = substr($trab_saida, 0, $iz) . substr($trab_saida, $iz + 1);
               }
               else
               {
                   $iz++;
               }
           }
           elseif ($char_mask == "x" || substr($trab_saida, $iz, 1) != "0")
           {
               $ix = strlen($trab_mask) + 1;
           }
           else
           {
               $trab_saida = substr($trab_saida, 0, $iz) . substr($trab_saida, $iz + 1);
           }
      }
      $nm_campo = $str_highlight_ini . $trab_saida . $str_highlight_ini;
   } 
}
?>
