<?php

class sc96_save_grid_rtf
{
   var $Db;
   var $Erro;
   var $Ini;
   var $Lookup;
   var $nm_data;
   var $Texto_tag;
   var $Arquivo;
   var $Tit_doc;
   var $sc_proc_grid; 
   var $NM_cmp_hidden = array();

   //---- 
   function __construct()
   {
      $this->nm_data   = new nm_data("pt_br");
      $this->Texto_tag = "";
   }

   //---- 
   function monta_rtf()
   {
      $this->inicializa_vars();
      $this->gera_texto_tag();
      $this->grava_arquivo_rtf();
      if ($this->Ini->sc_export_ajax)
      {
          $this->Arr_result['file_export']  = NM_charset_to_utf8($this->Rtf_f);
          $this->Arr_result['title_export'] = NM_charset_to_utf8($this->Tit_doc);
          $Temp = ob_get_clean();
          if ($Temp !== false && trim($Temp) != "")
          {
              $this->Arr_result['htmOutput'] = NM_charset_to_utf8($Temp);
          }
          $oJson = new Services_JSON();
          echo $oJson->encode($this->Arr_result);
          exit;
      }
      else
      {
          $this->progress_bar_end();
      }
   }

   //----- 
   function inicializa_vars()
   {
      global $nm_lang;
      if (isset($GLOBALS['nmgp_parms']) && !empty($GLOBALS['nmgp_parms'])) 
      { 
          $GLOBALS['nmgp_parms'] = str_replace("@aspass@", "'", $GLOBALS['nmgp_parms']);
          $todox = str_replace("?#?@?@?", "?#?@ ?@?", $GLOBALS["nmgp_parms"]);
          $todo  = explode("?@?", $todox);
          foreach ($todo as $param)
          {
               $cadapar = explode("?#?", $param);
               if (1 < sizeof($cadapar))
               {
                   if (substr($cadapar[0], 0, 11) == "SC_glo_par_")
                   {
                       $cadapar[0] = substr($cadapar[0], 11);
                       $cadapar[1] = $_SESSION[$cadapar[1]];
                   }
                   if (isset($GLOBALS['sc_conv_var'][$cadapar[0]]))
                   {
                       $cadapar[0] = $GLOBALS['sc_conv_var'][$cadapar[0]];
                   }
                   elseif (isset($GLOBALS['sc_conv_var'][strtolower($cadapar[0])]))
                   {
                       $cadapar[0] = $GLOBALS['sc_conv_var'][strtolower($cadapar[0])];
                   }
                   nm_limpa_str_sc96_save_grid($cadapar[1]);
                   nm_protect_num_sc96_save_grid($cadapar[0], $cadapar[1]);
                   if ($cadapar[1] == "@ ") {$cadapar[1] = trim($cadapar[1]); }
                   $Tmp_par   = $cadapar[0];
                   $$Tmp_par = $cadapar[1];
                   if ($Tmp_par == "nmgp_opcao")
                   {
                       $_SESSION['sc_session'][$script_case_init]['sc96_save_grid']['opcao'] = $cadapar[1];
                   }
               }
          }
      }
      $dir_raiz          = strrpos($_SERVER['PHP_SELF'],"/") ;  
      $dir_raiz          = substr($_SERVER['PHP_SELF'], 0, $dir_raiz + 1) ;  
      $this->nm_location = $this->Ini->sc_protocolo . $this->Ini->server . $dir_raiz; 
      require_once($this->Ini->path_aplicacao . "sc96_save_grid_total.class.php"); 
      $this->Tot      = new sc96_save_grid_total($this->Ini->sc_page);
      $this->prep_modulos("Tot");
      $Gb_geral = "quebra_geral_" . $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['SC_Ind_Groupby'];
      if (method_exists($this->Tot,$Gb_geral))
      {
          $this->Tot->$Gb_geral();
          $this->count_ger = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['tot_geral'][1];
          if ($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['SC_Ind_Groupby'] == "birthdate_stateid")
          {
              $this->sum_creditlimit = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['tot_geral'][2];
              $this->max_creditlimit = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['tot_geral'][3];
          }
      }
      if (!$this->Ini->sc_export_ajax) {
          require_once($this->Ini->path_lib_php . "/sc_progress_bar.php");
          $this->pb = new scProgressBar();
          $this->pb->setRoot($this->Ini->root);
          $this->pb->setDir($_SESSION['scriptcase']['sc96_save_grid']['glo_nm_path_imag_temp'] . "/");
          $this->pb->setProgressbarMd5($_GET['pbmd5']);
          $this->pb->initialize();
          $this->pb->setReturnUrl("./");
          $this->pb->setReturnOption('volta_grid');
          $this->pb->setTotalSteps($this->count_ger);
      }
      $this->Arquivo    = "sc_rtf";
      $this->Arquivo   .= "_" . date("YmdHis") . "_" . rand(0, 1000);
      $this->Arquivo   .= "_sc96_save_grid";
      $this->Arquivo   .= ".rtf";
      $this->Tit_doc    = "sc96_save_grid.rtf";
   }
   //---- 
   function prep_modulos($modulo)
   {
      $this->$modulo->Ini    = $this->Ini;
      $this->$modulo->Db     = $this->Db;
      $this->$modulo->Erro   = $this->Erro;
      $this->$modulo->Lookup = $this->Lookup;
   }


   //----- 
   function gera_texto_tag()
   {
     global $nm_lang;
      global $nm_nada, $nm_lang;

      $_SESSION['scriptcase']['sc_sql_ult_conexao'] = ''; 
      $this->sc_proc_grid = false; 
      $nm_raiz_img  = ""; 
      $this->New_label['customerid'] = "" . $this->Ini->Nm_lang['lang_customers_fild_customerid'] . "";
      $this->New_label['companyname'] = "" . $this->Ini->Nm_lang['lang_customers_fild_companyname'] . "";
      $this->New_label['contactname'] = "" . $this->Ini->Nm_lang['lang_customers_fild_contactname'] . "";
      $this->New_label['contacttitle'] = "" . $this->Ini->Nm_lang['lang_customers_fild_contacttitle'] . "";
      $this->New_label['birthdate'] = "" . $this->Ini->Nm_lang['lang_customers_fild_birthdate'] . "";
      $this->New_label['country'] = "" . $this->Ini->Nm_lang['lang_customers_fild_country'] . "";
      $this->New_label['regionid'] = "" . $this->Ini->Nm_lang['lang_customers_fild_regionid'] . "";
      $this->New_label['stateid'] = "" . $this->Ini->Nm_lang['lang_customers_fild_stateid'] . "";
      $this->New_label['city'] = "" . $this->Ini->Nm_lang['lang_customers_fild_city'] . "";
      $this->New_label['address'] = "" . $this->Ini->Nm_lang['lang_customers_fild_address'] . "";
      $this->New_label['postalcode'] = "" . $this->Ini->Nm_lang['lang_customers_fild_postalcode'] . "";
      $this->New_label['phone'] = "" . $this->Ini->Nm_lang['lang_customers_fild_phone'] . "";
      $this->New_label['fax'] = "" . $this->Ini->Nm_lang['lang_customers_fild_fax'] . "";
      $this->New_label['cityid'] = "" . $this->Ini->Nm_lang['lang_customers_fild_cityid'] . "";
      $this->New_label['creditlimit'] = "" . $this->Ini->Nm_lang['lang_customers_fild_creditlimit'] . "";
      $this->New_label['cardtype'] = "" . $this->Ini->Nm_lang['lang_customers_fild_cardtype'] . "";
      $this->New_label['cardnumber'] = "" . $this->Ini->Nm_lang['lang_customers_fild_cardnumber'] . "";
      $this->New_label['notes'] = "" . $this->Ini->Nm_lang['lang_customers_fild_notes'] . "";
      if (isset($_SESSION['scriptcase']['sc_apl_conf']['sc96_save_grid']['field_display']) && !empty($_SESSION['scriptcase']['sc_apl_conf']['sc96_save_grid']['field_display']))
      {
          foreach ($_SESSION['scriptcase']['sc_apl_conf']['sc96_save_grid']['field_display'] as $NM_cada_field => $NM_cada_opc)
          {
              $this->NM_cmp_hidden[$NM_cada_field] = $NM_cada_opc;
          }
      }
      if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['usr_cmp_sel']) && !empty($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['usr_cmp_sel']))
      {
          foreach ($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['usr_cmp_sel'] as $NM_cada_field => $NM_cada_opc)
          {
              $this->NM_cmp_hidden[$NM_cada_field] = $NM_cada_opc;
          }
      }
      if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['php_cmp_sel']) && !empty($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['php_cmp_sel']))
      {
          foreach ($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['php_cmp_sel'] as $NM_cada_field => $NM_cada_opc)
          {
              $this->NM_cmp_hidden[$NM_cada_field] = $NM_cada_opc;
          }
      }
      $this->sc_where_orig   = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_orig'];
      $this->sc_where_atual  = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_pesq'];
      $this->sc_where_filtro = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_pesq_filtro'];
      if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['campos_busca']) && !empty($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['campos_busca']))
      { 
          $Busca_temp = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['campos_busca'];
          if ($_SESSION['scriptcase']['charset'] != "UTF-8")
          {
              $Busca_temp = NM_conv_charset($Busca_temp, $_SESSION['scriptcase']['charset'], "UTF-8");
          }
          $this->customerid = $Busca_temp['customerid']; 
          $tmp_pos = strpos($this->customerid, "##@@");
          if ($tmp_pos !== false && !is_array($this->customerid))
          {
              $this->customerid = substr($this->customerid, 0, $tmp_pos);
          }
          $this->companyname = $Busca_temp['companyname']; 
          $tmp_pos = strpos($this->companyname, "##@@");
          if ($tmp_pos !== false && !is_array($this->companyname))
          {
              $this->companyname = substr($this->companyname, 0, $tmp_pos);
          }
          $this->contactname = $Busca_temp['contactname']; 
          $tmp_pos = strpos($this->contactname, "##@@");
          if ($tmp_pos !== false && !is_array($this->contactname))
          {
              $this->contactname = substr($this->contactname, 0, $tmp_pos);
          }
          $this->contacttitle = $Busca_temp['contacttitle']; 
          $tmp_pos = strpos($this->contacttitle, "##@@");
          if ($tmp_pos !== false && !is_array($this->contacttitle))
          {
              $this->contacttitle = substr($this->contacttitle, 0, $tmp_pos);
          }
      } 
      $this->nm_where_dinamico = "";
      $_SESSION['scriptcase']['sc96_save_grid']['contr_erro'] = 'on';
  $this->scWeb();
$_SESSION['scriptcase']['sc96_save_grid']['contr_erro'] = 'off'; 
      if  (!empty($this->nm_where_dinamico)) 
      {   
          $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_pesq'] .= $this->nm_where_dinamico;
      }   
      if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_name']))
      {
          $Pos = strrpos($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_name'], ".");
          if ($Pos === false) {
              $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_name'] .= ".rtf";
          }
          $this->Arquivo = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_name'];
          $this->Tit_doc = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_name'];
          unset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_name']);
      }
      $this->arr_export = array('label' => array(), 'lines' => array());
      $this->arr_span   = array();

      $this->Texto_tag .= "<table>\r\n";
      $this->Texto_tag .= "<tr>\r\n";
      foreach ($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['field_order'] as $Cada_col)
      { 
          $SC_Label = (isset($this->New_label['customerid'])) ? $this->New_label['customerid'] : ""; 
          if ($Cada_col == "customerid" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['companyname'])) ? $this->New_label['companyname'] : ""; 
          if ($Cada_col == "companyname" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['contactname'])) ? $this->New_label['contactname'] : ""; 
          if ($Cada_col == "contactname" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['contacttitle'])) ? $this->New_label['contacttitle'] : ""; 
          if ($Cada_col == "contacttitle" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['birthdate'])) ? $this->New_label['birthdate'] : ""; 
          if ($Cada_col == "birthdate" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['country'])) ? $this->New_label['country'] : ""; 
          if ($Cada_col == "country" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['regionid'])) ? $this->New_label['regionid'] : ""; 
          if ($Cada_col == "regionid" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['stateid'])) ? $this->New_label['stateid'] : ""; 
          if ($Cada_col == "stateid" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['city'])) ? $this->New_label['city'] : ""; 
          if ($Cada_col == "city" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['address'])) ? $this->New_label['address'] : ""; 
          if ($Cada_col == "address" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['postalcode'])) ? $this->New_label['postalcode'] : ""; 
          if ($Cada_col == "postalcode" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['phone'])) ? $this->New_label['phone'] : ""; 
          if ($Cada_col == "phone" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['fax'])) ? $this->New_label['fax'] : ""; 
          if ($Cada_col == "fax" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['cityid'])) ? $this->New_label['cityid'] : ""; 
          if ($Cada_col == "cityid" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['creditlimit'])) ? $this->New_label['creditlimit'] : ""; 
          if ($Cada_col == "creditlimit" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['cardtype'])) ? $this->New_label['cardtype'] : ""; 
          if ($Cada_col == "cardtype" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['cardnumber'])) ? $this->New_label['cardnumber'] : ""; 
          if ($Cada_col == "cardnumber" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
          $SC_Label = (isset($this->New_label['notes'])) ? $this->New_label['notes'] : ""; 
          if ($Cada_col == "notes" && (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off"))
          {
              $SC_Label = NM_charset_to_utf8($SC_Label);
              $SC_Label = str_replace('<', '&lt;', $SC_Label);
              $SC_Label = str_replace('>', '&gt;', $SC_Label);
              $this->Texto_tag .= "<td>" . $SC_Label . "</td>\r\n";
          }
      } 
      $this->Texto_tag .= "</tr>\r\n";
      $this->nm_field_dinamico = array();
      $this->nm_order_dinamico = array();
      $nmgp_select_count = "SELECT count(*) AS countTest from " . $this->Ini->nm_tabela; 
      if (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_sybase))
      { 
          $nmgp_select = "SELECT customerid, companyname, contactname, contacttitle, str_replace (convert(char(10),birthdate,102), '.', '-') + ' ' + convert(char(8),birthdate,20), country, regionid, stateid, city, address, postalcode, phone, fax, cityid, creditlimit, cardtype, cardnumber, notes from " . $this->Ini->nm_tabela; 
      } 
      elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_mysql))
      { 
          $nmgp_select = "SELECT customerid, companyname, contactname, contacttitle, birthdate, country, regionid, stateid, city, address, postalcode, phone, fax, cityid, creditlimit, cardtype, cardnumber, notes from " . $this->Ini->nm_tabela; 
      } 
      elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_mssql))
      { 
       $nmgp_select = "SELECT customerid, companyname, contactname, contacttitle, convert(char(23),birthdate,121), country, regionid, stateid, city, address, postalcode, phone, fax, cityid, creditlimit, cardtype, cardnumber, notes from " . $this->Ini->nm_tabela; 
      } 
      elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_oracle))
      { 
          $nmgp_select = "SELECT customerid, companyname, contactname, contacttitle, birthdate, country, regionid, stateid, city, address, postalcode, phone, fax, cityid, creditlimit, cardtype, cardnumber, notes from " . $this->Ini->nm_tabela; 
      } 
      elseif (in_array(strtolower($this->Ini->nm_tpbanco), $this->Ini->nm_bases_informix))
      { 
          $nmgp_select = "SELECT customerid, companyname, contactname, contacttitle, EXTEND(birthdate, YEAR TO DAY), country, regionid, stateid, city, address, postalcode, phone, fax, cityid, creditlimit, cardtype, cardnumber, notes from " . $this->Ini->nm_tabela; 
      } 
      else 
      { 
          $nmgp_select = "SELECT customerid, companyname, contactname, contacttitle, birthdate, country, regionid, stateid, city, address, postalcode, phone, fax, cityid, creditlimit, cardtype, cardnumber, notes from " . $this->Ini->nm_tabela; 
      } 
      $nmgp_select .= " " . $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_pesq'];
      $nmgp_select_count .= " " . $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_pesq'];
      if (isset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_resumo']) && !empty($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_resumo'])) 
      { 
          if (empty($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_pesq'])) 
          { 
              $nmgp_select .= " where " . $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_resumo']; 
              $nmgp_select_count .= " where " . $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_resumo']; 
          } 
          else
          { 
              $nmgp_select .= " and (" . $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_resumo'] . ")"; 
              $nmgp_select_count .= " and (" . $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['where_resumo'] . ")"; 
          } 
      } 
      $nmgp_order_by = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['order_grid'];
      $nmgp_select .= $nmgp_order_by; 
      if (!empty($this->Ini->nm_col_dinamica)) 
      {
          foreach ($this->Ini->nm_col_dinamica as $nm_cada_col => $nm_nova_col)
          {
              $nmgp_select = str_replace($nm_cada_col, $nm_nova_col, $nmgp_select); 
          }
      }
      $_SESSION['scriptcase']['sc_sql_ult_comando'] = $nmgp_select_count;
      $rt = $this->Db->Execute($nmgp_select_count);
      if ($rt === false && !$rt->EOF && $GLOBALS["NM_ERRO_IBASE"] != 1)
      {
         $this->Erro->mensagem(__FILE__, __LINE__, "banco", $this->Ini->Nm_lang['lang_errm_dber'], $this->Db->ErrorMsg());
         exit;
      }
      $this->count_ger = $rt->fields[0];
      $rt->Close();
      $_SESSION['scriptcase']['sc_sql_ult_comando'] = $nmgp_select;
      $rs = $this->Db->Execute($nmgp_select);
      if ($rs === false && !$rs->EOF && $GLOBALS["NM_ERRO_IBASE"] != 1)
      {
         $this->Erro->mensagem(__FILE__, __LINE__, "banco", $this->Ini->Nm_lang['lang_errm_dber'], $this->Db->ErrorMsg());
         exit;
      }
      $this->SC_seq_register = 0;
      $PB_tot = (isset($this->count_ger) && $this->count_ger > 0) ? "/" . $this->count_ger : "";
      while (!$rs->EOF)
      {
         $this->SC_seq_register++;
         if (!$this->Ini->sc_export_ajax) {
             $Mens_bar = NM_charset_to_utf8($this->Ini->Nm_lang['lang_othr_prcs']);
             $this->pb->setProgressbarMessage($Mens_bar . ": " . $this->SC_seq_register . $PB_tot);
             $this->pb->addSteps(1);
         }
         $this->Texto_tag .= "<tr>\r\n";
         $this->customerid = $rs->fields[0] ;  
         $this->companyname = $rs->fields[1] ;  
         $this->contactname = $rs->fields[2] ;  
         $this->contacttitle = $rs->fields[3] ;  
         $this->birthdate = $rs->fields[4] ;  
         $this->country = $rs->fields[5] ;  
         $this->regionid = $rs->fields[6] ;  
         $this->regionid = (string)$this->regionid;
         $this->stateid = $rs->fields[7] ;  
         $this->city = $rs->fields[8] ;  
         $this->address = $rs->fields[9] ;  
         $this->postalcode = $rs->fields[10] ;  
         $this->phone = $rs->fields[11] ;  
         $this->fax = $rs->fields[12] ;  
         $this->cityid = $rs->fields[13] ;  
         $this->cityid = (string)$this->cityid;
         $this->creditlimit = $rs->fields[14] ;  
         $this->creditlimit =  str_replace(",", ".", $this->creditlimit);
         $this->creditlimit = (string)$this->creditlimit;
         $this->cardtype = $rs->fields[15] ;  
         $this->cardnumber = $rs->fields[16] ;  
         $this->notes = $rs->fields[17] ;  
         //----- lookup - country
         $this->look_country = $this->country; 
         $this->Lookup->lookup_country($this->look_country, $this->country) ; 
         $this->look_country = ($this->look_country == "&nbsp;") ? "" : $this->look_country; 
         //----- lookup - stateid
         $this->look_stateid = $this->stateid; 
         $this->Lookup->lookup_stateid($this->look_stateid, $this->stateid) ; 
         $this->look_stateid = ($this->look_stateid == "&nbsp;") ? "" : $this->look_stateid; 
         $this->sc_proc_grid = true; 
         foreach ($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['field_order'] as $Cada_col)
         { 
            if (!isset($this->NM_cmp_hidden[$Cada_col]) || $this->NM_cmp_hidden[$Cada_col] != "off")
            { 
                $NM_func_exp = "NM_export_" . $Cada_col;
                $this->$NM_func_exp();
            } 
         } 
         $this->Texto_tag .= "</tr>\r\n";
         $rs->MoveNext();
      }
      $this->Texto_tag .= "</table>\r\n";
      if(isset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['export_sel_columns']['field_order']))
      {
          $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['field_order'] = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['export_sel_columns']['field_order'];
          unset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['export_sel_columns']['field_order']);
      }
      if(isset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['export_sel_columns']['usr_cmp_sel']))
      {
          $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['usr_cmp_sel'] = $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['export_sel_columns']['usr_cmp_sel'];
          unset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['export_sel_columns']['usr_cmp_sel']);
      }
      $rs->Close();
   }
   //----- customerid
   function NM_export_customerid()
   {
         $this->customerid = html_entity_decode($this->customerid, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->customerid = strip_tags($this->customerid);
         $this->customerid = NM_charset_to_utf8($this->customerid);
         $this->customerid = str_replace('<', '&lt;', $this->customerid);
         $this->customerid = str_replace('>', '&gt;', $this->customerid);
         $this->Texto_tag .= "<td>" . $this->customerid . "</td>\r\n";
   }
   //----- companyname
   function NM_export_companyname()
   {
         $this->companyname = html_entity_decode($this->companyname, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->companyname = strip_tags($this->companyname);
         $this->companyname = NM_charset_to_utf8($this->companyname);
         $this->companyname = str_replace('<', '&lt;', $this->companyname);
         $this->companyname = str_replace('>', '&gt;', $this->companyname);
         $this->Texto_tag .= "<td>" . $this->companyname . "</td>\r\n";
   }
   //----- contactname
   function NM_export_contactname()
   {
         $this->contactname = html_entity_decode($this->contactname, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->contactname = strip_tags($this->contactname);
         $this->contactname = NM_charset_to_utf8($this->contactname);
         $this->contactname = str_replace('<', '&lt;', $this->contactname);
         $this->contactname = str_replace('>', '&gt;', $this->contactname);
         $this->Texto_tag .= "<td>" . $this->contactname . "</td>\r\n";
   }
   //----- contacttitle
   function NM_export_contacttitle()
   {
         $this->contacttitle = html_entity_decode($this->contacttitle, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->contacttitle = strip_tags($this->contacttitle);
         $this->contacttitle = NM_charset_to_utf8($this->contacttitle);
         $this->contacttitle = str_replace('<', '&lt;', $this->contacttitle);
         $this->contacttitle = str_replace('>', '&gt;', $this->contacttitle);
         $this->Texto_tag .= "<td>" . $this->contacttitle . "</td>\r\n";
   }
   //----- birthdate
   function NM_export_birthdate()
   {
             $conteudo_x =  $this->birthdate;
             nm_conv_limpa_dado($conteudo_x, "YYYY-MM-DD");
             if (is_numeric($conteudo_x) && strlen($conteudo_x) > 0) 
             { 
                 $this->nm_data->SetaData($this->birthdate, "YYYY-MM-DD  ");
                 $this->birthdate = $this->nm_data->FormataSaida($this->nm_data->FormatRegion("DT", "ddmmaaaa"));
             } 
         $this->birthdate = NM_charset_to_utf8($this->birthdate);
         $this->birthdate = str_replace('<', '&lt;', $this->birthdate);
         $this->birthdate = str_replace('>', '&gt;', $this->birthdate);
         $this->Texto_tag .= "<td>" . $this->birthdate . "</td>\r\n";
   }
   //----- country
   function NM_export_country()
   {
         $this->look_country = html_entity_decode($this->look_country, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->look_country = strip_tags($this->look_country);
         $this->look_country = NM_charset_to_utf8($this->look_country);
         $this->look_country = str_replace('<', '&lt;', $this->look_country);
         $this->look_country = str_replace('>', '&gt;', $this->look_country);
         $this->Texto_tag .= "<td>" . $this->look_country . "</td>\r\n";
   }
   //----- regionid
   function NM_export_regionid()
   {
             nmgp_Form_Num_Val($this->regionid, $_SESSION['scriptcase']['reg_conf']['grup_num'], $_SESSION['scriptcase']['reg_conf']['dec_num'], "0", "S", "2", "", "N:" . $_SESSION['scriptcase']['reg_conf']['neg_num'] , $_SESSION['scriptcase']['reg_conf']['simb_neg'], $_SESSION['scriptcase']['reg_conf']['num_group_digit']) ; 
         $this->regionid = NM_charset_to_utf8($this->regionid);
         $this->regionid = str_replace('<', '&lt;', $this->regionid);
         $this->regionid = str_replace('>', '&gt;', $this->regionid);
         $this->Texto_tag .= "<td>" . $this->regionid . "</td>\r\n";
   }
   //----- stateid
   function NM_export_stateid()
   {
         $this->look_stateid = html_entity_decode($this->look_stateid, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->look_stateid = strip_tags($this->look_stateid);
         $this->look_stateid = NM_charset_to_utf8($this->look_stateid);
         $this->look_stateid = str_replace('<', '&lt;', $this->look_stateid);
         $this->look_stateid = str_replace('>', '&gt;', $this->look_stateid);
         $this->Texto_tag .= "<td>" . $this->look_stateid . "</td>\r\n";
   }
   //----- city
   function NM_export_city()
   {
         $this->city = html_entity_decode($this->city, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->city = strip_tags($this->city);
         $this->city = NM_charset_to_utf8($this->city);
         $this->city = str_replace('<', '&lt;', $this->city);
         $this->city = str_replace('>', '&gt;', $this->city);
         $this->Texto_tag .= "<td>" . $this->city . "</td>\r\n";
   }
   //----- address
   function NM_export_address()
   {
         $this->address = html_entity_decode($this->address, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->address = strip_tags($this->address);
         $this->address = NM_charset_to_utf8($this->address);
         $this->address = str_replace('<', '&lt;', $this->address);
         $this->address = str_replace('>', '&gt;', $this->address);
         $this->Texto_tag .= "<td>" . $this->address . "</td>\r\n";
   }
   //----- postalcode
   function NM_export_postalcode()
   {
         $this->postalcode = html_entity_decode($this->postalcode, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->postalcode = strip_tags($this->postalcode);
         $this->postalcode = NM_charset_to_utf8($this->postalcode);
         $this->postalcode = str_replace('<', '&lt;', $this->postalcode);
         $this->postalcode = str_replace('>', '&gt;', $this->postalcode);
         $this->Texto_tag .= "<td>" . $this->postalcode . "</td>\r\n";
   }
   //----- phone
   function NM_export_phone()
   {
         $this->phone = html_entity_decode($this->phone, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->phone = strip_tags($this->phone);
         $this->phone = NM_charset_to_utf8($this->phone);
         $this->phone = str_replace('<', '&lt;', $this->phone);
         $this->phone = str_replace('>', '&gt;', $this->phone);
         $this->Texto_tag .= "<td>" . $this->phone . "</td>\r\n";
   }
   //----- fax
   function NM_export_fax()
   {
         $this->fax = html_entity_decode($this->fax, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->fax = strip_tags($this->fax);
         $this->fax = NM_charset_to_utf8($this->fax);
         $this->fax = str_replace('<', '&lt;', $this->fax);
         $this->fax = str_replace('>', '&gt;', $this->fax);
         $this->Texto_tag .= "<td>" . $this->fax . "</td>\r\n";
   }
   //----- cityid
   function NM_export_cityid()
   {
             nmgp_Form_Num_Val($this->cityid, $_SESSION['scriptcase']['reg_conf']['grup_num'], $_SESSION['scriptcase']['reg_conf']['dec_num'], "0", "S", "2", "", "N:" . $_SESSION['scriptcase']['reg_conf']['neg_num'] , $_SESSION['scriptcase']['reg_conf']['simb_neg'], $_SESSION['scriptcase']['reg_conf']['num_group_digit']) ; 
         $this->cityid = NM_charset_to_utf8($this->cityid);
         $this->cityid = str_replace('<', '&lt;', $this->cityid);
         $this->cityid = str_replace('>', '&gt;', $this->cityid);
         $this->Texto_tag .= "<td>" . $this->cityid . "</td>\r\n";
   }
   //----- creditlimit
   function NM_export_creditlimit()
   {
             nmgp_Form_Num_Val($this->creditlimit, $_SESSION['scriptcase']['reg_conf']['grup_val'], $_SESSION['scriptcase']['reg_conf']['dec_val'], "2", "S", "2", "", "V:" . $_SESSION['scriptcase']['reg_conf']['monet_f_pos'] . ":" . $_SESSION['scriptcase']['reg_conf']['monet_f_neg'], $_SESSION['scriptcase']['reg_conf']['simb_neg'], $_SESSION['scriptcase']['reg_conf']['unid_mont_group_digit']) ; 
         $this->creditlimit = NM_charset_to_utf8($this->creditlimit);
         $this->creditlimit = str_replace('<', '&lt;', $this->creditlimit);
         $this->creditlimit = str_replace('>', '&gt;', $this->creditlimit);
         $this->Texto_tag .= "<td>" . $this->creditlimit . "</td>\r\n";
   }
   //----- cardtype
   function NM_export_cardtype()
   {
         $this->cardtype = html_entity_decode($this->cardtype, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->cardtype = strip_tags($this->cardtype);
         $this->cardtype = NM_charset_to_utf8($this->cardtype);
         $this->cardtype = str_replace('<', '&lt;', $this->cardtype);
         $this->cardtype = str_replace('>', '&gt;', $this->cardtype);
         $this->Texto_tag .= "<td>" . $this->cardtype . "</td>\r\n";
   }
   //----- cardnumber
   function NM_export_cardnumber()
   {
         $this->cardnumber = html_entity_decode($this->cardnumber, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->cardnumber = strip_tags($this->cardnumber);
         $this->cardnumber = NM_charset_to_utf8($this->cardnumber);
         $this->cardnumber = str_replace('<', '&lt;', $this->cardnumber);
         $this->cardnumber = str_replace('>', '&gt;', $this->cardnumber);
         $this->Texto_tag .= "<td>" . $this->cardnumber . "</td>\r\n";
   }
   //----- notes
   function NM_export_notes()
   {
         $this->notes = html_entity_decode($this->notes, ENT_COMPAT, $_SESSION['scriptcase']['charset']);
         $this->notes = strip_tags($this->notes);
         $this->notes = NM_charset_to_utf8($this->notes);
         $this->notes = str_replace('<', '&lt;', $this->notes);
         $this->notes = str_replace('>', '&gt;', $this->notes);
         $this->Texto_tag .= "<td>" . $this->notes . "</td>\r\n";
   }

   //----- 
   function grava_arquivo_rtf()
   {
      global $nm_lang, $doc_wrap;
      $this->Rtf_f = $this->Ini->root . $this->Ini->path_imag_temp . "/" . $this->Arquivo;
      $rtf_f       = fopen($this->Ini->root . $this->Ini->path_imag_temp . "/" . $this->Arquivo, "w");
      require_once($this->Ini->path_third      . "/rtf_new/document_generator/cl_xml2driver.php"); 
      $text_ok  =  "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\r\n"; 
      $text_ok .=  "<DOC config_file=\"" . $this->Ini->path_third . "/rtf_new/doc_config.inc\" >\r\n"; 
      $text_ok .=  $this->Texto_tag; 
      $text_ok .=  "</DOC>\r\n"; 
      $xml = new nDOCGEN($text_ok,"RTF"); 
      fwrite($rtf_f, $xml->get_result_file());
      fclose($rtf_f);
   }

   function nm_conv_data_db($dt_in, $form_in, $form_out)
   {
       $dt_out = $dt_in;
       if (strtoupper($form_in) == "DB_FORMAT") {
           if ($dt_out == "null" || $dt_out == "")
           {
               $dt_out = "";
               return $dt_out;
           }
           $form_in = "AAAA-MM-DD";
       }
       if (strtoupper($form_out) == "DB_FORMAT") {
           if (empty($dt_out))
           {
               $dt_out = "null";
               return $dt_out;
           }
           $form_out = "AAAA-MM-DD";
       }
       if (strtoupper($form_out) == "SC_FORMAT_REGION") {
           $this->nm_data->SetaData($dt_in, strtoupper($form_in));
           $prep_out  = (strpos(strtolower($form_in), "dd") !== false) ? "dd" : "";
           $prep_out .= (strpos(strtolower($form_in), "mm") !== false) ? "mm" : "";
           $prep_out .= (strpos(strtolower($form_in), "aa") !== false) ? "aaaa" : "";
           $prep_out .= (strpos(strtolower($form_in), "yy") !== false) ? "aaaa" : "";
           return $this->nm_data->FormataSaida($this->nm_data->FormatRegion("DT", $prep_out));
       }
       else {
           nm_conv_form_data($dt_out, $form_in, $form_out);
           return $dt_out;
       }
   }
   function progress_bar_end()
   {
      unset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_file']);
      if (is_file($this->Ini->root . $this->Ini->path_imag_temp . "/" . $this->Arquivo))
      {
          $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_file'] = $this->Ini->root . $this->Ini->path_imag_temp . "/" . $this->Arquivo;
      }
      $path_doc_md5 = md5($this->Ini->path_imag_temp . "/" . $this->Arquivo);
      $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid'][$path_doc_md5][0] = $this->Ini->path_imag_temp . "/" . $this->Arquivo;
      $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid'][$path_doc_md5][1] = $this->Tit_doc;
      $Mens_bar = $this->Ini->Nm_lang['lang_othr_file_msge'];
      if ($_SESSION['scriptcase']['charset'] != "UTF-8") {
          $Mens_bar = sc_convert_encoding($Mens_bar, "UTF-8", $_SESSION['scriptcase']['charset']);
      }
      $this->pb->setProgressbarMessage($Mens_bar);
      $this->pb->setDownloadLink($this->Ini->path_imag_temp . "/" . $this->Arquivo);
      $this->pb->setDownloadMd5($path_doc_md5);
      $this->pb->completed();
   }
   //---- 
   function monta_html()
   {
      global $nm_url_saida, $nm_lang;
      include($this->Ini->path_btn . $this->Ini->Str_btn_grid);
      unset($_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_file']);
      if (is_file($this->Ini->root . $this->Ini->path_imag_temp . "/" . $this->Arquivo))
      {
          $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['rtf_file'] = $this->Ini->root . $this->Ini->path_imag_temp . "/" . $this->Arquivo;
      }
      $path_doc_md5 = md5($this->Ini->path_imag_temp . "/" . $this->Arquivo);
      $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid'][$path_doc_md5][0] = $this->Ini->path_imag_temp . "/" . $this->Arquivo;
      $_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid'][$path_doc_md5][1] = $this->Tit_doc;
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd">
<HTML<?php echo $_SESSION['scriptcase']['reg_conf']['html_dir'] ?>>
<HEAD>
 <TITLE><?php echo $this->Ini->Nm_lang['lang_sc96_save_grid'] ?> :: RTF</TITLE>
 <META http-equiv="Content-Type" content="text/html; charset=<?php echo $_SESSION['scriptcase']['charset_html'] ?>" />
<?php
if ($_SESSION['scriptcase']['proc_mobile'])
{
?>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0" />
<?php
}
?>
  <META http-equiv="Expires" content="Fri, Jan 01 1900 00:00:00 GMT"/>
  <META http-equiv="Last-Modified" content="<?php echo gmdate("D, d M Y H:i:s"); ?> GMT"/>
  <META http-equiv="Cache-Control" content="no-store, no-cache, must-revalidate"/>
  <META http-equiv="Cache-Control" content="post-check=0, pre-check=0"/>
  <META http-equiv="Pragma" content="no-cache"/>
 <link rel="shortcut icon" href="../_lib/img/scriptcase__NM__ico__NM__favicon.ico">
  <link rel="stylesheet" type="text/css" href="../_lib/css/<?php echo $this->Ini->str_schema_all ?>_export.css" /> 
  <link rel="stylesheet" type="text/css" href="../_lib/css/<?php echo $this->Ini->str_schema_all ?>_export<?php echo $_SESSION['scriptcase']['reg_conf']['css_dir'] ?>.css" /> 
 <?php
 if(isset($this->Ini->str_google_fonts) && !empty($this->Ini->str_google_fonts))
 {
 ?>
    <link rel="stylesheet" type="text/css" href="<?php echo $this->Ini->str_google_fonts ?>" />
 <?php
 }
 ?>
  <link rel="stylesheet" type="text/css" href="../_lib/buttons/<?php echo $this->Ini->Str_btn_css ?>" /> 
</HEAD>
<BODY class="scExportPage">
<?php echo $this->Ini->Ajax_result_set ?>
<table style="border-collapse: collapse; border-width: 0; height: 100%; width: 100%"><tr><td style="padding: 0; text-align: center; vertical-align: middle">
 <table class="scExportTable" align="center">
  <tr>
   <td class="scExportTitle" style="height: 25px">RTF</td>
  </tr>
  <tr>
   <td class="scExportLine" style="width: 100%">
    <table style="border-collapse: collapse; border-width: 0; width: 100%"><tr><td class="scExportLineFont" style="padding: 3px 0 0 0" id="idMessage">
    <?php echo $this->Ini->Nm_lang['lang_othr_file_msge'] ?>
    </td><td class="scExportLineFont" style="text-align:right; padding: 3px 0 0 0">
     <?php echo nmButtonOutput($this->arr_buttons, "bexportview", "document.Fview.submit()", "document.Fview.submit()", "idBtnView", "", "", "", "", "", "", $this->Ini->path_botoes, "", "", "", "", "", "only_text", "text_right", "", "", "", "", "", "", "");
 ?>
     <?php echo nmButtonOutput($this->arr_buttons, "bdownload", "document.Fdown.submit()", "document.Fdown.submit()", "idBtnDown", "", "", "", "", "", "", $this->Ini->path_botoes, "", "", "", "", "", "only_text", "text_right", "", "", "", "", "", "", "");
 ?>
     <?php echo nmButtonOutput($this->arr_buttons, "bvoltar", "document.F0.submit()", "document.F0.submit()", "idBtnBack", "", "", "", "", "", "", $this->Ini->path_botoes, "", "", "", "", "", "only_text", "text_right", "", "", "", "", "", "", "");
 ?>
    </td></tr></table>
   </td>
  </tr>
 </table>
</td></tr></table>
<form name="Fview" method="get" action="<?php echo $this->Ini->path_imag_temp . "/" . $this->Arquivo ?>" target="_blank" style="display: none"> 
</form>
<form name="Fdown" method="get" action="sc96_save_grid_download.php" target="_blank" style="display: none"> 
<input type="hidden" name="script_case_init" value="<?php echo NM_encode_input($this->Ini->sc_page); ?>"> 
<input type="hidden" name="nm_tit_doc" value="sc96_save_grid"> 
<input type="hidden" name="nm_name_doc" value="<?php echo $path_doc_md5 ?>"> 
</form>
<FORM name="F0" method=post action="./"> 
<INPUT type="hidden" name="script_case_init" value="<?php echo NM_encode_input($this->Ini->sc_page); ?>"> 
<INPUT type="hidden" name="nmgp_opcao" value="volta_grid"> 
</FORM> 
</BODY>
</HTML>
<?php
   }
   function nm_gera_mask(&$nm_campo, $nm_mask)
   { 
      $trab_campo = $nm_campo;
      $trab_mask  = $nm_mask;
      $tam_campo  = strlen($nm_campo);
      $trab_saida = "";
      $str_highlight_ini = "";
      $str_highlight_fim = "";
      if(substr($nm_campo, 0, 23) == '<div class="highlight">' && substr($nm_campo, -6) == '</div>')
      {
           $str_highlight_ini = substr($nm_campo, 0, 23);
           $str_highlight_fim = substr($nm_campo, -6);

           $trab_campo = substr($nm_campo, 23, -6);
           $tam_campo  = strlen($trab_campo);
      }      $mask_num = false;
      for ($x=0; $x < strlen($trab_mask); $x++)
      {
          if (substr($trab_mask, $x, 1) == "#")
          {
              $mask_num = true;
              break;
          }
      }
      if ($mask_num )
      {
          $ver_duas = explode(";", $trab_mask);
          if (isset($ver_duas[1]) && !empty($ver_duas[1]))
          {
              $cont1 = count(explode("#", $ver_duas[0])) - 1;
              $cont2 = count(explode("#", $ver_duas[1])) - 1;
              if ($cont2 >= $tam_campo)
              {
                  $trab_mask = $ver_duas[1];
              }
              else
              {
                  $trab_mask = $ver_duas[0];
              }
          }
          $tam_mask = strlen($trab_mask);
          $xdados = 0;
          for ($x=0; $x < $tam_mask; $x++)
          {
              if (substr($trab_mask, $x, 1) == "#" && $xdados < $tam_campo)
              {
                  $trab_saida .= substr($trab_campo, $xdados, 1);
                  $xdados++;
              }
              elseif ($xdados < $tam_campo)
              {
                  $trab_saida .= substr($trab_mask, $x, 1);
              }
          }
          if ($xdados < $tam_campo)
          {
              $trab_saida .= substr($trab_campo, $xdados);
          }
          $nm_campo = $str_highlight_ini . $trab_saida . $str_highlight_ini;
          return;
      }
      for ($ix = strlen($trab_mask); $ix > 0; $ix--)
      {
           $char_mask = substr($trab_mask, $ix - 1, 1);
           if ($char_mask != "x" && $char_mask != "z")
           {
               $trab_saida = $char_mask . $trab_saida;
           }
           else
           {
               if ($tam_campo != 0)
               {
                   $trab_saida = substr($trab_campo, $tam_campo - 1, 1) . $trab_saida;
                   $tam_campo--;
               }
               else
               {
                   $trab_saida = "0" . $trab_saida;
               }
           }
      }
      if ($tam_campo != 0)
      {
          $trab_saida = substr($trab_campo, 0, $tam_campo) . $trab_saida;
          $trab_mask  = str_repeat("z", $tam_campo) . $trab_mask;
      }
   
      $iz = 0; 
      for ($ix = 0; $ix < strlen($trab_mask); $ix++)
      {
           $char_mask = substr($trab_mask, $ix, 1);
           if ($char_mask != "x" && $char_mask != "z")
           {
               if ($char_mask == "." || $char_mask == ",")
               {
                   $trab_saida = substr($trab_saida, 0, $iz) . substr($trab_saida, $iz + 1);
               }
               else
               {
                   $iz++;
               }
           }
           elseif ($char_mask == "x" || substr($trab_saida, $iz, 1) != "0")
           {
               $ix = strlen($trab_mask) + 1;
           }
           else
           {
               $trab_saida = substr($trab_saida, 0, $iz) . substr($trab_saida, $iz + 1);
           }
      }
      $nm_campo = $str_highlight_ini . $trab_saida . $str_highlight_ini;
   } 
function scWeb()
{
$_SESSION['scriptcase']['sc96_save_grid']['contr_erro'] = 'on';
  
	if (
    isset($_GET['site_iframe']) && !empty($_GET['site_iframe']) && $_GET['site_iframe'] == 'Y' && 
    (!isset($_SESSION['scriptcase']['device_mobile']) || !$_SESSION['scriptcase']['device_mobile'] || !$_SESSION['scriptcase']['display_mobile'])
	) {

		$need_reload = 0;

		if (isset($_GET['str_schema_all']) && $_GET['str_schema_all'] != '') {
			$set_theme = urldecode($_GET['str_schema_all']);

			if (trim($set_theme) != "") {
				if (strpos($set_theme, '/') !== false) {
					$explode_name = explode("/", $set_theme);
					$explode_name = array_filter($explode_name);
					$set_theme = $explode_name[0] != "" ? $explode_name[0] :
						isset($explode_name[1]) && $explode_name[1] != "" ?
							$explode_name[1] : "";
				}

				$actual_theme = $this->Ini->sc_get_schema();
				
				if ($actual_theme != $set_theme && trim("Sc9_" . $actual_theme) != $set_theme) {
					$this->Ini->sc_set_schema($set_theme);;
					$need_reload = 1;
				}
			}
		}

		if (
			isset($_GET['str_lang']) && trim($_GET['str_lang']) != '' &&
			isset($_GET['str_conf_reg']) && trim($_GET['str_conf_reg']) != '' &&
			isset($_GET['change_lang']) && trim($_GET['change_lang']) != ''
		) {
			$new_lang = trim(urldecode($_GET['str_lang']));
			$actual_language = trim($this->Ini->sc_get_language());
			$new_conf_lang = trim(urldecode($_GET['str_conf_reg']));
			$arr_lang_list = [
								'pt_br','en_us','fr','it','es',
								'de','ru','zh_cn','zh_hk','ja',
								'bg','cz','da','fi','nl','no',
								'pl','sv','tr','ar','uk','ko',
								'hr','sl','sk','sr','hu','id',
								'el','be','bs','et','ro','lt',
								'lv','hi','he','mk'
							 ];

			if (in_array($new_lang, $arr_lang_list) && trim($_GET['change_lang']) == true && $actual_language != $new_lang) {
				$language_and_configuration = $new_lang . ";" . $new_conf_lang;
				$this->Ini->sc_change_language($language_and_configuration);
include($this->Ini->path_btn . $this->Ini->Str_btn_grid);
				$need_reload = 1;
			}
		}

		if ($need_reload == 1 && isset($_GET['reload_first']) && trim($_GET['reload_first']) === 'ok') {
			unset($_GET['reload_first']);
			$url_nova = './?' . http_build_query($_GET);

			if (!headers_sent()) {
				header("Refresh: 0; url=" . $url_nova);
				exit;

			} else { 
				?>
				<script type="text/javascript">
					setTimeout(function(){
						window.location.href="<?php echo $url_nova; ?>";
					}, 5000);
				</script>
			<?php }

		}

		?>
		<script type="text/javascript">
			window.addEventListener("message", receiveMessage, false);

			var parentMessageEvent;

			function receiveMessage(event) {
				appendToLog('Received postMessage.');
				appendToLog('Origin: ' + event.origin);

				if (event.origin !== 'https://www.scriptcase.com.br'
					&& event.origin !== 'https://scriptcase.com.br'
					&& event.origin !== 'http://localhost') {
					return;
				}

				var object = JSON.parse(event.data);
				appendToLog('Event: ' + object.event);
				appendToLog('Message: ' + object.message);

				parentMessageEvent = event;
				sendResizeToParentWindow();
			}

			function appendToLog(message) {
				console.log('Log: ' + message + '.');
			}

			function sendResizeToParentWindow() {
				if (parentMessageEvent != undefined) {
					parentMessageEvent.source.postMessage(JSON.stringify({
						event: 'resize',
						height: $(document).height()
					}), parentMessageEvent.origin);
				}
			};

			window.addEventListener('resize', sendResizeToParentWindow, false);
		</script>
		<?php

		$appname = trim($this->Ini->nm_cod_apl);

		$apptype = explode("\n",file_get_contents($appname . "_ini.txt"));
		$apptype = trim($apptype[4]);

		switch($apptype)
		{
			case "form":
			?>
				<style type="text/css">
					.scFormPage{margin:0px!important;}
					.scFormHeader{display:none;}
					.scFormObjectOddMult,.scFormObjectFocusOddMult{width:83%!important;}
					#main_table_form{}
				</style>
			<?php
			break;
			case "cons":
			?>
				<style type="text/css">
					.scGridPage{margin:0px!important;}
					.scGridHeader,.scFilterHeader{display:none !important;}
					#summary_body > td,#sc_grid_body{padding:0px!important;}
					table#main_table_grid,table#main_table_res{}
					#res_chart_table{}
				</style>
			<?php
			break;
			case "contr":
			?>
				<style type="text/css">
					.scFormHeader{display:none;}
				</style>
			<?php
			break;
			case "reportpdf":
			?>
				<style type="text/css">
					.scFilterHeader{display:none;}
				</style>
			<?php
			break;
			case "calendar":
			?>
				<style type="text/css">
					.scFormPage{margin:0px!important;}
					.scFormHeader{display:none;}
					.scFormObjectOddMult,.scFormObjectFocusOddMult{width:83%!important;}
					#main_table_form{width:100%!important;}
				</style>
			<?php
			break;
		}


		switch($appname)
		{
			case "form_64":
			?>
				<style type="text/css">
					.scFormObjectOddMult,.scFormObjectFocusOddMult{width:68%!important;}
				</style>
			<?php
			break;
			case "form39":
			?>
				<style type="text/css">
					.scFormObjectOddMult,.scFormObjectFocusOddMult{width:68%!important;}
				</style>
			<?php
			break;
			
			case "form57_1":
			?>
				<style type="text/css">
					.scFormBorder{border-width:0px !important;}
					#hidden_bloco_0{width:100%!important;margin:0px!important;border-width:0px!important;}
				</style>
			<?php
			break;
			case "form57":
			
			
			$this->NM_cmp_hidden["country"] = "off";if (!isset($this->NM_ajax_event) || !$this->NM_ajax_event) {$_SESSION['sc_session'][$this->Ini->sc_page]['sc96_save_grid']['php_cmp_sel']["country"] = "off"; }
			?>
				<style type="text/css">
					#sc_b_alt_top{display:inline-block !important;}
				</style>
			<?php
			break;
			case "form54":
			?>
				<style type="text/css">
					#id_lookup_customerid,#id_ajax_label_customerid2{color:#6082C5!important;font-weight:bold!important;}
					#id_read_off_customerid{display:block!important;}
				</style>
			<?php
			break;
			case "form38":
			?>
				<style type="text/css">
					#hidden_field_data_info{display:none!important;}
					#hidden_bloco_2{border-width:0px!important;}
				</style>
			<?php
			break;
			case "form_single_2_single":
			?>
				<style type="text/css">
					#hidden_bloco_2{border-width:0px!important;}
				</style>
			<?php
			break;
			case "form_single_2_single_detail":
			?>
				<style type="text/css">
					#hidden_bloco_0{width:100%!important;margin:0px!important;border-width:0px!important;}
				</style>
			<?php
			break;
			case "ctr_5":
			?>
				<style type="text/css">
					.scFormPageText{font-weight:bold!important;}
				</style>
			<?php
			break;			
			case "form55":
			?>
				<style type="text/css">
					#sc_b_alt_top{display:inline-block!important;}
				</style>
			<?php
			break;
			case "form55_1":
			?>
				<style type="text/css">
					#hidden_bloco_0{width:100%!important;margin:0px!important;}
				</style>
			<?php
			break;
			case "grid52":
			?>
				<style type="text/css">
					#id_sc_field_map_1 iframe{margin-left:calc(50% - 350px)!important;}
				</style>
			<?php
			break;			
			case "grid50":
			?>
				<style type="text/css">
					#id_sc_field_video_1 object{margin-left:calc(50% - 400px)!important;}
				</style>
			<?php
			break;
			case "grid_refined_search":
			?>
				<style type="text/css">
					.scGridRefinedSearchPadding{width:300px!important;}
				</style>
			<?php
			break;
			case "tab03_1":
			?>
				<style type="text/css">
					.css_notes_label{vertical-align:top!important;}
				</style>
			<?php
			break;
			case "tab03_2":
			?>
				<style type="text/css">
					.scGridPage{overflow:hidden!important;}
				</style>
			<?php
			break;
			case "sample_chart":
			?>
				<style type="text/css">
					.scGridPage{overflow:hidden!important;}
					.scGridBorder{border-width:0px!important;}
				</style>
			<?php
			break;
			case "calendar05":
			?>
				<style type="text/css">
					#id_sc_field_id_api{display:none!important;}
				</style>
			<?php
			break;
		}


	}
	return true;
$_SESSION['scriptcase']['sc96_save_grid']['contr_erro'] = 'off';
}
}

?>
